/* Controllers */
summitApp

    //#region Main Controller
    .controller('mainCtrl', [
        '$scope',
        function ($scope) {
            console.log("Controller: mainCtrl");
            $scope.isTouchDevice = !!('ontouchstart' in window);
            $scope.isHighDensity = function () {
                return ((window.matchMedia && (window.matchMedia('only screen and (min-resolution: 124dpi), only screen and (min-resolution: 1.3dppx), only screen and (min-resolution: 48.8dpcm)').matches || window.matchMedia('only screen and (-webkit-min-device-pixel-ratio: 1.3), only screen and (-o-min-device-pixel-ratio: 2.6/2), only screen and (min--moz-device-pixel-ratio: 1.3), only screen and (min-device-pixel-ratio: 1.3)').matches)) || (window.devicePixelRatio && window.devicePixelRatio > 1.3));
            }
        }
    ])
    //#endregion Main Controller

    //#region Login Controller
    .controller('Login', [
        '$scope',
        '$cookieStore',
        '$location',
        '$state',
        '$timeout',
        '$http',
        function ($scope, $cookieStore, $location, $state, $timeout, $http) {
            $scope.$on('$stateChangeSuccess', function () {
            });

            // If the user logged out, mark as logged out.
            $cookieStore.put('authenticated', false);
            $cookieStore.put('authenticatedExpiry', 0)

            // Retreive the SummitName
            //  /api/summit/name
            $scope.GetSummitInfo = function () {
                $http({
                    method: "get",
                    url: "/api/summit/info"
                })
                    .success(function (data) {
                        // Do something with the data
                        $scope.SummitInfo = data;
                    })
            }
            $scope.GetSummitInfo();

            // Get Summit Authentication Configuration (from authentication.json)
            $scope.AuthenticationConfiguration = {};// Set to null
            //#region Get Summit Authentication Configuration
            $scope.GetSummitAuthenticationConfiguration = function () {
                $http({
                    method: "get",
                    url: "/api/login/authconfig"
                })
                    .success(function (data) {
                        $scope.AuthenticationConfiguration = data;
                    })
            }
            $scope.GetSummitAuthenticationConfiguration();
            //#endregion Get Summit Authentication Configuration

            // User name pattern
            //  1. 4-32 characters
            //  2. The following special chars are allowed (0 or more): !@#$%
            //  3. Alphanumeric characters are also allowed
            $scope.UserPattern = /^[0-9a-zA-Z!@#$%\\ ]{4,32}$/;
            // Password pattern
            //  1. 4-32 characters
            //  2. The following special chars are allowed (0 or more): !@#$%
            //  3. Alphanumeric characters are also allowed
            $scope.PasswordPattern = /^[0-9a-zA-Z!@#$% ]{4,32}$/;

            $scope.Credentials = { User: "", Password: "" };
            $scope.LoginStatus = "";
            $scope.ResponseMessage = "";
        
            $scope.LoginAttempt = function (Credentials) {
                $scope.LoginStatus = "Sending";
                $http({
                    method: "put",
                    url: "/api/login",
                    data: Credentials
                })
                    .success(function (data) {
                        //console.log('LoginAttempt data=' + data.LoginPassed);
                        if (data.Result === true) {
                            console.log('Authentication Passed');
                            var currentDate = new Date();
                            var expiry = new Date(currentDate.getTime() + 60 * 60 * 1000);// Expiry is one hour
                            //console.log('Current Time=' + currentDate);
                            //console.log('Expiry Time=' + expiry.valueOf());
                            $cookieStore.put('authenticated', true);
                            $cookieStore.put('authenticatedExpiry', expiry.valueOf())
                            $scope.Credentials.Password = "";
                            $('#IdLoginPassword').val('');
                            $scope.LoginStatus = "Success";
                            $scope.ResponseMessage = data.Message;
                            $state.go('summit.home');
                        } else {
                            console.log('Authentication Failed');
                            $('#IdLoginStatus').html('Authentication Failed');
                            $('#IdLoginPassword').val('');
                            $cookieStore.put('authenticated', false);
                            $cookieStore.put('authenticatedExpiry', 0)
                            $scope.Credentials.Password = "";
                            $scope.LoginStatus = "Failed";
                            $scope.ResponseMessage = data.Message;
                            setTimeout(function () {
                                $('#IdLoginStatus').html('');
                                $scope.LoginStatus = "";
                                $scope.ResponseMessage = "";
                                $state.go('login');
                            }, 2000);
                        }
                    })
            }
        }
    ])
    //#endregion Login Controller

    //#region Side Menu Controller
    .controller('sideMenuCtrl', [
        '$scope',
        '$state',
        '$stateParams',
        '$timeout',
        function ($scope, $state, $stateParams, $timeout) {
            $scope.sections = [
                {
                    id: 0,
                    title: 'System',
                    icon: 'icon_house first_level_icon',
                    link: 'summit.home'
                },
                //{
                //    id: 1,
                //    title: 'System Info',
                //    icon: 'icon_info_alt first_level_icon',
                //    link: 'summit.systemstatus'
                //},
                {
                    id: 2,
                    title: 'Network',
                    icon: 'icon_flowchart_alt first_level_icon',
                    link: 'summit.network'
                },
                {
                    id: 3,
                    title: 'Digital I/O',
                    icon: 'icon_datareport first_level_icon',
                    link: 'summit.digitalio'
                },
                {
                    id: 4,
                    title: 'Analog I/O',
                    icon: 'icon_datareport_alt first_level_icon',
                    link: 'summit.analogio'
                }
                ,
                {
                    id: 5,
                    title: 'Serial I/O',
                    icon: 'arrow_up_alt first_level_icon',
                    link: 'summit.serialports'
                }
                ,
                {
                    id: 6,
                    title: 'Ping Sensors',
                    icon: 'el-icon-signal first_level_icon',
                    link: 'summit.pingsensors'
                }
            ];

            // accordion menu
            $(document).off('click').on('click', '.side_menu_expanded #main_menu .has_submenu > a', function () {
                var $this_parent = $(this).parent('.has_submenu'),
                    panel_active = $this_parent.hasClass('section_active');
                $('#main_menu .has_submenu').removeClass('section_active').children('ul').slideUp('200');
                if (!panel_active) {
                    $this_parent.addClass('section_active').children('ul').slideDown('200');
                }
            });

            $timeout(function () {
                $('#main_menu .has_submenu .act_nav').closest('.has_submenu').children('a').click();
            }, 0);
        }
    ])
    //#endregion Side Menu Controller

    //#region Summit Home Page Controller
    .controller('Summit', [
        '$scope',
        '$modal',
        '$http',
        '$timeout',
        'socketManager',
        function ($scope, $modal, $http, $timeout, socketManager) {
            //#region Summit - General

            //#region Summit - General - Entry
            $scope.$on('$stateChangeSuccess', function () {
                console.log("Controller: Summit");
            });

            // socket.io
            $scope.$on('$destroy', function (event) {
                socketManager.removeAllListeners();
            });
            //#endregion Summit - General - Entry

            // Retreive the list of available network interfaces
            // Retrieve Eth0 MACID
            //  /api/network/interfaces
            //#region GetNetworkInterfaces
            $scope.GetNetworkInterfaces = function () {
                $scope.WaitingForNetworkInfo = true;
                $http({
                    method: "get",
                    url: "/api/network/interfaces"
                })
                    .success(function (data) {
                        //console.log('Get GetNetworkInterfaces success');
                        // Do something with the data
                        $scope.NetworkInterfaces = data;
                        $scope.NumberOfNetworkInterfaces = $scope.NetworkInterfaces.length

                        $scope.Eth0Macid = "Unavailable - Contact Tech Support";
                        for (i = 0; i < data.length; i++) {
                            if (data[i].Name === "eth0") $scope.Eth0Macid = data[i].MACID;
                        }

                        // Adjust the QR Code
                        $('#IdSummitSerialNumberQrcode').css({ 'width': 50, 'height': 50 }).qrcode({
                            render: 'canvas',
                            size: 100,
                            text: "Summit Serial# " + $scope.Eth0Macid
                        }).children('img').prop('title', $scope.Eth0Macid);

                        $scope.WaitingForNetworkInfo = false;
                    })
            }
            $scope.GetNetworkInterfaces();
            //#endregion GetNetworkInterfaces

            // Identify the summit using LED blinks
            //  /api/summit/identify
            //#region IndentifyDevice
            $scope.IdentifyDevice = function () {
                $http({
                    method: "get",
                    url: "/api/summit/identify"
                }).success(function (data) {
                    //console.log('IdentifyDevice success');
                });
                //$event.preventDefault();
            }
            //#endregion IndentifyDevice
            //#endregion Summit - General

            //#region Crest - Operations
            //----------------------------------------------------------
            // Crest operations

            // Get Crest info
            //  /api/crest
            $scope.GetCrestVersion = function () {
                $http({
                    method: "get",
                    url: "/api/crest"
                })
                    .success(function (data) {
                        //console.log('Get GetCrestVersion success');
                        $('#IdCurrentAppInfo').html(data.description + " v" + data.version);
                        $scope.InstalledPackage = data;
                    })
            }
            $scope.GetCrestVersion();

            $scope.GetSystemConfig = function () {
                $http({
                    method: "get",
                    url: "/api/summit/systemconfig"
                })
                    .success(function (data) {
                        //console.log('Get Summit System Config success');
                        $scope.SummitSystemConfig = data;
                    })
            }
            $scope.GetSystemConfig();

            $scope.UpgradeAvailable = true;// Always allow users to Manage versions
            // Retreive the latest Crest version
            //  /api/crest/latest
            $scope.GetLatestVersion = function () {
                $scope.WaitingForLatestVersionInfo = true;
                $timeout(function () {
                    $('#IdLatestVersion').css('color', 'red');
                    $('#IdLatestVersion').html("Retrieving version info from server ... please wait.");
                })
                $http({
                    method: "get",
                    url: "/api/crest/latest"
                })
                    .success(function (version) {
                        console.log('GetLatestVersion result=' + version);
                        $scope.WaitingForLatestVersionInfo = false;

                        if (version.indexOf("Error") == 0) {
                            $timeout(function () {
                                $('#IdLatestVersion').css('color', 'red');
                                $('#IdLatestVersion').html(version);
                                $scope.LatestVersion = version;
                            })
                        } else {
                            $timeout(function () {
                                $('#IdLatestVersion').css('color', 'black');
                                $('#IdLatestVersion').html("Latest Available: " + $scope.InstalledPackage.description + " v" + version);
                                $scope.LatestVersion = version;
                                if ($scope.LatestVersion !== $scope.InstalledPackage.version) {
                                    $scope.UpgradeAvailable = true;
                                }
                            })
                        }
                    })
            }
            $scope.GetLatestVersion();

            $scope.KenwoodRulesArray = [];

            // Retreive array of Kenwood rules
            //  /api/network/kenwood/rules
            $scope.GetKenwoodRules = function () {
                console.log("Inside GetKenwoodRules")
                $http({
                    method: "get",
                    url: "/api/kenwood/rules"
                })
                    .success(function (data) {
                        $scope.KenwoodRulesArray = data;
                        $scope.NumberOfKenwoodRules = data.length;
                    })
            }
            $scope.GetKenwoodRules();
            //#endregion Crest

            //#region Summit - System Information tab
            //----------------------------------------------------------
            // System Information tab

            // System Info, Name, Date/Time, Uptime
            //#region System Info, Name, Date/Time, Uptime
            $scope.GetSummitInfo = function () {
                $http({
                    method: "get",
                    url: "/api/summit/info"
                })
                    .success(function (data) {
                        //console.log('Get GetSummitInfo success');
                        // Do something with the data
                        $scope.SummitInfo = data;
                    })
            }
            $scope.GetSummitInfo();

            // Set Summit Name
            $scope.ManageSummitName = function (SummitInfo) {
                console.log("Inside SetSummitName - Current Summit Name=" + SummitInfo);
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/ManageSummitName.html',
                    controller: function ($scope, $modalInstance) {
                        //#region SetSummitName controller preamble
                        $scope.SummitInfo = SummitInfo;
                        $scope.SummitNamePattern = /^[0-9a-zA-Z!@#$%\\\: ]{4,32}$/
                        //#endregion SetSystemDateTime controller preamble

                        //  Apply the Summit Name
                        //#region Apply set Summit name
                        $scope.apply = function (info) {
                            console.log('Calling /api/summit/info Summit Name=' + info);
                            $http({
                                method: "put",
                                url: "/api/summit/info",
                                data: info
                            })
                                .success(function (data) {
                                    //console.log('Put /api/summit/info success data=' + JSON.stringify(data));
                                    SummitInfo = data;
                                    $modalInstance.dismiss('done');
                                })
                                .error(function (data, status) {
                                    //console.log('Put /api/summit/info error error=' + JSON.stringify(data));
                                })
                        }
                        //#endregion Apply set Summit name

                        //  User canceled operation
                        //#region Cancel set Summit name
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                        //#endregion Cancel set Summit name
                    }
                });
            };

            // Set System Date/Time
            $scope.SetSystemDateTime = function (CurrentSystemTime) {
                console.log("Inside SetSystemDateTime - CurrentSystemTime=" + CurrentSystemTime);
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/SetSystemDateTime.html',
                    controller: function ($scope, $modalInstance) {
                        // Setup the System Date/Time
                        //#region SetSystemDateTime controller preamble
                        $scope.modalTitle = "Set System Date/Time";

                        $scope.SetSystemDate = moment(CurrentSystemTime, 'YYYY-MM-DD HH:mm:ss').format("YYYY-MM-DD");
                        $scope.SetSystemDateFilter = /^((2[0-9]{3})|(19[0-9]{2}))-([0-9]{2})-([0-9]{2})$/;
                        console.log("Date=" + $scope.SetSystemDate);

                        $scope.SetSystemTime = moment(CurrentSystemTime, 'YYYY-MM-DD HH:mm:ss').format("HH:mm");
                        $scope.SetSystemTimeFilter = /^([01]?[0-9]|2[0-3]):[0-5][0-9]$/;
                        console.log("Time=" + $scope.SetSystemTime);

                        //#endregion SetSystemDateTime controller preamble

                        //  Change the system Date/Time
                        //#region Apply Set System Date/Time
                        $scope.ApplySetSystemDateTime = function (date, time) {

                            var SystemDateTime = date + " " + time;
                            console.log('Calling /api/summit/systemdatetime data=' + SystemDateTime);

                            $http({
                                method: "put",
                                url: "/api/summit/systemdatetime",
                                data: { "SystemDateTime": SystemDateTime }
                            })
                                .success(function (data) {
                                    //console.log('Put /api/summit/systemdatetime success data=' + JSON.stringify(data));
                                    $modalInstance.dismiss('done');
                                })
                                .error(function (data, status) {
                                    //console.log('Put /api/summit/systemdatetime error error=' + JSON.stringify(data));
                                })
                        }
                        //#endregion Apply Set System Date/Time

                        //  User canceled operation
                        //#region Cancel Set System Date/Time
                        $scope.CancelSetSystemDateTime = function () {
                            $modalInstance.dismiss('cancel');
                        };
                        //#endregion Cancel Set System Date/Time
                    }
                });
            };

            // Retreive the CrestStartTime
            $scope.CrestStartTime = 0;
            $scope.GetCrestStartTime = function () {
                $http({
                    method: "get",
                    url: "/api/crest/starttime"
                })
                    .success(function (data) {
                        $scope.CrestStartTime = data.CrestStartTime;
                    })
            }
            $scope.GetCrestStartTime();
            //#endregion System Info, Name, Date/Time, Uptime

            // Crest OS Info and Upgrade
            //#region Crest OS Info and Upgrade
            $scope.GetOsInfo = function () {
                $http({
                    method: "get",
                    url: "/api/summit/operatingsystem"
                })
                    .success(function (data) {
                        //console.log('Get GetOsInfo success');
                        $('#IdCurrentOsInfo').html(data.os);
                        $scope.OsVersion = data;
                    })
            }
            $scope.GetOsInfo();

            // Crest Upgrade
            //#region Crest Upgrade
            $scope.CrestUpgrade = function (installedProduct, latestVersion) {
                console.log("Inside GetCrestSoftware")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/GetCrestSoftware.html',
                    scope: $scope,
                    //#region Crest Upgrade - Modal Controller
                    controller: function ($scope, $modalInstance) {
                        // Setup the Get Crest Software modal
                        //#region GetCrestSoftwareUpdate controller preamble
                        $scope.CrestUpgradePercentage = "0%";
                        $scope.CrestUpgradeMethod = "CrestDownload";
                        $scope.CrestUpgradeFile = null;
                        $scope.BeforeUpgradeStarted = true;
                        $scope.UploadFileSelected = false;
                        $scope.LatestVersion = latestVersion;
                        $scope.InstalledProduct = installedProduct;
                        $scope.CrestDownloadUrl = 'http://www.tascsystems.com/downloads/summit/crest-v' + latestVersion + '.tar';
                        $scope.CrestDownloadUrlPattern = /^https?:\/\/(www\.)?[-a-zA-Z0-9@:%._\+~#=]{2,256}\.[a-z]{2,6}\b([-a-zA-Z0-9@:%_\+.~#?&//=]*)?$/;
                        $scope.CrestUpgradeInProgress = false;
                        //#endregion SetNetworkInterface controller preamble

                        //  Upgrade Crest software
                        //#region Upgrade Crest - Apply
                        $scope.ApplyCrestUpgrade = function (CrestUpgradeMethod, CrestDownloadUrl, CrestUpgradeFile) {
                            console.log("ApplyUpgradeCrest: CrestUpgradeMethod='" + CrestUpgradeMethod + "' CrestDownloadUrl='" + CrestDownloadUrl + "' CrestUpgradeFile='" + CrestUpgradeFile + "'");

                            // Initiate the upgrade operation
                            $scope.BeforeUpgradeStarted = false;
                            $scope.CrestUpgradeInProgress = true;
                            $scope.CrestUpgradeError = false;
                            $scope.CrestUpgradeComplete = false;

                            if (CrestUpgradeMethod == "CrestDownload") {
                                //#region Crest Upgrade - download and install

                                $http({
                                    method: "put",
                                    url: "/api/crest/download",
                                    data: { CrestUrl: CrestDownloadUrl }
                                })
                                    .success(function (result) {
                                        console.log('ApplyCrestUpgrade.CrestDownload: "' + CrestDownloadUrl + '" result=' + result);

                                        if (result.indexOf("Error") != 0) {
                                            // Show as downloaded and available on next reboot
                                            setTimeout(function () {
                                                console.log("ApplyCrestUpgrade.Crest Download and Install complete!");
                                                $scope.CrestUpgradeInProgress = false;
                                                $scope.CrestUpgradeComplete = true;
                                                $scope.CrestUpgradeError = false;
                                            }, 30000);
                                        } else {
                                            $scope.CrestUpgradeInProgress = false;
                                            $scope.CrestUpgradeComplete = false;
                                            $scope.CrestUpgradeError = true;
                                        }
                                    })

                                //#endregion Crest Upgrade - download and install
                            } else {
                                //#region Crest Upgrade - upload and install

                                var fd = new FormData();
                                fd.append("CrestUpgradeFile", CrestUpgradeFile);
                                var xhr = new XMLHttpRequest();
                                xhr.upload.addEventListener("progress", uploadProgress, false);
                                xhr.addEventListener("load", uploadComplete, false);
                                xhr.addEventListener("error", uploadFailed, false);
                                xhr.addEventListener("abort", uploadCanceled, false);
                                xhr.open("POST", "/api/crest/upload");
                                xhr.send(fd);

                                function uploadProgress(evt) {
                                    if (evt.lengthComputable) {
                                        $scope.CrestUpgradePercentage = Math.round(evt.loaded * 100 / evt.total) + "%"
                                        $scope.$apply();
                                        console.log("Complete=" + $scope.CrestUpgradePercentage);
                                    }
                                    else {
                                        $scope.CrestUpgradePercentage = "Unknown%";
                                    }
                                }

                                function uploadComplete(evt) {
                                    /* This event is raised when the server send back a response */
                                    //alert(evt.target.responseText);
                                    setTimeout(function () {
                                        console.log("ApplyCrestUpgrade.Crest Upload and Install complete!");
                                        $scope.CrestUpgradeInProgress = false;
                                        $scope.CrestUpgradeComplete = true;
                                        $scope.CrestUpgradeError = false;
                                        $scope.$apply();
                                    }, 30000);
                                }

                                function uploadFailed(evt) {
                                    //alert("There was an error attempting to upload the file.");
                                    console.log("Upload failed/error");
                                    $scope.CrestUpgradeInProgress = false;
                                    $scope.CrestUpgradeComplete = false;
                                    $scope.CrestUpgradeError = true;
                                    $scope.$apply();
                                }

                                function uploadCanceled(evt) {
                                    //alert("The upload has been canceled by the user or the browser dropped the connection.");
                                    console.log("Upload has been canceled by the user or browser dropped connection");
                                    $scope.CrestUpgradeInProgress = false;
                                    $scope.CrestUpgradeComplete = false;
                                    $scope.CrestUpgradeError = true;
                                    $scope.$apply();
                                }
                                //#endregion Crest Upgrade - upload and install
                            }
                        };
                        //#endregion Upgrade Crest - Apply

                        //#region Crest Upgrade - Supporting Methods
                        $scope.CheckFileName = function (element) {
                            $scope.CrestUpgradeFile = element.files[0];
                            $scope.CrestUpgradeMethod = "CrestUploadFile";
                            console.log("CrestUpgradeFile=" + $scope.CrestUpgradeFile);
                            $scope.$apply();
                        };

                        $scope.Complete = function () {
                            // Exit - this button only available after download is complete
                            $modalInstance.close();
                        }

                        //  User canceled operation
                        $scope.Cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                        //#endregion Crest Upgrade - Supporting Methods
                    }
                    //#endregion Crest Upgrade - Modal Controller
                });
            };
            //#endregion Crest Upgrade
            //#endregion Crest OS Info and Upgrade

            // Get Apex 4 Host Info and Connection Status
            //#region Get Apex 4 Host Configuration and Connection Status
            $scope.Apex4Host = {};
            $scope.Apex4HostConnectionStatus = "UNKNOWN";
            //#region Get Host Configuration
            $scope.GetApex4HostConfiguration = function () {
                $http({
                    method: "get",
                    url: "/api/apex4/host"
                })
                    .success(function (data) {
                        $scope.Apex4Host = data;
                    })
            }
            $scope.GetApex4HostConfiguration();
            //#endregion Get Host Configuration
            //#region Get Connection Status
            $scope.GetApex4HostConnectionStatus = function () {
                $http({
                    method: "get",
                    url: "/api/apex4/connectionstatus"
                })
                    .success(function (data) {
                        $scope.Apex4HostConnectionStatus = data;
                        $('#IdApex4HostConnectionStatus').html(data);
                        switch (data) {
                            case "CONNECTED":
                                $('#IdApex4HostConnectionStatus').attr('class', 'btn btn-success');
                                $('#IdApex4HostConnectionStatus').html(data);
                                break;
                            case "DISCONNECTED":
                            case "ERROR":
                                $('#IdApex4HostConnectionStatus').attr('class', 'btn btn-danger');
                                $('#IdApex4HostConnectionStatus').html(data);
                                break;
                            case "NOT DEFINED":
                                $('#IdApex4HostConnectionStatus').attr('class', 'btn btn-basic');
                                $('#IdApex4HostConnectionStatus').html(data);
                                break;
                            default:
                                $('#IdApex4HostConnectionStatus').attr('class', 'btn btn-danger');
                                $('#IdApex4HostConnectionStatus').html("UNKNOWN");
                                break;
                        }
                    })
            }
            $scope.GetApex4HostConnectionStatus();
            //#endregion Get Connection Status
            //#endregion Get Apex 4 Host Info and Connection Status

            // Configure Apex 4 Settings
            //#region Configure Apex 4 Settings
            $scope.ConfigureApex4Settings = function (apex4Host) {
                //console.log("ConfigureApex4Settings: Apex4Info=" + JSON.stringify(apex4Host))
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/ConfigureApex4Settings.html',
                    scope: $scope,
                    controller: function ($scope, $modalInstance) {

                        //#region Modal setup/control
                        $scope.modalTitle = "Configure Apex 4 Settings";
                        $scope.Apex4HostTemp = apex4Host;
                        $scope.AddressPattern = /^[\w:\.]{1,64}$/;
                        // Before when we used IP:Port
                        //$scope.AddressPattern = /^((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/;
                        $scope.PortPattern = /^(6553[0-5]|655[0-2][0-9]\d|65[0-4](\d){2}|6[0-4](\d){3}|[1-5](\d){4}|[1-9](\d){0,3})$/;
                        $scope.TokenPattern = /^\w{48}$/;
                        //#endregion Modal setup/control

                        //#region apply()
                        $scope.ConnectToApex4 = function (apex4info) {
                            // Attempt connection to Apex 4
                            $http({
                                method: "put",
                                url: "/api/apex4/connect",
                                data: $scope.Apex4HostTemp
                            })
                                .success(function (data) {
                                    //console.log('Connection to Apex4 Host result=' + JSON.stringify(data));
                                    $modalInstance.close(data);
                                })
                        };
                        //#endregion apply()

                        //#region remove()
                        $scope.DeleteApex4Connection = function () {
                            // Call to remove host
                            $http({
                                method: "get",
                                url: "/api/apex4/remove"
                            })
                                .success(function (data) {
                                    //console.log('Remove Apex4 Host=' + JSON.stringify(data));
                                    $modalInstance.close(data);
                                })
                        };
                        //#endregion remove()

                        //#region cancel()
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                        //#endregion cancel()
                    }
                });

                // Save the results from the modal to $scope data, so it will automatically update the UI
                modalInstance.result.then(function (apex4host) {
                    $scope.Apex4Host = apex4host;
                }, function () {
                    console.log('Modal dismissed at: ' + new Date());
                });
            };
            //#endregion Configure Apex 4 Settings
            // Handle Apex 4 Socket Messages
            //#region Handle Apex 4 Socket Messages
            socketManager.on('Apex4Status', function (data) {
                //console.log('socketManager.on for Apex4Status='+JSON.stringify(data));
                switch (data.Apex4Status) {
                    case "CONNECTED":
                        $('#IdApex4HostConnectionStatus').attr('class', 'btn btn-success');
                        $('#IdApex4HostConnectionStatus').html(data.Apex4Status);
                        break;
                    case "DISCONNECTED":
                    case "ERROR":
                        $('#IdApex4HostConnectionStatus').attr('class', 'btn btn-danger');
                        $('#IdApex4HostConnectionStatus').html(data.Apex4Status);
                        break;
                    case "NOT DEFINED":
                        $('#IdApex4HostConnectionStatus').attr('class', 'btn btn-basic');
                        $('#IdApex4HostConnectionStatus').html(data.Apex4Status);
                        break;
                    default:
                        $('#IdApex4HostConnectionStatus').attr('class', 'btn btn-danger');
                        $('#IdApex4HostConnectionStatus').html("UNKNOWN");
                        break;
                }
            });
            //#endregion Handle Apex 4 Socket Messages

            // Summit System Status
            //#region Summit System Status
            $scope.GetSystemStatus = function () {
                $http({
                    method: "get",
                    url: "/api/summit/systemstatus"
                })
                    .success(function (data) {
                        console.log('Get GetSystemEvents data="' + data + '"');
                        $('#IdCurrentSystemStatus').html(data);
                        switch (data) {
                            case "NORMAL":
                                $('#IdCurrentSystemStatus').attr('class', 'btn btn-success');
                                break;
                            case "WARNING":
                                $('#IdCurrentSystemStatus').attr('class', 'btn btn-warning');
                                break;
                            case "FAILURE":
                                $('#IdCurrentSystemStatus').attr('class', 'btn btn-danger');
                                break;
                            default:
                                $('#IdCurrentSystemStatus').attr('class', 'btn btn-danger');
                                $('#IdCurrentSystemStatus').html("UNKNOWN");
                                break;
                        }
                    })
            }
            $scope.GetSystemStatus();
            //#endregion Summit System Status

            //#region Get Serial Port Settings
            $scope.SerialPortSettings = [];
            $scope.GetSerialPortSettings = function () {
                $http({
                    method: "get",
                    url: "/api/serialports"
                })
                    .success(function (data) {
                        //console.log('serialPortsCtrl.GetSerialPortSettings success');
                        $scope.SerialPortSettings = data;
                    })
            }
            $scope.GetSerialPortSettings();
            //#endregion Get Serial Port Settings

            // Summit Home table stuff
            //#region Summit Home table stuff
            $('#IdSummitTable').footable({
                toggleSelector: " > tbody > tr > td > span.footable-toggle"
            }).on({
                'footable_filtering': function (e) {
                    var selected = $scope.userStatus;
                    if (selected && selected.length > 0) {
                        e.filter += (e.filter && e.filter.length > 0) ? ' ' + selected : selected;
                        e.clear = !e.filter;
                    }
                }
            });

            $scope.clearFilters = function () {
                $('.filter-status').val('');
                $('#footable_summit').trigger('footable_clear_filter');
            };

            $scope.filterTable = function (userStatus) {
                $('#footable_summit').data('footable-filter').filter($('#textFilter').val());
            };
            //#endregion Summit Home table stuff

            // Handle incoming socket.io updates     
            //#region Socket I/O management
            socketManager.on('CurrentSystemTime', function (message) {
                //$('#IdSystemClock').html(message.CurrentSystemTime);
                $scope.CurrentSystemTime = message.CurrentSystemTime;
                //console.log("Received time: " + message);
            });

            $scope.CrestUptime = 0;
            $scope.CrestUptimeDays = 0;
            $scope.CrestUptimeHours = 0;
            $scope.CrestUptimeMinutes = 0;
            $scope.CrestUptimeSeconds = 0;
            socketManager.on('CrestUptime', function (message) {
                $scope.CrestUptime = message.CrestUptime;
                $scope.CrestUptimeDays = parseInt($scope.CrestUptime / 86400);
                $scope.CrestUptimeHours = ("0" + parseInt($scope.CrestUptime / 3600) % 24).slice(-2);
                $scope.CrestUptimeMinutes = ("0" + parseInt($scope.CrestUptime / 60) % 60).slice(-2);
                $scope.CrestUptimeSeconds = ("0" + $scope.CrestUptime % 60).slice(-2);
            });

            socketManager.on('SystemStatus', function (message) {
                $('#IdCurrentSystemStatus').html(message.ErrorType);
                switch (data) {
                    case "NORMAL":
                        $('#IdCurrentSystemStatus').attr('class', 'btn btn-success');
                        break;
                    case "WARNING":
                        $('#IdCurrentSystemStatus').attr('class', 'btn btn-warning');
                        break;
                    case "FAILURE":
                        $('#IdCurrentSystemStatus').attr('class', 'btn btn-danger');
                        break;
                    default:
                        $('#IdCurrentSystemStatus').attr('class', 'btn btn-danger');
                        $('#IdCurrentSystemStatus').html("UNKNOWN");
                        break;
                }
            });
            //#endregion Socket I/O management

            //#endregion Summit - System Information tab

            //#region Summit - Authentication tab

            //#region Get Configuration and Login Records
            // Get Summit Authentication Configuration (from authentication.json)
            $scope.AuthenticationConfiguration = {};// Set to null
            //#region Get Summit Authentication Configuration
            $scope.GetSummitAuthenticationConfiguration = function () {
                $http({
                    method: "get",
                    url: "/api/login/authconfig"
                })
                    .success(function (data) {
                        $scope.AuthenticationConfiguration = data;
                    })
            }
            $scope.GetSummitAuthenticationConfiguration();
            //#endregion Get Summit Authentication Configuration

            // Get the Summit Local Authentication (from users.json)
            $scope.LocalAuthenticationConfiguration = {};
            //#region Get Summit Local Authentication
            //  /api/login/users
            $scope.GetLocalAuthenticationConfiguration = function () {
                $http({
                    method: "get",
                    url: "/api/login/localconfig"
                })
                    .success(function (data) {
                        // Do something with the data
                        $scope.LocalAuthenticationConfiguration = data;
                    })
            }
            $scope.GetLocalAuthenticationConfiguration();// Go get Summit Users
            //#endregion Get Summit Local Authentication

            // Retreive Summit Login Attempts
            //#region Retreive Summit Login Attempts
            //  /api/login/attempts
            $scope.GetSummitLoginAttempts = function () {
                console.log("Inside GetSummitLoginAttempts ...")
                $http({
                    method: "get",
                    url: "/api/login/attempts"
                })
                    .success(function (data) {
                        //console.log('Get GetSummitLoginAttempts success');
                        // Do something with the data
                        $scope.SummitLoginAttempts = data;
                    })
            }
            $scope.GetSummitLoginAttempts();// Go get Summit Login Attempts
            //#endregion Retreive Summit Login Attempts
            //#endregion Get Configuration and Login Records

            //#region Change Configuration
            $scope.AuthenticationOptions = ["Local", "RADIUS Server"];
            // Select the Authentication Configuration Method (from toggle)
            //#region Select the Authentication Configuration Method
            $scope.SelectAuthenticationConfigurationMethod = function (option) {
                // Don't worry unless user actually changed the Method
                if (option != $scope.AuthenticationConfiguration.Method) {
                    $scope.AuthenticationConfiguration.Method = option;

                    console.log("Sending: '/api/login/authconfig");

                    $http({
                        method: "put",
                        url: "/api/login/authconfig",
                        data: $scope.AuthenticationConfiguration
                    }).success(function (data) {
                        //console.log('SelectAuthenticationConfigurationMethod PUT success data=' + JSON.stringify(data));
                        $scope.AuthenticationConfiguration = data;
                    });
                }
            }
            //#endregion Select the Authentication Configuration Method

            // Change Local Authentication Configuration
            //#region Change Local Authentication Configuration
            $scope.ChangeLocalAuthenticationConfiguration = function (localAuthenticationConfiguration) {
                console.log("Inside ChangeLocalAuthenticationConfiguration")

                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/ManageUserCredentials.html',
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = "Change User Credentials";
                        $scope.TypeOfView = "password";

                        // Make a copy of original credentials, for back up
                        $scope.temp = {
                            "user": localAuthenticationConfiguration.user,
                            "password": localAuthenticationConfiguration.password,
                            "confirm": localAuthenticationConfiguration.password
                        };

                        // Username pattern
                        //  1. 4-32 characters
                        //  2. Alphanumeric characters only
                        $scope.UserPattern = /^[\w]{4,32}$/;
                        // Password pattern
                        //  1. 4-32 characters
                        //  2. The following special chars are allowed (0 or more): !@#$%
                        //  3. Alphanumeric characters are also allowed
                        $scope.PasswordPattern = /^[0-9a-zA-Z!@#$%]{4,32}$/;

                        // Apply button press - update the server
                        $scope.apply = function () {
                            console.log("Sending: '/api/login/localconfig");

                            $http({
                                method: "put",
                                url: "/api/login/localconfig",
                                data: $scope.temp
                            }).success(function (data) {
                                //console.log('ChangeLocalAuthenticationConfiguration success user='+data.user);
                                localAuthenticationConfiguration.user = data.user;
                                localAuthenticationConfiguration.password = data.password;
                                localAuthenticationConfiguration.lastlogin = data.lastlogin;
                            });
                            $modalInstance.close($scope.temp);
                        };

                        // Toggle

                        $scope.ShowPasswordToggle = function () {
                            if ($scope.TypeOfView === "password") {
                                $scope.TypeOfView = "text";
                            } else {
                                $scope.TypeOfView = "password";
                            }
                        }

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });

                modalInstance.result.then(function (summitUser) {
                    // Modal close
                }, function () {
                    // Dismissed
                });
            };
            //#endregion Change Local Authentication Configuration

            // Change Authentication Configuration
            //#region Change Authentication Configuration
            $scope.ChangeAuthenticationConfiguration = function (authenticationConfiguration) {
                console.log("Inside ChangeAuthenticationConfiguration")

                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/ManageAuthenticationConfiguration.html',
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = "Change RADIUS Server Authentication";

                        // Make a copy of original credentials, for back up
                        $scope.temp = {
                            "Method": "RADIUS Server",
                            "RADIUS": {
                                "Name": authenticationConfiguration.RADIUS.Name,
                                "Address": authenticationConfiguration.RADIUS.Address,
                                "Port": authenticationConfiguration.RADIUS.Port,
                                "Secret": authenticationConfiguration.RADIUS.Secret
                            }
                        };

                        // Name pattern
                        //  1. 4-32 characters
                        //  2. Alphanumeric characters only
                        $scope.NamePattern = /^[\w ]{4,32}$/;
                        // IP Address Pattern
                        $scope.AddressPattern = /^((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/;
                        // IP Port Patter
                        $scope.PortPattern = /^(6553[0-5]|655[0-2][0-9]\d|65[0-4](\d){2}|6[0-4](\d){3}|[1-5](\d){4}|[1-9](\d){0,3})$/;
                        // Phrase pattern
                        //  1. 4-32 characters
                        //  2. The following special chars are allowed (0 or more): !@#$%
                        //  3. Alphanumeric characters are also allowed
                        $scope.SecretPattern = /^[0-9a-zA-Z!@#$% ]{4,32}$/;

                        // Apply button press - update the server
                        $scope.apply = function () {
                            console.log("Sending: '/api/login/authconfig");

                            $http({
                                method: "put",
                                url: "/api/login/authconfig",
                                data: $scope.temp
                            }).success(function (data) {
                                //console.log('ChangeAuthenticationConfiguration success data=' + JSON.stringify(data));
                                authenticationConfiguration.RADIUS.Name = data.RADIUS.Name;
                                authenticationConfiguration.RADIUS.Address = data.RADIUS.Address;
                                authenticationConfiguration.RADIUS.Port = data.RADIUS.Port;
                                authenticationConfiguration.RADIUS.Secret = data.RADIUS.Secret;
                            });
                            $modalInstance.close($scope.temp);
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });

                modalInstance.result.then(function (summitUser) {
                    // Modal close
                }, function () {
                    // Dismissed
                });
            };
            //#endregion Change Authentication Configuration

            //#endregion Change Configuration

            //#region Test RADIUS Authentication
            // Get Crest software
            //  /api/crest/download
            $scope.TestRadiusAuthentication = function (authenticationConfiguration) {
                console.log("Inside TestRadiusAuthentication")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/TestRadiusAuthentication.html',
                    controller: function ($scope, $modalInstance) {
                        //#region TestRadiusAuthentication preamble
                        $scope.ModalTitle = "Test RADIUS Authentication";
                        $scope.RadiusTest = "";
                        $scope.ResponseMessage = "";
                        $scope.Credentials = {
                            User: "",
                            Password: ""
                        }
                        // User name pattern
                        //  1. 4-32 characters
                        //  2. The following special chars are allowed (0 or more): !@#$%
                        //  3. Alphanumeric characters are also allowed
                        $scope.UserPattern = /^[0-9a-zA-Z!@#$%\\ ]{4,32}$/;
                        // Password pattern
                        //  1. 4-32 characters
                        //  2. The following special chars are allowed (0 or more): !@#$%
                        //  3. Alphanumeric characters are also allowed
                        $scope.PasswordPattern = /^[0-9a-zA-Z!@#$% ]{4,32}$/;
                        //#endregion SetNetworkInterface controller preamble

                        //  Download Crest software
                        //# region Download Crest software
                        $scope.TestLogin = function () {

                            console.log('TestRadiusAuthentication.Test: "' + $scope.Credentials.User + '"');
                            $scope.RadiusTest = "Testing";

                            $http({
                                method: "put",
                                url: "/api/login",
                                data: $scope.Credentials
                            })
                                .success(function (response) {
                                    console.log('TestRadiusAuthentication.Test: Response=' + JSON.stringify(response));
                                    (response.Result ? $scope.RadiusTest = "Success" : $scope.RadiusTest = "Failed");
                                    $scope.ResponseMessage = response.Message;

                                    $timeout(function () {
                                        $scope.RadiusTest = "";
                                        $scope.ResponseMessage = "";
                                    }, 2000);
                                })
                        };
                        //# endregion Download Crest software

                        //  User canceled operation
                        $scope.Cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });
            };
            //#endregion Test RADIUS Authentication

            //#endregion Summit - Authentication tab

            //#region Summit - Logging tab
            //----------------------------------------------------------
            // Logging tab

            $scope.LoggingVerbosity
            $scope.LoggingVerbosityOpposite

            // Retreive the system software information
            //  /api/logging/loglevel
            $scope.GetLoggingVerbosity = function () {
                $http({
                    method: "get",
                    url: "/api/logging/loglevel"
                })
                    .success(function (data) {
                        //console.log('Get GetLoggingVerbosity success - data=' + data.LogLevel);
                        $scope.LoggingVerbosity = data.LogLevel;
                        if ($scope.LoggingVerbosity == "BASIC")
                            $scope.LoggingVerbosityOpposite = "VERBOSE"
                        else
                            $scope.LoggingVerbosityOpposite = "BASIC"
                        $('#IdLoggingVerbosity').html($scope.LoggingVerbosity);
                        $('#IdLoggingVerbosityOpposite').html($scope.LoggingVerbosityOpposite);
                    })
            }
            $scope.GetLoggingVerbosity();

            $scope.LoggingVerbosityChange = function () {
                if ($scope.LoggingVerbosity === "BASIC")
                    changeURL = "/api/logging/loglevel/VERBOSE"
                else
                    changeURL = "/api/logging/loglevel/BASIC"
                console.log("PUT to " + changeURL);

                $http({
                    method: "put",
                    url: changeURL
                })
                    .success(function (data) {
                        //console.log('Put LoggingVerbosityChange success - data=' + data.LogLevel);
                        $scope.LoggingVerbosity = data.LogLevel;
                        if ($scope.LoggingVerbosity == "BASIC")
                            $scope.LoggingVerbosityOpposite = "VERBOSE"
                        else
                            $scope.LoggingVerbosityOpposite = "BASIC"
                        $('#IdLoggingVerbosity').html($scope.LoggingVerbosity);
                        $('#IdLoggingVerbosityOpposite').html($scope.LoggingVerbosityOpposite);
                    })
            }

            // Retreive the log files
            //  /api/logging/logfiles
            $scope.GetLogFiles = function () {
                $http({
                    method: "get",
                    url: "/api/logging/logfiles"
                })
                    .success(function (data) {
                        console.log('Get GetLogFiles success');
                        // Do something with the data
                        $scope.LogFiles = data;
                        $scope.NumberOfLogFiles = $scope.LogFiles.length
                    })
            }
            $scope.GetLogFiles();// Go get Log Files

            // View a log file
            //  /api/logging/logfiles/:logfile
            $scope.DisplayLogFile = function (logFile) {
                console.log("Inside DisplayLogFile")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/displaylogfile.html',
                    size: 'lg',
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = logFile;

                        // Go get the log file
                        console.log("Inside DisplayLogFile: '/api/logging/logfiles/" + logFile + "'");
                        $http({
                            method: 'GET',
                            url: "/api/logging/logfiles/" + logFile
                        }).success(function (data) {
                            //console.log("Get logging/logfiles/" + logFile + " success");
                            $('#IdLogFileContents').html(decodeURIComponent(data));
                            $('#IdLogFileContents').css('font-size', 'smaller');
                        });

                        // Done viewing
                        $scope.done = function () {
                            $modalInstance.dismiss('done');
                        };

                        // Cancel (x) press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });
            };

            // Download a log file
            $scope.DownloadLogFile = function (logFile) {
                console.log("Inside DownloadLogFile: '/api/logging/logfiles/" + logFile + "'");
                $http({
                    method: 'GET',
                    url: "/api/logging/logfiles/" + logFile
                }).
                    success(function (data, status, headers, config) {
                        console.log("Inside DownloadLogFile - received data!");
                        var anchor = angular.element('<a/>');
                        anchor.attr({
                            href: 'data:text/plain;charset=utf-8,' + data,
                            target: '_blank',
                            download: logFile
                        })[0].click();
                    }).
                    error(function (data, status, headers, config) {
                        console.log("Error downloading log file")
                    });
            };
            //#endregion Summit - Logging tab
        }
    ])
    //#endregion Summit Home Page Controller

    //#region System Status Controller
    .controller('systemStatus', [
        '$scope',
        '$http',
        'socketManager',
        function ($scope, $http, socketManager) {
            // Administrative controller stuff
            $scope.$on('$stateChangeSuccess', function () {
                console.log("Controller: systemStatus");
            });

            $scope.$on('$destroy', function (event) {
                socketManager.removeAllListeners();
            });

            // Retreive System Status array through RESTful API
            $scope.GetSystemStatus = function () {
                $http({
                    method: "get",
                    url: "/api/systemstatus"
                })
                    .success(function (data) {
                        console.log('GetSystemStatus data=' + data);
                        $scope.SystemStatus = data;
                        $scope.SystemStatusTotal = data.length;
                    })
            }
            $scope.GetSystemStatus();// Go get System System

            // Retreive the Current System Status through RESTful API
            $scope.GetCurrentSystemStatus = function () {
                $http({
                    method: "get",
                    url: "/api/currentsystemstatus"
                })
                    .success(function (data) {
                        console.log('Get GetCurrentSystemStatus data="' + data + '"');
                        $('#IdCurrentSystemStatus').html(data);
                        switch (data) {
                            case "NORMAL":
                                $('#IdCurrentSystemStatus').attr('class', 'btn btn-success');
                                break;
                            case "WARNING":
                                $('#IdCurrentSystemStatus').attr('class', 'btn btn-warning');
                                break;
                            case "FAILURE":
                                $('#IdCurrentSystemStatus').attr('class', 'btn btn-danger');
                                break;
                            default:
                                $('#IdCurrentSystemStatus').attr('class', 'btn btn-danger');
                                $('#IdCurrentSystemStatus').html("UNKNOWN");
                                break;
                        }
                    })
            }
            $scope.GetCurrentSystemStatus();// Go get Current System Status

            $scope.CauseError = function () {
                $http({
                    method: "get",
                    url: "/api/causeerror"
                })
                    .success(function (data) {
                        console.log('Get CauseError data="' + data + '"');
                    })
            }

            socketManager.on('SystemStatus', function (message) {
                $('#IdCurrentSystemStatus').html(message.ErrorType);
                switch (data) {
                    case "NORMAL":
                        $('#IdCurrentSystemStatus').attr('class', 'btn btn-success');
                        break;
                    case "WARNING":
                        $('#IdCurrentSystemStatus').attr('class', 'btn btn-warning');
                        break;
                    case "FAILURE":
                        $('#IdCurrentSystemStatus').attr('class', 'btn btn-danger');
                        break;
                    default:
                        $('#IdCurrentSystemStatus').attr('class', 'btn btn-danger');
                        $('#IdCurrentSystemStatus').html("UNKNOWN");
                        break;
                }
            });
        }
    ])
    //#endregion System Status Controller

    //#region Network Manager Controller
    .controller('networkCtrl', [
        '$scope',
        '$modal',
        '$http',
        '$timeout',
        'socketManager',
        function ($scope, $modal, $http, $timeout, socketManager) {

            //#region Network - General
            // Administrative controller stuff
            $scope.$on('$stateChangeSuccess', function () {
                console.log("Controller: networkCtrl");
            });

            $scope.$on('$destroy', function (event) {
                socketManager.removeAllListeners();
            });
            //#endregion Network - General

            //----------------------------------------------------------
            // Network - Interfaces tab
            //#region Network - Interfaces tab

            $('#IdNetworkTable').footable({
                toggleSelector: " > tbody > tr > td > span.footable-toggle"
            })

            $scope.EngineId = "";
            // Retreive the list of available network interfaces
            //  /api/network/interfaces
            $scope.GetNetworkInterfaces = function () {
                console.log("GetNetworkInterfaces called ...")
                $scope.WaitingForNetworkInfo = true;
                $http({
                    method: "get",
                    url: "/api/network/interfaces"
                })
                    .success(function (data) {
                        //console.log('Get GetNetworkInterfaces success - data=' + JSON.stringify(data));
                        // Do something with the data
                        $scope.NetworkInterfaces = data;
                        $scope.NumberOfNetworkInterfaces = $scope.NetworkInterfaces.length
                        $scope.WaitingForNetworkInfo = false;

                        // Build the EngineID for SNMPv3
                        //  0x = hex prefix
                        //  2E7E = TASC's number 11902
                        //  03 = code to indicate use of MACID
                        //  Remaining 6 nibbles = MACID from eth0
                        $scope.EngineId = "2E-7E-03-" + $scope.NetworkInterfaces[0].MACID.replace(/\:/g,'-').toUpperCase();
                    })
            }
            $scope.GetNetworkInterfaces();

            // Set the network interface
            //  /api/network/interfaces/:interface
            $scope.SetNetworkInterface = function (networkInterface) {
                console.log("Inside SetNetworkInterface for interface=" + JSON.stringify(networkInterface))
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/SetNetworkInterface.html',
                    controller: function ($scope, $modalInstance) {
                        //#region SetNetworkInterface controller preamble
                        // Clone a copy of the Interface for temporary use and sending to API
                        //  We'll copy back the reply to the Interface object if successful
                        $scope.TempInterface = JSON.parse(JSON.stringify(networkInterface));

                        // Modal options
                        $scope.modalTitle = "Configure " + $scope.TempInterface.Name;
                        $scope.MethodOptions = [{ type: "DHCP" }, { type: "STATIC" }];
                        if ($scope.TempInterface.Method === "STATIC") {
                            $scope.StaticIP = true
                        }
                        else {
                            $scope.StaticIP = false;
                        }

                        // Handle toggles of Method type
                        $scope.MethodSelected = function (method) {
                            console.log("Selected Assignment=" + method)
                            $scope.TempInterface.Method = method;
                            if (method === "STATIC") {
                                $scope.StaticIP = true
                            }
                            else {
                                $scope.StaticIP = false;
                            }
                        }
                        $scope.IPAddressFilter = /^(([1-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.){3}([1-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])$/;
                        $scope.NetmaskFilter = /^([1-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.((\d|\d\d|1\d\d|2[0-4]\d|25[0-5])\.){2}(\d|[1-9]\d|1\d\d|2[0-4]\d|25[0-5]\d)$/;
                        $scope.GatewayFilter = /^(([1-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])\.){3}([1-9]|[1-9]\d|1\d\d|2[0-4]\d|25[0-5])$/;
                        //#endregion SetNetworkInterface controller preamble

                        //  Show users the changes and prepare for reboot
                        //#region ApplyNetworkInterface function
                        $scope.ApplyNetworkInterface = function () {

                            // We need to reboot, so let user confirm
                            //#region ConfirmReboot function
                            $scope.ConfirmReboot = function (ifaceNew) {
                                console.log('   Confirm Reboot modal started!')
                                var $modalInstance = $modal.open({
                                    templateUrl: 'views/partials/NetworkInterfaceChanged.html',
                                    size: '',
                                    controller: function ($scope, $modalInstance) {

                                        // There were some changes, so let's bringup the modal
                                        $scope.modalTitle = 'Network Interface has changed!';
                                        if (ifaceNew.Method === 'DHCP') {
                                            $scope.NewInterfaceSettings = '<p>' + ifaceNew.Name + ' has been changed to:</p><p>&nbsp;&nbsp;Method: DHCP</p>';
                                        } else {
                                            $scope.NewInterfaceSettings = '<p>' + ifaceNew.Name + ' has been changed to:</p><p>&nbsp;&nbsp;Method: STATIC</p><p>&nbsp;&nbsp;IP Address: ' + ifaceNew.IPAddress + '</p><p>&nbsp;&nbsp;Netmask: ' + ifaceNew.Netmask + '</p><p>&nbsp;&nbsp;Gateway: ' + ifaceNew.Gateway + '</p>';
                                        }

                                        $scope.ok = function () {
                                            $modalInstance.close();
                                        };
                                    }
                                });
                            }

                            var NetworkInterfaceChanged = false;

                            console.log('Comparison of new settings vs. old:');
                            console.log('New=' + JSON.stringify($scope.TempInterface));
                            console.log('Old=' + JSON.stringify(networkInterface));

                            if ($scope.TempInterface.Method == networkInterface.Method) {
                                // Check to see if anything has changed

                                // DHCP -> DHCP - no change
                                if ($scope.TempInterface.Method === 'DHCP') {
                                    //  we don't need to throw up this modal, cuz nothing really changed 
                                    NetworkInterfaceChanged = false;
                                    console.log('   DHCP->DHCP no change, so exit');

                                }

                                // STATIC -> STATIC (with no parameter changes)
                                else if (JSON.stringify($scope.TempInterface) == JSON.stringify(networkInterface)) {
                                    // If we're going from Static -> Static and nothing changed, 
                                    //  we don't need to throw up this modal, cuz nothing really changed 
                                    NetworkInterfaceChanged = false;
                                    console.log('   STATIC->STATIC no change, so exit');
                                }

                                // STATIC -> STATIC (with parameter changes)
                                else {
                                    // If we're going from Static -> Static and nothing changed, 
                                    //  we don't need to throw up this modal, cuz nothing really changed 
                                    NetworkInterfaceChanged = true;
                                    console.log('   STATIC->STATIC with change, do change');
                                }
                            }

                            else {
                                // If we're going from Static -> DHCP or DHCP -> STATIC, 
                                NetworkInterfaceChanged = true;
                                console.log('   DHCP->STATIC or STATIC->DHCP, do change');
                            }

                            // If we see that network interfaces have changed, then bring up another dialog box
                            if (NetworkInterfaceChanged) {
                                // Send out the changed network interface
                                console.log("Sending: '/api/network/interfaces'" + $scope.TempInterface.Name);
                                console.log("  NetworkInterface.IPAddress=" + $scope.TempInterface.IPAddress);
                                $http({
                                    method: 'PUT',
                                    url: "/api/network/interfaces",
                                    data: $scope.TempInterface
                                }).success(function (data) {
                                    //console.log('/api/network/interfaces PUT success data=' + JSON.stringify(data));
                                    networkInterface = data;
                                    // Confirm the reboot now that network changes are in place
                                    $scope.ConfirmReboot($scope.TempInterface);
                                    $modalInstance.close();
                                });
                            }
                            //#endregion ConfirmReboot function

                        };
                        //#endregion ApplyNetworkInterface function

                        //  User canceled operation
                        $scope.CancelNetworkInterface = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });
            };
            //#endregion Network - Interfaces tab

            //----------------------------------------------------------
            // Network - Crest Server tab
            //#region Network - Crest Server

            //#region GetWebServerConfiguration
            $scope.SummitWebServerConfiguration = {};
            $scope.GetWebServerConfiguration = function () {
                console.log("GetWebServerConfiguration called ...")
                $scope.WaitingForNetworkInfo = true;
                $http({
                    method: "get",
                    url: "/api/webserver"
                })
                    .success(function (data) {
                        //console.log('Get GetWebServerConfiguration success - data=' + JSON.stringify(data));
                        $scope.SummitWebServerConfiguration = data;
                    })
            }
            $scope.GetWebServerConfiguration();
            //#endregion GetWebServerConfiguration

            //#region ConfigureWebServer
            $scope.ConfigureWebServer = function (webServerType,webServerConfig) {
                console.log("Inside ConfigureWebServer")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/ManageWebServerConfiguration.html',
                    controller: function ($scope, $modalInstance) {

                        //#region Modal setup/control
                        $scope.modalTitle = "Configure Crest Web Server (" + webServerType + ")";
                        $scope.PreviousWebServerConfig = JSON.parse(JSON.stringify(webServerConfig));
                        $scope.WebServerType = webServerType;
                        if (webServerType == "http") {
                            $scope.Port = webServerConfig.http.port;
                            $scope.Enabled = webServerConfig.http.enabled ? "TRUE" : "FALSE";
                        } else {
                            $scope.Port = webServerConfig.https.port;
                        }
                        $scope.PortPattern = /^(6553[0-5]|655[0-2][0-9]\d|65[0-4](\d){2}|6[0-4](\d){3}|[1-5](\d){4}|[1-9](\d){0,3})$/

                        // List of possible options for updating the configuration
                        $scope.EnabledOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.SetHttpWebServerEnabled = function (option) {
                            if (option == "TRUE")
                                webServerConfig.http.enabled = true;
                            else
                                webServerConfig.http.enabled = false;
                            $scope.Enabled = webServerConfig.http.enabled ? "TRUE" : "FALSE";
                        }
                        //#endregion Modal setup/control

                        //#region apply()
                        $scope.apply = function (port) {

                            //#region ConfirmReboot function
                            $scope.ConfirmReboot = function (rebootMessage) {
                                console.log('Confirm Web Server Configuration change modal started!')
                                var $modalInstance = $modal.open({
                                    templateUrl: 'views/partials/WebServerConfigurationChanged.html',
                                    size: '',
                                    controller: function ($scope, $modalInstance) {

                                        // There were some changes, so let's bringup the modal
                                        $scope.modalTitle = 'Crest Web Server configration has changed!';
                                        $scope.NewCrestWebServerSettings = '<p>' + rebootMessage + '</p>';

                                        $scope.ok = function () {
                                            $modalInstance.close();
                                        }
                                    }
                                });
                            }
                            //#endregion ConfirmReboot function

                            // If changes are made:
                            //  - Send the changes to the server
                            //  - Throw up a modal to inform about reboot needed
                            var WebConfigChanged = false;
                            var WebConfigChangedMessage = "";
                            console.log("Sending: '/api/webserver'");
                            if (webServerType == "http") {
                                webServerConfig.http.port = port;
                                if (webServerConfig.http.enabled != $scope.PreviousWebServerConfig.http.enabled) {
                                    WebConfigChanged = true;
                                    WebConfigChangedMessage = "Crest Web Server HTTP Port Changed to " + (webServerConfig.http.enabled ? "'TRUE'" : "'FALSE'");
                                }
                                if (webServerConfig.http.port != $scope.PreviousWebServerConfig.http.port) {
                                    WebConfigChanged = true;
                                    WebConfigChangedMessage = "Crest Web Server HTTP Port Changed to " + webServerConfig.http.port;
                                }
                            }
                            else {
                                webServerConfig.https.port = port;
                                if (webServerConfig.https.port != $scope.PreviousWebServerConfig.https.port) {
                                    WebConfigChanged = true;
                                    WebConfigChangedMessage = "Crest Web Server HTTPS Port Changed to " + webServerConfig.https.port;
                                }
                            }

                            // We only need to update the server and throw up a message if the config was changed
                            if (WebConfigChanged) {
                                $http({
                                    method: "put",
                                    url: "/api/webserver",
                                    data: webServerConfig
                                }).success(function (data) {
                                    //console.log('ConfigureWebServer PUT success data=' + JSON.stringify(data));
                                    webServerConfig = data;
                                    });

                                // Throw up modal to let user know that we need to reboot
                                $scope.ConfirmReboot(WebConfigChangedMessage);
                            }

                            // We're done!
                            $modalInstance.close();
                        };
                        //#endregion apply()

                        //#region cancel()
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                        //#endregion cancel()
                    }
                });
            };
            //#endregion ConfigureWebServer

            //#endregion Network - Crest Server

            //----------------------------------------------------------
            // Email (SMTP)
            //#region Network - Email (SMTP)

            $scope.SmtpSettings = [];// Holds SMTP Settings

            // Retreive SMTP Host info
            //  /api/network/smtp
            $scope.GetSmtpHosts = function () {
                console.log("GetSmtpHosts called ...")
                $http({
                    method: "get",
                    url: "/api/network/smtp"
                })
                    .success(function (data) {
                        //console.log('GetSmtpHosts success - data=' + JSON.stringify(data));
                        $scope.HostName = data.HostName;
                        $scope.SmtpSettings = data;
                    })
            }
            $scope.GetSmtpHosts();

            //#region archive
            //$scope.SmtpHost = {
            //    HostName: "MyGmail",
            //    Enabled: "TRUE",
            //    IPAddress: "smtp.gmail.com",
            //    Port: 465,
            //    FromEmail: "tascsystems@gmail.com",
            //    Authorization: {
            //        User: "tascsystems@gmail.com",
            //        Pass: "TotallyAwesome!"
            //    },
            //    Secure: true
            //}

            //$scope.SmtpToEmailList = [{
            //        Name: "TechSupport",
            //        Enabled: "TRUE",
            //        EmailAddress: "support@tascsystems.com"
            //    },
            //    {
            //        Name: "Info",
            //        Enabled: "FALSE",
            //        EmailAddress: "info@tascsystems.com"
            //    },
            //];
            //#endregion archive

            // Send test email to SMTP server
            //  /api/network/smtp/test
            $scope.TestSmtpHost = function () {
                console.log("Inside TestSmtpHost");
                $scope.SmtpTest = "Testing";

                var ToList = "";
                var AddedEmail = false;
                //for (var e = 0; e < $scope.SmtpSettings.Options.To.length; e++) {
                //    if ($scope.SmtpSettings.Options.To[e].Enabled) {
                //        console.log("TestSmtpHost: Adding email=" + $scope.SmtpSettings.Options.To[e].Email);
                //        if (AddedEmail) ToList += ",";// Add separator if we previously had an email
                //        ToList += $scope.SmtpSettings.Options.To[e].Email;
                //        AddedEmail = true;  
                //    }
                //}
                ToList = $scope.SmtpSettings.Options.From;
                console.log("TestSmtpHost: ToList=" + ToList);

                var data = {
                    Port: $scope.SmtpSettings.Transport.Port,
                    Host: $scope.SmtpSettings.Transport.Host,
                    Secure: $scope.SmtpSettings.Transport.Secure,
                    User: $scope.SmtpSettings.Transport.Auth.User,
                    Pass: $scope.SmtpSettings.Transport.Auth.Pass,
                    From: $scope.SmtpSettings.Options.From,
                    To: ToList
                }

                $http({
                    method: "put",
                    url: "/api/network/smtp/test",
                    data: data
                })
                    .success(function (data) {
                        //console.log('TestSmtpHost success - data=' + JSON.stringify(data));
                        if (data.result) {
                            $scope.SmtpTest = "Success";// This is to show the succeeded symbol
                        }
                        else {
                            $scope.SmtpTest = "Failed";// This is to show the fail symbol

                            // Throw up a message to let user know the error that was received
                            var modalInstance = $modal.open({
                                templateUrl: 'views/partials/SmtpErrorModal.html',
                                controller: function ($scope, $modalInstance) {
                                    $scope.modalTitle = 'SMTP Test Error';
                                    $scope.modalCode = "Error Type: " + data.response.code + "  (Code=" + data.response.responseCode + ")";
                                    $scope.modalResponse = data.response.response

                                    $scope.ok = function () {
                                        $modalInstance.close();
                                    };

                                    $scope.cancel = function () {
                                        $modalInstance.dismiss('cancel');
                                    };

                                }
                            });
                        }
                        // Clear image
                        $timeout(function () { $scope.SmtpTest = ""; }, 3000);
                    })
            };

            // Configure SMTP Settings 
            //  /api/network/smtp
            $scope.ConfigureSmtpSettings = function (SmtpSettings) {
                console.log("Inside ConfigureSmtpSettings")
                var OriginalSmtpSettings = {
                    HostName: SmtpSettings.HostName,
                    Enabled: SmtpSettings.Enabled,
                    Host: SmtpSettings.Transport.Host,
                    Port: SmtpSettings.Transport.Port,
                    From: SmtpSettings.Options.From,
                    User: SmtpSettings.Transport.Auth.User,
                    Pass: SmtpSettings.Transport.Auth.Pass,
                    Secure: SmtpSettings.Transport.Secure
                }
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/ManageSmtpSettings.html',
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = "Configure SMTP Settings";
                        $scope.SmtpSettings = SmtpSettings;
                        $scope.OriginalSmtpSettings = {
                            HostName: SmtpSettings.HostName,
                            Enabled: SmtpSettings.Enabled,
                            Host: SmtpSettings.Transport.Host,
                            Port: SmtpSettings.Transport.Port,
                            From: SmtpSettings.Options.From,
                            User: SmtpSettings.Transport.Auth.User,
                            Pass: SmtpSettings.Transport.Auth.Pass,
                            Secure: SmtpSettings.Transport.Secure
                        }
                        $scope.EnabledOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.HostNamePattern = /^[\w][\w ]{0,15}$/;
                        $scope.HostPattern = /^((([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))|((([a-zA-Z0-9]|[a-zA-Z0-9][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z0-9]|[A-Za-z0-9][A-Za-z0-9\-]*[A-Za-z0-9]))$/;
                        $scope.PortPattern = /^[1-9][0-9]{0,4}$/;
                        $scope.FromEmailAddressPattern = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
                        $scope.AuthUserPattern = /^[\x20-\x7F][\x20-\x7F]{0,32}$/;
                        $scope.AuthPassPattern = /^[\x20-\x7F][\x20-\x7F]{0,32}$/;

                        // Accept changes to the configuration into the temp variable
                        $scope.SetEnabled = function (option) {
                            if (option == "TRUE") {
                                $scope.SmtpSettings.Enabled = true;
                            } else {
                                $scope.SmtpSettings.Enabled = false;
                            }
                        }

                        $scope.SetSecure = function (option) {
                            if (option == "TRUE") {
                                $scope.SmtpSettings.Transport.Secure = true;
                            } else {
                                $scope.SmtpSettings.Transport.Secure = false;
                            }
                        }

                        // Apply button press - update the server
                        $scope.apply = function () {
                            console.log("Sending: '/api/network/smtp");

                            $http({
                                method: "put",
                                url: "/api/network/smtp",
                                data: $scope.SmtpSettings
                            }).success(function (data) {
                                //console.log('ConfigureSmtpSettings PUT success data=' + JSON.stringify(data));
                            });
                            $modalInstance.close();
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            SmtpSettings.HostName = OriginalSmtpSettings.HostName;
                            SmtpSettings.Enabled = OriginalSmtpSettings.Enabled;
                            SmtpSettings.Transport.Host = OriginalSmtpSettings.Host;
                            SmtpSettings.Transport.Port = OriginalSmtpSettings.Port;
                            SmtpSettings.Options.From = OriginalSmtpSettings.From;
                            SmtpSettings.Transport.Auth.User = OriginalSmtpSettings.User;
                            SmtpSettings.Transport.Auth.Pass = OriginalSmtpSettings.Pass;
                            SmtpSettings.Transport.Secure = OriginalSmtpSettings.Secure;
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });

                modalInstance.result.then(function () {
                }, function () {
                    SmtpSettings.HostName = OriginalSmtpSettings.HostName;
                    SmtpSettings.Enabled = OriginalSmtpSettings.Enabled;
                    SmtpSettings.Transport.Host = OriginalSmtpSettings.Host;
                    SmtpSettings.Transport.Port = OriginalSmtpSettings.Port;
                    SmtpSettings.Options.From = OriginalSmtpSettings.From;
                    SmtpSettings.Transport.Auth.User = OriginalSmtpSettings.User;
                    SmtpSettings.Transport.Auth.Pass = OriginalSmtpSettings.Pass;
                    SmtpSettings.Transport.Secure = OriginalSmtpSettings.Secure;
                });
            };

            // Add a new SMTP Email
            //  /api/network/smtp
            $scope.AddSmtpEmail = function (SmtpSettings) {
                console.log("Inside AddSmtpEmail")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/ManageSmtpEmail.html',
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = "Add SMTP Email";
                        SmtpSettings.Options.To.splice(0, 0, { "Name": "", "Enabled": false, "Email": "" });// Add to front (more visible)
                        $scope.index = 0;
                        $scope.SmtpSettings = SmtpSettings;
                        $scope.EnabledOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.NamePattern = /^[\w][\w ]{0,15}$/;
                        $scope.EmailAddressPattern = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;

                        // Accept changes to the configuration into the temp variable
                        $scope.SetEnabled = function (option) {
                            if (option == "TRUE") {
                                $scope.SmtpSettings.Options.To[0].Enabled = true;
                            } else {
                                $scope.SmtpSettings.Options.To[0].Enabled = false;
                            }
                        }

                        // Apply button press - update the server
                        $scope.apply = function () {
                            console.log("Sending: '/api/network/smtp/");

                            $http({
                                method: "put",
                                url: "/api/network/smtp",
                                data: $scope.SmtpSettings
                            }).success(function (data) {
                                //console.log('ConfigureSmtpEmail PUT success data=' + JSON.stringify(data));
                            });
                            $modalInstance.close();
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            SmtpSettings.Options.To.splice(0, 1);// Get rid of this, not wanted
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });

                modalInstance.result.then(function () {
                }, function () {
                    SmtpSettings.Options.To.splice(0, 1);// Get rid of this, not wanted
                });
            };

            // Edit an existing SMTP Email
            //  /api/network/smtp
            $scope.ConfigureSmtpEmail = function (index, SmtpSettings) {
                console.log("Inside ConfigureSmtpEmail")
                var OriginalSmtpSettings = {
                    Name: SmtpSettings.Options.To[index].Name,
                    Enabled: SmtpSettings.Options.To[index].Enabled,
                    Email: SmtpSettings.Options.To[index].Email
                }
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/ManageSmtpEmail.html',
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = "Configure SMTP Email";
                        $scope.index = index;
                        $scope.SmtpSettings = SmtpSettings;

                        $scope.EnabledOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.NamePattern = /^[\w][\w ]{0,15}$/;
                        $scope.EmailAddressPattern = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;

                        // Accept changes to the configuration into the temp variable
                        $scope.SetEnabled = function (option) {
                            if (option == "TRUE") {
                                $scope.SmtpSettings.Options.To[index].Enabled = true;
                            } else {
                                $scope.SmtpSettings.Options.To[index].Enabled = false;
                            }
                        }

                        // Apply button press - update the server
                        $scope.apply = function () {
                            console.log("Sending: '/api/network/smtp/");

                            $http({
                                method: "put",
                                url: "/api/network/smtp",
                                data: $scope.SmtpSettings
                            }).success(function (data) {
                                //console.log('ConfigureSmtpEmail PUT success data=' + JSON.stringify(data));
                            });
                            $modalInstance.close();
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            SmtpSettings.Options.To[index].Name = OriginalSmtpSettings.Name;
                            SmtpSettings.Options.To[index].Enabled = OriginalSmtpSettings.Enabled;
                            SmtpSettings.Options.To[index].Email = OriginalSmtpSettings.Email;
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });

                modalInstance.result.then(function () {
                }, function () {
                    SmtpSettings.Options.To[index].Name = OriginalSmtpSettings.Name;
                    SmtpSettings.Options.To[index].Enabled = OriginalSmtpSettings.Enabled;
                    SmtpSettings.Options.To[index].Email = OriginalSmtpSettings.Email;
                });
            };

            // Delete an existing SMTP Email
            //  /api/network/smtp
            $scope.DeleteSmtpEmail = function (index, SmtpSettings) {
                console.log("Inside DeleteSmtpEmail")
                SmtpSettings.Options.To.splice(index, 1)
                $http({
                    method: "put",
                    url: "/api/network/smtp",
                    data: SmtpSettings
                })
                    .success(function (data) {
                        //console.log('DeleteSmtpEmail success - data=' + JSON.stringify(data));
                        SmtpSettings = data;
                    })
            };

            //#endregion Network - Email (SMTP)

            //----------------------------------------------------------
            // SNMP Server
            //#region Network - SNMP tab

            $scope.SnmpHostsArray = [];

            // Retreive array of SNMP Hosts
            //  /api/network/snmp/hosts
            $scope.GetSnmpHosts = function () {
                console.log("GetSnmpHosts called ...")
                $http({
                    method: "get",
                    url: "/api/network/snmp/hosts"
                })
                    .success(function (data) {
                        //console.log('GetSnmpHosts success - data=' + JSON.stringify(data));
                        $scope.SnmpHostsArray = data;
                        $scope.NumberOfSnmpHosts = data.length;
                    })
            }
            $scope.GetSnmpHosts();

            // Send test trap to SNMP Host
            //  /api/network/snmp/test
            $scope.SendTestTrap = function (currentSnmpHost) {
                console.log("Inside SendTestTrap")
                $http({
                    method: "put",
                    url: "/api/network/snmp/test",
                    data: currentSnmpHost
                })
                    .success(function (data) {
                        //console.log('SendTestTrap success - data=' + JSON.stringify(data));
                    })
            };

            // Add an SNMP Host
            //#region Add SNMP Host
            $scope.AddSnmpHost = function (snmpHostsArray,EngineId) {
                console.log("Inside AddSnmpHost")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/managesnmphost.html',
                    //#region Add SNMP Host controller
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = "Add SNMP Host";
                        $scope.EngineId = EngineId;
                        $scope.tempSnmpHost = {
                            HostName: "",
                            Enabled: "TRUE",
                            IpAddress: "",
                            Port: "162",
                            Community: "Public",
                            SnmpVersion: 2,
                            AuthUser: "",
                            AuthPassword: "",
                            AuthProtocol: 0,
                            PrivPassword: "",
                            PrivProtocol: 0
                        };
                        $scope.HostNamePattern = /^[\w]{1,16}$/;
                        $scope.IpAddressPattern = /^((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/;
                        $scope.PortPattern = /^(6553[0-5]|655[0-2][0-9]\d|65[0-4](\d){2}|6[0-4](\d){3}|[1-5](\d){4}|[1-9](\d){0,3})$/;
                        $scope.CommunityPattern = /^[a-zA-Z0-9\-]{1,24}$/;
                        $scope.AuthUserPattern = /^[a-zA-Z0-9\-]{8,16}$/;
                        $scope.AuthPasswordPattern = /^[a-zA-Z0-9]{8,16}$/;
                        $scope.PrivPasswordPattern = /^[a-zA-Z0-9]{8,16}$/;

                        // List of possible options for updating the configuration
                        $scope.EnabledOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.SnmpVersionOptions = [{ option: 'SNMP v2C' }, { option: 'SNMP v3' }];
                        $scope.AuthProtocolOptions = [{ option: 'None' }, { option: 'MD5' }, { option: 'SHA' }];
                        $scope.PrivProtocolOptions = [{ option: 'None' }, { option: 'DES' }, { option: 'AES' }];

                        $scope.SetEnabled = function (option) {
                            $scope.tempSnmpHost.Enabled = option
                        }
                        $scope.SetSnmpVersion = function (option) {
                            if (option == "SNMP v3")
                                $scope.tempSnmpHost.SnmpVersion = 3;
                            else
                                $scope.tempSnmpHost.SnmpVersion = 2;// Default
                        }
                        $scope.SetAuthProtocol = function (option) {
                            if (option == "MD5")
                                $scope.tempSnmpHost.AuthProtocol = 1;
                            else if (option == "SHA")
                                $scope.tempSnmpHost.AuthProtocol = 2;
                            else
                                $scope.tempSnmpHost.AuthProtocol = 0;// Default
                        }
                        $scope.SetPrivProtocol = function (option) {
                            if (option == "DES")
                                $scope.tempSnmpHost.PrivProtocol = 1;
                            else if (option == "AES")
                                $scope.tempSnmpHost.PrivProtocol = 2;
                            else
                                $scope.tempSnmpHost.PrivProtocol = 0;// Default
                        }

                        // Apply button press - update the server
                        $scope.apply = function (EngineId) {
                            console.log("Sending: '/api/network/snmp/hosts data=" + JSON.stringify($scope.tempSnmpHost));
                            if ($scope.tempSnmpHost.SnmpVersion == 3) $scope.tempSnmpHost.Community = EngineId;
                            $http({
                                method: "put",
                                url: "/api/network/snmp/hosts",
                                data: $scope.tempSnmpHost
                            }).success(function (data) {
                                //console.log('AddSnmpHost PUT success data=' + JSON.stringify(data));
                                $modalInstance.close(data);
                            });
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    },
                    //#endregion Add SNMP Host controller
                });

                // Save the results from the modal to $scope data, so it will automatically update the UI
                modalInstance.result.then(function (SnmpHostsArray) {
                    $scope.SnmpHostsArray = SnmpHostsArray;
                    $scope.NumberOfSnmpHosts = SnmpHostsArray.length;
                }, function () {
                    console.log('Modal dismissed at: ' + new Date());
                });
            };
            //#endregion Add SNMP Host

            // Edit existing SNMP Host
            //#region Edit existing SNMP Host
            $scope.ConfigureSnmpHost = function (currentSnmpHost,EngineId) {
                console.log("Inside ConfigureSnmpHost")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/managesnmphost.html',
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = "Configure SNMP Host";
                        $scope.EngineId = EngineId;
                        $scope.tempSnmpHost = {
                            Id: currentSnmpHost.Id,
                            HostName: currentSnmpHost.HostName,
                            Enabled: currentSnmpHost.Enabled,
                            IpAddress: currentSnmpHost.IpAddress,
                            Port: currentSnmpHost.Port,
                            Community: currentSnmpHost.Community,
                            SnmpVersion: currentSnmpHost.SnmpVersion,
                            AuthUser: currentSnmpHost.AuthUser,
                            AuthPassword: currentSnmpHost.AuthPassword,
                            AuthProtocol: currentSnmpHost.AuthProtocol,
                            PrivPassword: currentSnmpHost.PrivPassword,
                            PrivProtocol: currentSnmpHost.PrivProtocol
                        };
                        $scope.HostNamePattern = /^[\w]{1,16}$/;
                        $scope.IpAddressPattern = /^((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/;
                        $scope.PortPattern = /^(6553[0-5]|655[0-2][0-9]\d|65[0-4](\d){2}|6[0-4](\d){3}|[1-5](\d){4}|[1-9](\d){0,3})$/;
                        $scope.AuthUserPattern = /^[a-zA-Z0-9\-]{4,16}$/;
                        $scope.AuthPasswordPattern = /^[a-zA-Z0-9]{8,16}$/;
                        $scope.PrivPasswordPattern = /^[a-zA-Z0-9]{8,16}$/;
                        if (currentSnmpHost.SnmpVersion == 3) {
                            $scope.CommunityPattern = /^[A-Z0-9\-]*$/;
                        } else {
                            $scope.CommunityPattern = /^[a-zA-Z0-9\-]{1,24}$/;
                        }

                        // List of possible options for updating the configuration
                        $scope.EnabledOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.SnmpVersionOptions = [{ option: 'SNMP v2C' }, { option: 'SNMP v3' }];
                        $scope.AuthProtocolOptions = [{ option: 'None' }, { option: 'MD5' }, { option: 'SHA' }];
                        $scope.PrivProtocolOptions = [{ option: 'None' }, { option: 'DES' }, { option: 'AES' }];

                        $scope.SetEnabled = function (option) {
                            $scope.tempSnmpHost.Enabled = option
                        }
                        $scope.SetSnmpVersion = function (option) {
                            if (option == "SNMP v3") {
                                $scope.tempSnmpHost.SnmpVersion = 3;
                                $scope.CommunityPattern = /^[A-Z0-9\-]*$/;
                            }
                            else {
                                $scope.tempSnmpHost.SnmpVersion = 2;// Default
                                $scope.CommunityPattern = /^[a-zA-Z0-9\-]{1,24}$/;
                            }
                        }
                        $scope.SetAuthProtocol = function (option) {
                            if (option == "MD5")
                                $scope.tempSnmpHost.AuthProtocol = 1;
                            else if (option == "SHA")
                                $scope.tempSnmpHost.AuthProtocol = 2;
                            else
                                $scope.tempSnmpHost.AuthProtocol = 0;// Default
                        }
                        $scope.SetPrivProtocol = function (option) {
                            if (option == "DES")
                                $scope.tempSnmpHost.PrivProtocol = 1;
                            else if (option == "AES")
                                $scope.tempSnmpHost.PrivProtocol = 2;
                            else
                                $scope.tempSnmpHost.PrivProtocol = 0;// Default
                        }

                        // Apply button press - update the server
                        $scope.apply = function (EngineId) {
                            console.log("Sending: '/api/network/snmp/hosts/" + currentSnmpHost.Id + " data=" + JSON.stringify($scope.tempSnmpHost));
                            if ($scope.tempSnmpHost.SnmpVersion == 3) $scope.tempSnmpHost.Community = EngineId;
                            $http({
                                method: "put",
                                url: "/api/network/snmp/hosts/" + currentSnmpHost.Id,
                                data: $scope.tempSnmpHost
                            }).success(function (data) {
                                //console.log('ConfigureSnmpHost PUT success data=' + JSON.stringify(data));
                                currentSnmpHost.HostName = data.HostName;
                                currentSnmpHost.Enabled = data.Enabled;
                                currentSnmpHost.IpAddress = data.IpAddress;
                                currentSnmpHost.Port = data.Port;
                                currentSnmpHost.Community = data.Community;
                                currentSnmpHost.SnmpVersion = data.SnmpVersion;
                                currentSnmpHost.AuthUser = data.AuthUser;
                                currentSnmpHost.AuthPassword = data.AuthPassword;
                                currentSnmpHost.AuthProtocol = data.AuthProtocol;
                                currentSnmpHost.PrivPassword = data.PrivPassword;
                                currentSnmpHost.PrivProtocol = data.PrivProtocol;
                            });
                            $modalInstance.close();
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });
            };
            //#endregion Edit existing SNMP Host

            // Delete a SNMP Host
            //#region Delete a SNMP Host
            //  /api/network/snmp/hosts/delete
            $scope.DeleteSnmpHost = function (currentSnmpHost) {
                console.log("Inside DeleteSnmpHost")
                $http({
                    method: "put",
                    url: "/api/network/snmp/hosts/delete",
                    data: currentSnmpHost
                })
                    .success(function (data) {
                        //console.log('DeleteSnmpHost success - data=' + JSON.stringify(data));
                        $scope.SnmpHostsArray = data;
                        $scope.NumberOfSnmpHosts = data.length;
                    })
            };
            //#endregion Delete a SNMP Host

            // Retreive the mib file
            //#region Retreive the mib file
            //  /api/network/snmp/mibfile
            $scope.GetSnmpMibFile = function () {
                $http({
                    method: "get",
                    url: "/api/network/snmp/mibfile"
                }).
                    success(function (data, status, headers, config) {
                        console.log("Inside GetSnmpMibFile - downloaded TASC-SUMMIT.MIB file!");
                        var anchor = angular.element('<a/>');
                        anchor.attr({
                            href: 'data:text/plain;charset=utf-8,' + data,
                            target: '_blank',
                            download: "TASC-SUMMIT.MIB"
                        })[0].click();
                    }).
                    error(function (data, status, headers, config) {
                        console.log("Error downloading TASC-SUMMIT.MIB file")
                    });
            }
            //#endregion Retreive the mib file

            //#endregion Network - SNMP tab

            //#region Network - Web Server tab
            //----------------------------------------------------------
            // Web Server
            //#endregion Network - Web Server tab            

        }
    ])
    //#endregion Network Manager Controller

    //#region Digital I/O Controller
    .controller('digitalioCtrl', [
        '$scope',
        '$http',
        '$modal',
        'socketManager',
        function ($scope, $http, $modal, socketManager) {

            //----------------------------------------------------------
            // General Initialization
            //#region General Initialization

            // Administrative controller stuff
            $scope.$on('$stateChangeSuccess', function () {
                console.log("Controller: digitalioCtrl");
            });
            $scope.$on('$destroy', function (event) {
                socketManager.removeAllListeners();
            });

            //----------------------------------------------------------
            // General values.
            $scope.ShowEnabled = true;

            $('#DigitalIoEnabledOnly').on('click', function () {
                $scope.ShowEnabled = false;
            })

            $('#DigitalIoAllDevices').on('click', function () {
                $scope.ShowEnabled = true;
            })
            //#endregion General Initialization

            //----------------------------------------------------------
            // Digital Inputs
            //#region Digital Inputs

            // Retreive Digital Input array through RESTful API
            $scope.GetDigitalInputs = function () {
                $http({
                    method: "get",
                    url: "/api/digitalinputs"
                })
                    .success(function (data) {
                        //console.log('GetDigitalInputs success');
                        $scope.DigitalInputs = data;
                        $scope.DigitalInputsTotal = data.length;
                        for (i = 0, enabled = 0; i < data.length; i++) {
                            if (data[i].Enabled == "TRUE") enabled++;
                        }
                        $scope.DigitalInputsEnabled = enabled;
                    })
            }
            $scope.GetDigitalInputs();// Go get digital inputs

            // Handle incoming socket.io updates            
            socketManager.on('DigitalInput', function (data) {
                //console.log('socketManager.on for DigitalInput Address=' + data.Address + " data=" + JSON.stringify(data));
                Address = data.Address
                $scope.DigitalInputs[Address].Name = data.Name
                $scope.DigitalInputs[Address].Value = data.Value
                $scope.DigitalInputs[Address].Enabled = data.Enabled
                $scope.DigitalInputs[Address].SendEvents = data.SendEvents
                $scope.DigitalInputs[Address].Polarity = data.Polarity
                $scope.DigitalInputs[Address].HoldTime = data.HoldTime
                $scope.DigitalInputs[Address].TimeChanged = data.TimeChanged
                if (data.Enabled = "TRUE") {
                    if (data.Value == "1") {
                        $('#IdDigitalInput' + Address + 'Value').html("ON");
                        $('#IdDigitalInput' + Address + 'Value').css('color', 'white');
                        $('#IdDigitalInput' + Address + 'Value').css('background-color', 'green');
                        $('#IdDigitalInput' + Address + 'Value').css('border-color', 'green');
                    } else {
                        $('#IdDigitalInput' + Address + 'Value').html("OFF");
                        $('#IdDigitalInput' + Address + 'Value').css('color', 'white');
                        $('#IdDigitalInput' + Address + 'Value').css('background-color', 'red');
                        $('#IdDigitalInput' + Address + 'Value').css('border-color', 'red');
                    }
                }
            });

            // Update the configuration information of the Digital Inputs
            socketManager.on('DigitalInputs', function (data) {
                console.log('socketManager.on for DigitalInputs');
                $scope.DigitalInputsTotal = data.DigitalInputsTotal;
                $scope.DigitalInputsEnabled = data.DigitalInputsEnabled;
            });

            // Update the hold time
            socketManager.on('DigitalInputHoldTime', function (data) {
                //console.log('socketManager.on for DigitalInputHoldTime data=' + JSON.stringify(data));
                if ($scope.DigitalInputs[data.DigitalInput].Enabled == "TRUE") {
                    if (data.HoldTime == "HOLDING") {
                        $('#IdDigitalInput' + data.DigitalInput + 'HoldTime').css('color', 'black');
                        $('#IdDigitalInput' + data.DigitalInput + 'HoldTime').css('background-color', '#ffff66');
                        $('#IdDigitalInput' + data.DigitalInput + 'HoldTime').css('border-color', '#ffff66');
                    } else if (data.HoldTime == "OFF") {
                        $('#IdDigitalInput' + data.DigitalInput + 'HoldTime').css('color', 'black');
                        $('#IdDigitalInput' + data.DigitalInput + 'HoldTime').css('background-color', 'lightgrey');
                        $('#IdDigitalInput' + data.DigitalInput + 'HoldTime').css('border-color', 'lightgrey');
                    } else if (data.HoldTime == "ON") {
                        $('#IdDigitalInput' + data.DigitalInput + 'HoldTime').css('color', 'white');
                        $('#IdDigitalInput' + data.DigitalInput + 'HoldTime').css('background-color', 'green');
                        $('#IdDigitalInput' + data.DigitalInput + 'HoldTime').css('border-color', 'green');
                    }
                }
            });

            // Configure Digital Input x
            //      currentDigitalInput = $scope.DigitalInputs[Address]
            //      tempDigitalInput = temporary value for this modal
            $scope.ConfigureDigitalInput = function (currentDigitalInput) {
                console.log("Inside ConfigureDigitalInput")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/configuredigitalinput.html',
                    controller: function ($scope, $modalInstance) {
                        console.log("Digital input selected=" + currentDigitalInput.Address);
                        $scope.modalTitle = "Configure Digital Input '" + currentDigitalInput.Name + "' at address=" + currentDigitalInput.Address;

                        // Create a copy of the current configuration during the configuration process
                        $scope.tempDigitalInput = angular.copy(currentDigitalInput);

                        // List of possible options for updating the configuration
                        $scope.EnabledOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.SendEventsOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.PolarityOptions = [{ option: 'Normally Open' }, { option: 'Normally Closed' }];
                        $scope.HoldTimeOptions = [{ option: '0' }, { option: '1' }, { option: '2' }, { option: '3' }, { option: '4' }, { option: '5' }];

                        // Accept changes to the configuration into the temp variable
                        $scope.SetEnabled = function (option) {
                            $scope.tempDigitalInput.Enabled = option
                        }
                        $scope.SetSendEvents = function (option) {
                            $scope.tempDigitalInput.SendEvents = option
                        }
                        $scope.SetPolarity = function (option) {
                            $scope.tempDigitalInput.Polarity = option
                        }
                        $scope.SetHoldTime = function (option) {
                            $scope.tempDigitalInput.HoldTime = parseInt(option)
                        }

                        // Apply button press - update the server
                        $scope.apply = function () {
                            $scope.tempDigitalInput.Name = $scope.tempDigitalInput.Name.substring(0, 16);// Temporary fix for long strings
                            console.log("Sending: '/api/digitalinputs/" + $scope.tempDigitalInput.Address + "'");
                            console.log("tempDigitalInput=" + JSON.stringify($scope.tempDigitalInput));
                            $http({
                                method: "put",
                                url: "/api/digitalinputs/" + currentDigitalInput.Address,
                                data: $scope.tempDigitalInput
                            }).success(function (data) {
                                //console.log('ConfigureDigitalInput success');
                                //console.log('ConfigureDigitalInput: data=' + JSON.stringify(data));
                                Address = data.Address
                                currentDigitalInput.Name = data.Name;
                                currentDigitalInput.Value = data.Value;
                                currentDigitalInput.Enabled = data.Enabled;
                                currentDigitalInput.SendEvents = data.SendEvents;
                                currentDigitalInput.Polarity = data.Polarity;
                                currentDigitalInput.HoldTime = data.HoldTime;
                                currentDigitalInput.TimeChanged = data.TimeChanged;

                                if (currentDigitalInput.Enabled === "TRUE") {
                                    if (currentDigitalInput.Value === "1") {
                                        $('#IdDigitalInput' + Address + 'Value').html("ON");
                                        $('#IdDigitalInput' + Address + 'Value').css('color', 'white');
                                        $('#IdDigitalInput' + Address + 'Value').css('background-color', 'green');
                                        $('#IdDigitalInput' + Address + 'Value').css('border-color', 'green');
                                    }
                                    else {
                                        $('#IdDigitalInput' + Address + 'Value').html("OFF");
                                        $('#IdDigitalInput' + Address + 'Value').css('color', 'white');
                                        $('#IdDigitalInput' + Address + 'Value').css('background-color', 'red');
                                        $('#IdDigitalInput' + Address + 'Value').css('border-color', 'red');
                                    }
                                } else {
                                    $('#IdDigitalInput' + Address + 'Value').html("--");
                                    $('#IdDigitalInput' + Address + 'Value').css('color', 'white');
                                    $('#IdDigitalInput' + Address + 'Value').css('background-color', 'grey');
                                    $('#IdDigitalInput' + Address + 'Value').css('border-color', 'grey');
                                }
                            });
                            $modalInstance.close();
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });
            };
            //#endregion Digital Inputs

            //----------------------------------------------------------
            // Digital Outputs
            //#region Digital Outputs

            // Retreive Digital Output array through RESTful API
            $scope.GetDigitalOutputs = function () {
                $http({
                    method: "get",
                    url: "/api/digitaloutputs"
                })
                    .success(function (data) {
                        //console.log('GetDigitalOutputs success length=' + data.length);
                        $scope.DigitalOutputs = data;
                        $scope.DigitalOutputsTotal = data.length;
                        for (i = 0, enabled = 0; i < data.length; i++) {
                            if (data[i].Enabled == "TRUE") enabled++;
                        }
                        $scope.DigitalOutputsEnabled = enabled;
                    })
            }
            $scope.GetDigitalOutputs();// Go get digital outputs

            // Handle incoming socket.io updates            
            socketManager.on('DigitalOutput', function (data) {
                //console.log('socketManager.on for DigitalOutput Address=' + data.Address);
                Address = data.Address
                $scope.DigitalOutputs[data.Address].Name = data.Name
                $scope.DigitalOutputs[data.Address].Value = data.Value
                $scope.DigitalOutputs[data.Address].Enabled = data.Enabled
                $scope.DigitalOutputs[data.Address].SendEvents = data.SendEvents
                $scope.DigitalOutputs[data.Address].Polarity = data.Polarity
                $scope.DigitalOutputs[data.Address].ActionType = data.ActionType
                $scope.DigitalOutputs[data.Address].TimeChanged = data.TimeChanged
                if (data.Enabled === "TRUE") {
                    if (data.Value == "1") {
                        $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Set').html("Turn OFF");
                        $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Value').html("ON");
                        $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Value').css('color', 'white');
                        $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Value').css('background-color', 'green');
                        $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Value').css('border-color', 'green');
                    } else {
                        $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Set').html("Turn ON");
                        $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Value').html("OFF");
                        $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Value').css('color', 'white');
                        $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Value').css('background-color', 'red');
                        $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Value').css('border-color', 'red');
                    }
                    // Hard-coded switch back to Primary from grey or unknown
                    $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Set').css("color", " #fff");
                    $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Set').css("background-color", '#f0ad4e');
                    $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Set').css("border-color", '#f0ad4e');
                }
                else {
                    $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Set').html("--");
                    $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Set').css("color", "white");
                    $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Set').css("background-color", 'grey');
                    $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Set').css("border-color", 'grey');
                    $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Value').html("--");
                    $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Value').css('color', 'white');
                    $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Value').css('background-color', 'grey');
                    $('#IdDigitalOutput' + $scope.DigitalOutputs[Address].Address + 'Value').css('border-color', 'grey');
                }
            });

            // Update the configuration Outformation of the Digital Outputs
            socketManager.on('DigitalOutputs', function (data) {
                //console.log('socketManager.on for DigitalOutputs');
                $scope.DigitalOutputsTotal = data.DigitalOutputsTotal;
                $scope.DigitalOutputsEnabled = data.DigitalOutputsEnabled;
            });

            // Set Digital Output x value            
            $scope.SetDigitalOutputValue = function (output) {
                if ($scope.DigitalOutputs[output].Enabled === "TRUE") {
                    if ($scope.DigitalOutputs[output].Value == "1")
                        sendValue = "0";
                    else
                        sendValue = "1";
                    $http({
                        method: "put",
                        url: "/api/digitaloutputs/" + output + "/" + sendValue
                    }).success(function (data) {
                        //console.log('SetDigitalOutputValue success');
                    });
                    //$event.preventDefault();
                }
            }

            // Configure Digital Output x
            $scope.ConfigureDigitalOutput = function (currentDigitalOutput) {
                console.log("Inside ConfigureDigitalOutput")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/configuredigitaloutput.html',
                    controller: function ($scope, $modalInstance) {
                        console.log("Digital Output selected=" + currentDigitalOutput.Address);
                        $scope.modalTitle = "Configure Digital Output '" + currentDigitalOutput.Name + "' at address=" + currentDigitalOutput.Address;

                        // Create a copy of the current configuration during the configuration process
                        $scope.tempDigitalOutput = angular.copy(currentDigitalOutput);

                        // List of possible options for updating the configuration
                        $scope.EnabledOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.SendEventsOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.PolarityOptions = [{ option: 'Normally Open' }, { option: 'Normally Closed' }];
                        $scope.ActionTypeOptions = [{ option: 'Latched' }];

                        // Accept changes to the configuration into the temp variable
                        $scope.SetEnabled = function (option) {
                            $scope.tempDigitalOutput.Enabled = option
                        }
                        $scope.SetSendEvents = function (option) {
                            $scope.tempDigitalOutput.SendEvents = option
                        }
                        $scope.SetPolarity = function (option) {
                            $scope.tempDigitalOutput.Polarity = option
                        }
                        $scope.SetActionType = function (option) {
                            $scope.tempDigitalOutput.ActionType = option
                        }

                        // Apply button press - update the server
                        $scope.apply = function () {
                            $scope.tempDigitalOutput.Name = $scope.tempDigitalOutput.Name.substring(0, 16);// Temporary fix for long strings
                            console.log("Sending: '/api/digitaloutputs/" + $scope.tempDigitalOutput.Address + "'");
                            console.log("tempDigitalOutput=" + JSON.stringify($scope.tempDigitalOutput));

                            $http({
                                method: "put",
                                url: "/api/digitalOutputs/" + currentDigitalOutput.Address,
                                data: $scope.tempDigitalOutput
                            }).success(function (data) {
                                //console.log('ConfigureDigitalOutput success');
                                currentDigitalOutput.Name = data.Name;
                                currentDigitalOutput.Enabled = data.Enabled;
                                currentDigitalOutput.SendEvents = data.SendEvents;
                                currentDigitalOutput.Polarity = data.Polarity;
                                currentDigitalOutput.ActionType = data.ActionType;

                                if (currentDigitalOutput.Enabled === "TRUE") {
                                    if (currentDigitalOutput.Value === "1") {
                                        $('#IdDigitalOutput' + data.Address + 'Set').html("Turn OFF");
                                        $('#IdDigitalOutput' + data.Address + 'Value').html("ON");
                                        $('#IdDigitalOutput' + data.Address + 'Value').css('color', 'white');
                                        $('#IdDigitalOutput' + data.Address + 'Value').css('background-color', 'green');
                                        $('#IdDigitalOutput' + data.Address + 'Value').css('border-color', 'green');
                                    }
                                    else {
                                        $('#IdDigitalOutput' + data.Address + 'Set').html("Turn ON");
                                        $('#IdDigitalOutput' + data.Address + 'Value').html("OFF");
                                        $('#IdDigitalOutput' + data.Address + 'Value').css('color', 'white');
                                        $('#IdDigitalOutput' + data.Address + 'Value').css('background-color', 'red');
                                        $('#IdDigitalOutput' + data.Address + 'Value').css('border-color', 'red');
                                    }
                                    // Hard-coded switch back to Primary from grey or unknown
                                    $('#IdDigitalOutput' + data.Address + 'Set').css("color", " #fff");
                                    $('#IdDigitalOutput' + data.Address + 'Set').css("background-color", '#f0ad4e');
                                    $('#IdDigitalOutput' + data.Address + 'Set').css("border-color", '#f0ad4e');
                                } else {
                                    $('#IdDigitalOutput' + data.Address + 'Value').html("--");
                                    $('#IdDigitalOutput' + data.Address + 'Value').css('color', 'white');
                                    $('#IdDigitalOutput' + data.Address + 'Value').css('background-color', 'grey');
                                    $('#IdDigitalOutput' + data.Address + 'Value').css('border-color', 'grey');
                                    $('#IdDigitalOutput' + data.Address + 'Set').html("--");
                                    $('#IdDigitalOutput' + data.Address + 'Set').css("color", "white");
                                    $('#IdDigitalOutput' + data.Address + 'Set').css("background-color", 'grey');
                                    $('#IdDigitalOutput' + data.Address + 'Set').css("border-color", 'grey');
                                }
                            });
                            $modalInstance.close();
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });
            };
            //#endregion Digital Outputs

        }
    ])
    //#endregion Digital I/O Controller

    //#region Analog I/O Controller
    .controller('analogioCtrl', [
        '$scope',
        '$modal',
        '$http',
        'socketManager',
        function ($scope, $modal, $http, socketManager) {

            //----------------------------------------------------------
            // General Initialization
            //#region General Initialization
            $scope.$on('$stateChangeSuccess', function () {
                console.log("Controller: analogioCtrl");
            });
            $scope.$on('$destroy', function (event) {
                socketManager.removeAllListeners();
            });

            $scope.ShowEnabled = true;

            $('#AnalogIoEnabledOnly').on('click', function () {
                $scope.ShowEnabled = false;
            })

            $('#AnalogIoAllDevices').on('click', function () {
                $scope.ShowEnabled = true;
            })
            //#endregion General Initialization

            //----------------------------------------------------------
            // Analog Inputs
            //#region Analog Inputs

            // Retreive the Summit Users
            //  /api/login/users
            $scope.GetSummitUser = function () {
                console.log("Inside GetSummitUser ...")
                $http({
                    method: "get",
                    url: "/api/login/localconfig"
                })
                    .success(function (data) {
                        //console.log('Get GetSummitUser success');
                        // Do something with the data
                        $scope.TASCQA = data.user;
                    })
            }
            $scope.GetSummitUser();// Go get Log Files

            // Retreive FormulasArray & Analog Input array through RESTful API
            //#region GetFormulasAndAnalogInputs
            $scope.FormulasArray = [];
            $scope.AnalogInputs = [];
            $scope.GetFormulasAndAnalogInputs = function () {
                $http({
                    method: "get",
                    url: "/api/formulas"
                })
                    .success(function (data) {
                        //console.log('GetFormulas success');
                        $scope.FormulasArray = data;
                        $scope.FormulasTotal = data.length;

                        $http({
                            method: "get",
                            url: "/api/analoginputs"
                        })
                            .success(function (data) {
                                //console.log('GetAnalogInputs success');
                                $scope.AnalogInputs = data;
                                $scope.AnalogInputsTotal = data.length;
                                for (var i = 0, enabled = 0; i < data.length; i++) {
                                    if (data[i].Enabled == "TRUE") enabled++;
                                }
                                $scope.AnalogInputsEnabled = enabled;
                            })
                    })
            }
            $scope.GetFormulasAndAnalogInputs();// Get formulas now
            //#endregion GetFormulasAndAnalogInputs

            // Handle incoming socket.io updates
            //#region Socket Message: AnalogInput
            socketManager.on('AnalogInput', function (data) {
                //console.log("socketManager.on: 'AnalogInput' - Address=" + data.Address);
                Address = data.Address
                //console.log("SocketOn 'AnalogInput': data=" + JSON.stringify(data));
                $scope.AnalogInputs[Address].Name = data.Name
                $scope.AnalogInputs[Address].RawValue = data.RawValue
                $scope.AnalogInputs[Address].RangedValue = data.RangedValue
                $scope.AnalogInputs[Address].FormulaValue = data.FormulaValue
                $scope.AnalogInputs[Address].FormulaId = data.FormulaId
                $scope.AnalogInputs[Address].FormulaEnabled = data.FormulaEnabled;
                $scope.AnalogInputs[Address].Enabled = data.Enabled
                $scope.AnalogInputs[Address].SendEvents = data.SendEvents
                $scope.AnalogInputs[Address].LowThreshold = Number(data.LowThreshold).toFixed(2)
                $scope.AnalogInputs[Address].HighThreshold = Number(data.HighThreshold).toFixed(2)
                $scope.AnalogInputs[Address].FormulaLowThreshold = data.FormulaLowThreshold
                $scope.AnalogInputs[Address].FormulaHighThreshold = data.FormulaHighThreshold
                $scope.AnalogInputs[Address].Offset = data.Offset
                $scope.AnalogInputs[Address].HoldTime = data.HoldTime
                $scope.AnalogInputs[Address].Qualifier = data.Qualifier
                $scope.AnalogInputs[Address].QualifierValue = data.QualifierValue
                $scope.AnalogInputs[Address].TimeChanged = data.TimeChanged
                $scope.AnalogInputs[Address].ThresholdState = data.ThresholdState

                $scope.UpdateAnalogInputsDisplay(Address);
            });
            //#endregion Socket Message: AnalogInput

            //#region Socket Message: AnalogInputs
            socketManager.on('AnalogInputs', function (data) {
                //console.log("socketManager.on: 'AnalogInputs' - length=" + data.AnalogInputs.length);
                for (var address = 0; address < data.AnalogInputs.length; address++) {
                    $scope.AnalogInputs[address].Name = data.AnalogInputs[address].Name
                    $scope.AnalogInputs[address].RawValue = data.AnalogInputs[address].RawValue
                    $scope.AnalogInputs[address].RangedValue = data.AnalogInputs[address].RangedValue
                    $scope.AnalogInputs[address].FormulaValue = data.AnalogInputs[address].FormulaValue
                    $scope.AnalogInputs[address].FormulaId = data.AnalogInputs[address].FormulaId
                    $scope.AnalogInputs[address].FormulaEnabled = data.AnalogInputs[address].FormulaEnabled;
                    $scope.AnalogInputs[address].Enabled = data.AnalogInputs[address].Enabled
                    $scope.AnalogInputs[address].SendEvents = data.AnalogInputs[address].SendEvents
                    $scope.AnalogInputs[address].LowThreshold = Number(data.AnalogInputs[address].LowThreshold).toFixed(2)
                    $scope.AnalogInputs[address].HighThreshold = Number(data.AnalogInputs[address].HighThreshold).toFixed(2)
                    $scope.AnalogInputs[address].FormulaLowThreshold = data.AnalogInputs[address].FormulaLowThreshold
                    $scope.AnalogInputs[address].FormulaHighThreshold = data.AnalogInputs[address].FormulaHighThreshold
                    $scope.AnalogInputs[address].Offset = data.AnalogInputs[address].Offset
                    $scope.AnalogInputs[address].HoldTime = data.AnalogInputs[address].HoldTime
                    $scope.AnalogInputs[address].Qualifier = data.AnalogInputs[address].Qualifier
                    $scope.AnalogInputs[address].QualifierValue = data.AnalogInputs[address].QualifierValue
                    $scope.AnalogInputs[address].TimeChanged = data.AnalogInputs[address].TimeChanged
                    $scope.AnalogInputs[address].ThresholdState = data.AnalogInputs[address].ThresholdState
                    $scope.UpdateAnalogInputsDisplay(address);

                    //#region Step 1 for QA: Calculate High, Low, Average                   
                    $scope.AnalogInputsAverageTotal = 0;
                    $scope.AnalogInputsAverageCount = 0;
                    $scope.AnalogInputsHigh = Number(0.0);
                    $scope.AnalogInputsLow = Number(99.9);
                    $scope.AnalogInputsHighPoint = 0;
                    $scope.AnalogInputsLowPoint = 0;
                    for (var i = 0; i < data.AnalogInputs.length; i++) {
                        $scope.AnalogInputsAverageTotal += Number(data.AnalogInputs[i].RangedValue);
                        $scope.AnalogInputsAverageCount++;
                        if (Number(data.AnalogInputs[i].RangedValue) > $scope.AnalogInputsHigh) {
                            $scope.AnalogInputsHigh = Number(data.AnalogInputs[i].RangedValue)
                            $scope.AnalogInputsHighPoint = i + 1;
                        }
                        if (Number(data.AnalogInputs[i].RangedValue) < $scope.AnalogInputsLow) {
                            $scope.AnalogInputsLow = Number(data.AnalogInputs[i].RangedValue)
                            $scope.AnalogInputsLowPoint = i + 1;
                        }
                    }
                    $scope.AnalogInputsAverage = Number(($scope.AnalogInputsAverageTotal / $scope.AnalogInputsAverageCount)).toFixed(2);
                    $scope.AnalogInputsAverageTotal = Number(($scope.AnalogInputsAverageTotal)).toFixed(3);
                    $scope.AnalogInputsAverageCount = ($scope.AnalogInputsAverageCount).toFixed(0);
                    $scope.AnalogInputsHigh = Number($scope.AnalogInputsHigh).toFixed(2);
                    $scope.AnalogInputsLow = Number($scope.AnalogInputsLow).toFixed(2);
                    //#endregion Step 1 for QA: Calculate High, Low, Average

                    //#region Step 2 for QA: Figure out Standard Deviation
                    var total = 0.0;
                    for (var i = 0; i < data.AnalogInputs.length; i++) {
                        v1 = Math.pow((parseFloat(data.AnalogInputs[i].RangedValue) - $scope.AnalogInputsAverage), 2);
                        total += v1;
                    }
                    $scope.AnalogInputsStandardDeviation = Math.sqrt(Number(total) / $scope.AnalogInputsAverageCount).toFixed(3);
                    $scope.AnalogInputsStandardDeviationWithinRange = true;
                    $scope.AnalogInputsStdDevPercentage = (Number($scope.AnalogInputsStandardDeviation) / Number($scope.AnalogInputsAverage) * 100).toFixed(2);
                    if ($scope.AnalogInputsStdDevPercentage > 2) $scope.AnalogInputsStandardDeviationWithinRange = false;
                    //#endregion Step 2 for QA: Figure out Standard Deviation

                    //#region Step 3 for QA: Figure out list of Analog Points outside of the allowable StdDev range
                    $scope.AnalogInputsFailureList = [];
                    for (var i = 0; i < data.AnalogInputs.length; i++) {
                        diff = Math.abs(Number(data.AnalogInputs[i].RangedValue) - $scope.AnalogInputsAverage);
                        diffPercent = (diff / $scope.AnalogInputsAverage) * 100;
                        if (diffPercent > 2 ? pass = false : pass = true);
                        $scope.AnalogInputsFailureList.push({ Pass: pass, Address: (i + 1), Value: Number(data.AnalogInputs[i].RangedValue).toFixed(2), Diff: Number(diff).toFixed(2), DiffPercent: Number(diffPercent).toFixed(2) });
                        //console.log("Analog Input " + (i + 1) + "=" + Number(data.AnalogInputs[i].RangedValue).toFixed(2));
                    }
                    //#endregion Step 3 for QA: Figure out list of Analog Points outside of the allowable StdDev range
                }
            });
            //#endregion Socket Message: AnalogInputs

            //#region Socket Message: AnalogInputQualifier
            socketManager.on('AnalogInputQualifier', function (data) {
                //console.log('socketManager.on for AnalogInputQualifier data=' + JSON.stringify(data));
                if ($scope.AnalogInputs[data.AnalogInput].Enabled == "TRUE") {
                    if (data.Qualifier == true) {
                        console.log("data.Qualifier==true")
                        $('#IdAnalogInput' + data.AnalogInput + 'Qualifier').css('color', 'white');
                        $('#IdAnalogInput' + data.AnalogInput + 'Qualifier').css('background-color', 'green');
                        $('#IdAnalogInput' + data.AnalogInput + 'Qualifier').css('border-color', 'green');
                    } else {
                        console.log("data.Qualifier==false")
                        $('#IdAnalogInput' + data.AnalogInput + 'Qualifier').css('color', 'black');
                        $('#IdAnalogInput' + data.AnalogInput + 'Qualifier').css('background-color', 'lightgrey');
                        $('#IdAnalogInput' + data.AnalogInput + 'Qualifier').css('border-color', 'lightgrey');
                    }
                }
            });
            //#endregion Socket Message: AnalogInputQualifier

            //#region Socket Message: AnalogInputHoldTime
            socketManager.on('AnalogInputHoldTime', function (data) {
                //console.log('socketManager.on for AnalogInputHoldTime data=' + JSON.stringify(data));
                if ($scope.AnalogInputs[data.AnalogInput].Enabled == "TRUE") {
                    if (data.HoldTime == "HOLDING") {
                        $('#IdAnalogInput' + data.AnalogInput + 'HoldTime').css('color', 'black');
                        $('#IdAnalogInput' + data.AnalogInput + 'HoldTime').css('background-color', '#ffff66');
                        $('#IdAnalogInput' + data.AnalogInput + 'HoldTime').css('border-color', '#ffff66');
                    } else if (data.HoldTime == "OFF") {
                        $('#IdAnalogInput' + data.AnalogInput + 'HoldTime').css('color', 'black');
                        $('#IdAnalogInput' + data.AnalogInput + 'HoldTime').css('background-color', 'lightgrey');
                        $('#IdAnalogInput' + data.AnalogInput + 'HoldTime').css('border-color', 'lightgrey');
                    } else if (data.HoldTime == "ON") {
                        $('#IdAnalogInput' + data.AnalogInput + 'HoldTime').css('color', 'white');
                        $('#IdAnalogInput' + data.AnalogInput + 'HoldTime').css('background-color', 'green');
                        $('#IdAnalogInput' + data.AnalogInput + 'HoldTime').css('border-color', 'green');
                    }
                }
            });
            //#endregion Socket Message: AnalogInputHoldTime

            //#region Socket Message: AnalogInputsConfigured
            socketManager.on('AnalogInputsConfigured', function (data) {
                //console.log('socketManager.on for AnalogInputs');
                $scope.AnalogInputsTotal = data.AnalogInputsTotal;
                $scope.AnalogInputsEnabled = data.AnalogInputsEnabled;
            });
            //#endregion Socket Message: AnalogInputsConfigured

            //#region UpdateAnalogInputsDisplay
            $scope.UpdateAnalogInputsDisplay = function (Address) {
                if ($scope.AnalogInputs[Address].Enabled === "TRUE") {
                    //console.log("AnalogInput event: AnalogInput[" + Address + "] RawValue=" + $scope.AnalogInputs[Address].RawValue + " RangedValue=" + $scope.AnalogInputs[Address].RangedValue + " FormulaValue=" + $scope.AnalogInputs[Address].FormulaValue + " Threshold State=" + $scope.AnalogInputs[Address].ThresholdState);

                    // Show the value as green (in range) or red (out of range)
                    $('#IdAnalogInput' + Address + 'Value').css('color', 'white');
                    if ($scope.AnalogInputs[Address].ThresholdState === 0) {
                        $('#IdAnalogInput' + Address + 'Value').css('background-color', 'green');
                        $('#IdAnalogInput' + Address + 'Value').css('border-color', 'green');
                    } else if ($scope.AnalogInputs[Address].ThresholdState != -1) {
                        $('#IdAnalogInput' + Address + 'Value').css('background-color', 'red');
                        $('#IdAnalogInput' + Address + 'Value').css('border-color', 'red');
                    }

                    // Show RangedValue or FormulaValues
                    var Value, LowThreshold, HighThreshold;
                    if ($scope.AnalogInputs[Address].FormulaEnabled === 1 && $scope.AnalogInputs[Address].FormulaId !== -1) {
                        // If we're using a formula, then change from Ranged Value to Formula Value
                        var FormulaIndex = -1;
                        for (var f = 0; f < $scope.FormulasArray.length; f++) {
                            if ($scope.AnalogInputs[Address].FormulaId === $scope.FormulasArray[f].Id) {
                                FormulaIndex = f;
                                break;
                            }
                        }

                        // Show formula'd FormulaValue
                        Value = Number($scope.AnalogInputs[Address].FormulaValue).toFixed($scope.FormulasArray[FormulaIndex].Decimals);
                        $('#IdAnalogInput' + Address + 'Value').html(Value + " " + $scope.FormulasArray[FormulaIndex].Units);

                        // Show formula'd LowThreshold and HighThreshold
                        LowThreshold = Number($scope.AnalogInputs[Address].FormulaLowThreshold).toFixed($scope.FormulasArray[FormulaIndex].Decimals);
                        $('#IdAnalogInput' + Address + 'LowThreshold').html(LowThreshold + " " + $scope.FormulasArray[FormulaIndex].Units);
                        HighThreshold = Number($scope.AnalogInputs[Address].FormulaHighThreshold).toFixed($scope.FormulasArray[FormulaIndex].Decimals);
                        $('#IdAnalogInput' + Address + 'HighThreshold').html(HighThreshold + " " + $scope.FormulasArray[FormulaIndex].Units);

                        // Show formula name
                        $('#IdAnalogInput' + Address + 'Formula').html($scope.FormulasArray[FormulaIndex].Name);
                    } else {
                        // Show formula-less RangedValue
                        $('#IdAnalogInput' + Address + 'Value').html($scope.AnalogInputs[Address].RangedValue + " Volts");

                        // Show formula-less LowThreshold and HighThreshold
                        LowThreshold = Number($scope.AnalogInputs[Address].LowThreshold).toFixed(2);
                        $('#IdAnalogInput' + Address + 'LowThreshold').html(LowThreshold + " Volts");
                        HighThreshold = Number($scope.AnalogInputs[Address].HighThreshold).toFixed(2);
                        $('#IdAnalogInput' + Address + 'HighThreshold').html(HighThreshold + " Volts");
                    }
                } else {
                    if ($scope.AnalogInputs[Address].FormulaId !== -1) {
                        // If we're using a formula, then change from Ranged Value to Formula Value
                        var FormulaIndex = -1;
                        for (var f = 0; f < $scope.FormulasArray.length; f++) {
                            if ($scope.AnalogInputs[Address].FormulaId === $scope.FormulasArray[f].Id) {
                                FormulaIndex = f;
                                break;
                            }
                        }

                        // Show formula name
                        $('#IdAnalogInput' + i + 'Formula').html($scope.FormulasArray[FormulaIndex].Name);
                    }

                    // Analog Input display
                    $('#IdAnalogInput' + Address + 'Value').html("--");
                    $('#IdAnalogInput' + Address + 'Value').css('color', 'white');
                    $('#IdAnalogInput' + Address + 'Value').css('background-color', 'grey');
                    $('#IdAnalogInput' + Address + 'Value').css('border-color', 'grey');

                    // Show LowThreshold and HighThreshold
                    $('#IdAnalogInput' + Address + 'LowThreshold').html("--");
                    $('#IdAnalogInput' + Address + 'HighThreshold').html("--");
                }
            }
            //#endregion UpdateAnalogInputsDisplay

            //#region ToggleFormulaEnabled
            $scope.ToggleFormulaEnabled = function (Address) {

                if ($scope.AnalogInputs[Address].FormulaEnabled === 1) {
                    // Previously was enabled, now disable
                    $scope.AnalogInputs[Address].FormulaEnabled = 0;
                } else {
                    // Previously was disabled, now enable
                    $scope.AnalogInputs[Address].FormulaEnabled = 1;
                }

                // Update server, this will result in a new socket message
                $http({
                    method: "put",
                    url: "/api/analoginputs/" + Address,
                    data: $scope.AnalogInputs[Address]
                }).success(function (data) {
                    //console.log('ConfigureAnalogInput success');
                    Address = data.Address
                    $scope.AnalogInputs[Address].Name = data.Name
                    $scope.AnalogInputs[Address].RawValue = data.RawValue
                    $scope.AnalogInputs[Address].FormulaId = data.FormulaId;
                    $scope.AnalogInputs[Address].FormulaEnabled = data.FormulaEnabled;
                    $scope.AnalogInputs[Address].RangedValue = data.RangedValue;
                    $scope.AnalogInputs[Address].FormulaValue = data.FormulaValue
                    $scope.AnalogInputs[Address].Enabled = data.Enabled;
                    $scope.AnalogInputs[Address].SendEvents = data.SendEvents;
                    $scope.AnalogInputs[Address].FormulaId = data.FormulaId;
                    $scope.AnalogInputs[Address].LowThreshold = Number(data.LowThreshold).toFixed(2)
                    $scope.AnalogInputs[Address].HighThreshold = Number(data.HighThreshold).toFixed(2)
                    $scope.AnalogInputs[Address].FormulaLowThreshold = data.FormulaLowThreshold;
                    $scope.AnalogInputs[Address].FormulaHighThreshold = data.FormulaHighThreshold;
                    $scope.AnalogInputs[Address].Offset = data.Offset
                    $scope.AnalogInputs[Address].HoldTime = data.HoldTime;
                    $scope.AnalogInputs[Address].Qualifier = data.Qualifier;
                    $scope.AnalogInputs[Address].ThresholdState = data.ThresholdState;

                    $scope.UpdateAnalogInputsDisplay(Address);
                });
            }
            //#endregion ToggleFormulaEnabled

            //#region Configure Analog Input
            $scope.ConfigureAnalogInput = function (currentAnalogInput, FormulasArray) {
                console.log("Inside ConfigureAnalogInput")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/configureanaloginput.html',
                    controller: function ($scope, $modalInstance) {
                        console.log("Analog input selected=" + JSON.stringify(currentAnalogInput) + " FormulasArray=" + JSON.stringify(FormulasArray));
                        $scope.modalTitle = "Configure Analog Input '" + currentAnalogInput.Name + "' at address=" + currentAnalogInput.Address;

                        // Create a copy of the current configuration during the configuration process
                        $scope.tempAnalogInput = {
                            Address: currentAnalogInput.Address,
                            Name: currentAnalogInput.Name,
                            RawValue: currentAnalogInput.RawValue,
                            RangedValue: currentAnalogInput.RangedValue,
                            NamePattern: /^[\w ]{1,16}$/,
                            Enabled: currentAnalogInput.Enabled,
                            SendEvents: currentAnalogInput.SendEvents,
                            FormulaId: currentAnalogInput.FormulaId,
                            FormulaEnabled: currentAnalogInput.FormulaEnabled,
                            LowThreshold: Number(currentAnalogInput.LowThreshold).toFixed(2),
                            LowThresholdPattern: /^(((([0-9]|[1][0-9]|[2][0-4]){0,1}(\.[0-9]{0,2}){0,1})|((25)(\.[0]{0,2}){0,1})))$/,
                            HighThreshold: Number(currentAnalogInput.HighThreshold).toFixed(2),
                            HighThresholdPattern: /^(((([0-9]|[1][0-9]|[2][0-4]){0,1}(\.[0-9]{0,2}){0,1})|((25)(\.[0]{0,2}){0,1})))$/,
                            ThresholdState: currentAnalogInput.ThresholdState,
                            Offset: currentAnalogInput.Offset,
                            HoldTime: currentAnalogInput.HoldTime,
                            Qualifier: currentAnalogInput.Qualifier,
                            QualifierPattern: /^([\d]|[1-3]\d|[4][0-8])$/,
                            ThresholdState: currentAnalogInput.ThresholdState,
                            TimeChanged: currentAnalogInput.TimeChanged,
                            // Added just for completeness
                            FormulaValue: currentAnalogInput.FormulaValue,
                            FormulaLowThreshold: currentAnalogInput.FormulaLowThreshold,
                            FormulaHighThreshold: currentAnalogInput.FormulaHighThreshold,
                        };

                        // List of possible options for updating the configuration
                        $scope.EnabledOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.SendEventsOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.OffsetOptions = [{ option: '-0.5' }, { option: '-0.4' }, { option: '-0.3' }, { option: '-0.2' }, { option: '-0.1' },
                        { option: '0.0' }, { option: '0.1' }, { option: '0.2' }, { option: '0.3' }, { option: '0.4' }, { option: '0.5' }];
                        $scope.HoldTimeOptions = [{ option: '0' }, { option: '1' }, { option: '2' }, { option: '3' }, { option: '4' }, { option: '5' }];

                        $scope.FormulaOptions = [];
                        $scope.FormulaOptions.push({ Id: -1, Name: "[No Formula]" });// Make no formula an option
                        // Load up the FormulaOptions based on the FormulasArray
                        for (var i = 0; i < FormulasArray.length; i++) {
                            $scope.FormulaOptions.push({ Id: FormulasArray[i].Id, Name: FormulasArray[i].Name });
                        }

                        // Default option: Show either [No Formula] or the selected name                            
                        $scope.SelectedFormulaName = "[No Formula]";
                        if (currentAnalogInput.FormulaId !== -1) {
                            // Find the index of the selected formula
                            var SelectedIdIndex = -1;
                            for (var i = 0; i < FormulasArray.length; i++) {
                                if (FormulasArray[i].Id == currentAnalogInput.FormulaId) {
                                    SelectedIdIndex = i;// Found it!
                                    break;
                                }
                            }
                            // If we found it, then 
                            if (SelectedIdIndex !== -1) {
                                $scope.SelectedFormulaName = FormulasArray[SelectedIdIndex].Name;
                                $scope.SelectedFormulaUnits = FormulasArray[SelectedIdIndex].Units;
                                $scope.SelectedFormulaIndex = SelectedIdIndex;
                            }
                        }

                        // Accept changes to the configuration into the temp variable
                        $scope.SetEnabled = function (option) {
                            $scope.tempAnalogInput.Enabled = option
                        }
                        $scope.SetSendEvents = function (option) {
                            $scope.tempAnalogInput.SendEvents = option
                        }
                        $scope.SetOffset = function (option) {
                            $scope.tempAnalogInput.Offset = option
                        }
                        $scope.SetHoldTime = function (option) {
                            $scope.tempAnalogInput.HoldTime = parseInt(option)
                        }
                        $scope.SetFormulaId = function (Id) {
                            $scope.tempAnalogInput.FormulaId = Id;// Change the formula Id

                            // Adjust the name of the selected Id to either 
                            //  [No Formula] for Id = -1 or the [<selected name>] for Id != -1
                            $scope.SelectedFormulaName = "[No Formula]";
                            if (Id !== -1) {
                                // Find the index of the selected formula
                                var SelectedIdIndex = -1;
                                for (var i = 0; i < FormulasArray.length; i++) {
                                    if (FormulasArray[i].Id == Id) {
                                        SelectedIdIndex = i;// Found it!
                                        break;
                                    }
                                }
                                // If we found it, then 
                                if (SelectedIdIndex !== -1) {
                                    $scope.SelectedFormulaName = FormulasArray[SelectedIdIndex].Name;
                                    $scope.SelectedFormulaUnits = FormulasArray[SelectedIdIndex].Units;
                                    $scope.SelectedFormulaIndex = SelectedIdIndex;
                                }
                            }
                            console.log("ConfigureAnalogInput: [after 2] $scope.SelectedFormulaName=" + $scope.SelectedFormulaName);
                        }

                        $scope.FormulaLowThreshold = $scope.tempAnalogInput.FormulaLowThreshold;
                        $scope.EvaluateFormulaLowThreshold = function () {
                            // We'll just calculate locally for now ... maybe later do a call to the server
                            var calculatedresult = "ERROR";
                            try {
                                var expression = Parser.parse(FormulasArray[$scope.SelectedFormulaIndex].Formula);
                                var rawresult = expression.evaluate({ x: $scope.tempAnalogInput.LowThreshold })
                                calculatedresult = Number(rawresult).toFixed(FormulasArray[$scope.SelectedFormulaIndex].Decimals)
                            } catch (err) {
                                console.log("ConfigureAnalogInput.EvaluateFormulaLowThreshold: Error=" + err);
                            }
                            finally {
                                $scope.FormulaLowThreshold = calculatedresult;
                            }
                        }

                        $scope.FormulaHighThreshold = $scope.tempAnalogInput.FormulaHighThreshold;
                        $scope.EvaluateFormulaHighThreshold = function () {
                            // We'll just calculate locally for now ... maybe later do a call to the server
                            var calculatedresult = "ERROR";
                            try {
                                var expression = Parser.parse(FormulasArray[$scope.SelectedFormulaIndex].Formula);
                                var rawresult = expression.evaluate({ x: $scope.tempAnalogInput.HighThreshold })
                                calculatedresult = Number(rawresult).toFixed(FormulasArray[$scope.SelectedFormulaIndex].Decimals)
                            } catch (err) {
                                console.log("ConfigureAnalogInput.EvaluateFormulaHighThreshold: Error=" + err);
                            }
                            finally {
                                $scope.FormulaHighThreshold = calculatedresult;
                            }
                        }

                        // Apply button press - update the server
                        $scope.apply = function () {
                            console.log("Sending: '/api/analoginputs/" + $scope.tempAnalogInput.Address + "'");
                            console.log("tempAnalogInput=" + JSON.stringify($scope.tempAnalogInput));

                            $http({
                                method: "put",
                                url: "/api/analoginputs/" + currentAnalogInput.Address,
                                data: $scope.tempAnalogInput
                            }).success(function (data) {
                                //console.log('ConfigureAnalogInput success');
                                Address = data.Address
                                currentAnalogInput.Name = data.Name
                                currentAnalogInput.RawValue = data.RawValue
                                currentAnalogInput.FormulaId = data.FormulaId;
                                currentAnalogInput.FormulaEnabled = data.FormulaEnabled;
                                currentAnalogInput.RangedValue = data.RangedValue;
                                currentAnalogInput.FormulaValue = data.FormulaValue;
                                currentAnalogInput.Enabled = data.Enabled;
                                currentAnalogInput.SendEvents = data.SendEvents;
                                currentAnalogInput.FormulaId = data.FormulaId;
                                currentAnalogInput.LowThreshold = Number(data.LowThreshold).toFixed(2)
                                currentAnalogInput.HighThreshold = Number(data.HighThreshold).toFixed(2)
                                currentAnalogInput.FormulaLowThreshold = data.FormulaLowThreshold;
                                currentAnalogInput.FormulaHighThreshold = data.FormulaHighThreshold;
                                currentAnalogInput.Offset = data.Offset
                                currentAnalogInput.HoldTime = data.HoldTime;
                                currentAnalogInput.Qualifier = data.Qualifier;
                                currentAnalogInput.ThresholdState = data.ThresholdState;
                                currentAnalogInput.TimeChanged = data.TimeChanged;

                                if (currentAnalogInput.Enabled === "TRUE") {

                                    // Show the value as green (in range) or red (out of range)
                                    $('#IdAnalogInput' + Address + 'Value').css('color', 'white');
                                    if (currentAnalogInput.ThresholdState === 0) {
                                        $('#IdAnalogInput' + Address + 'Value').css('background-color', 'green');
                                        $('#IdAnalogInput' + Address + 'Value').css('border-color', 'green');
                                    } else if (currentAnalogInput.ThresholdState != -1) {
                                        $('#IdAnalogInput' + Address + 'Value').css('background-color', 'red');
                                        $('#IdAnalogInput' + Address + 'Value').css('border-color', 'red');
                                    }

                                    // Show RangedValue or FormulaValues
                                    var Value, LowThreshold, HighThreshold;
                                    if (currentAnalogInput.FormulaId !== -1) {
                                        // If we're using a formula, then change from Ranged Value to Formula Value
                                        var FormulaIndex = -1;
                                        for (var f = 0; f < FormulasArray.length; f++) {
                                            if (currentAnalogInput.FormulaId === FormulasArray[f].Id) {
                                                FormulaIndex = f;
                                                break;
                                            }
                                        }

                                        // Show formula name
                                        $('#IdAnalogInput' + Address + 'Formula').html(FormulasArray[FormulaIndex].Name);

                                        // Only update values if the formula is enabled                                            
                                        if (currentAnalogInput.FormulaEnabled === 1) {
                                            // Show formula'd FormulaValue
                                            Value = Number(currentAnalogInput.FormulaValue).toFixed(FormulasArray[FormulaIndex].Decimals);
                                            $('#IdAnalogInput' + Address + 'Value').html(Value + " " + FormulasArray[FormulaIndex].Units);

                                            // Show formula'd LowThreshold and HighThreshold
                                            LowThreshold = Number(currentAnalogInput.FormulaLowThreshold).toFixed(FormulasArray[FormulaIndex].Decimals);
                                            $('#IdAnalogInput' + Address + 'LowThreshold').html(LowThreshold + " " + FormulasArray[FormulaIndex].Units);
                                            HighThreshold = Number(currentAnalogInput.FormulaHighThreshold).toFixed(FormulasArray[FormulaIndex].Decimals);
                                            $('#IdAnalogInput' + Address + 'HighThreshold').html(HighThreshold + " " + FormulasArray[FormulaIndex].Units);
                                        }
                                    } else {
                                        // Show formula-less RangedValue
                                        $('#IdAnalogInput' + Address + 'Value').html(currentAnalogInput.RangedValue + " Volts");

                                        // Show formula-less LowThreshold and HighThreshold
                                        LowThreshold = Number(currentAnalogInput.LowThreshold).toFixed(2);
                                        $('#IdAnalogInput' + Address + 'LowThreshold').html(LowThreshold + " Volts");
                                        HighThreshold = Number(currentAnalogInput.HighThreshold).toFixed(2);
                                        $('#IdAnalogInput' + Address + 'HighThreshold').html(HighThreshold + " Volts");
                                    }
                                } else {
                                    var Value, LowThreshold, HighThreshold;
                                    if (currentAnalogInput.FormulaId !== -1) {
                                        // If we're using a formula, then change from Ranged Value to Formula Value
                                        var FormulaIndex = -1;
                                        for (var f = 0; f < FormulasArray.length; f++) {
                                            if (currentAnalogInput.FormulaId === FormulasArray[f].Id) {
                                                FormulaIndex = f;
                                                break;
                                            }
                                        }

                                        // Show formula name
                                        $('#IdAnalogInput' + Address + 'Formula').html(FormulasArray[FormulaIndex].Name);
                                    }

                                    // Analog Input display
                                    $('#IdAnalogInput' + Address + 'Value').html("--");
                                    $('#IdAnalogInput' + Address + 'Value').css('color', 'white');
                                    $('#IdAnalogInput' + Address + 'Value').css('background-color', 'grey');
                                    $('#IdAnalogInput' + Address + 'Value').css('border-color', 'grey');

                                    // Show LowThreshold and HighThreshold
                                    $('#IdAnalogInput' + Address + 'LowThreshold').html("--");
                                    $('#IdAnalogInput' + Address + 'HighThreshold').html("--");
                                }

                            });
                            $modalInstance.close();
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });
                //#endregion Configure Analog Input

            };
            //#endregion Analog Inputs

            //----------------------------------------------------------
            // Formulas
            //#region Formulas

            // Add a new formula
            //  /api/formulas
            $scope.AddFormula = function (FormulasArray) {
                console.log("AddFormula: modal entry")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/ManageFormulas.html',
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = "Add Formula";
                        $scope.tempFormula = {
                            Name: "",
                            NamePattern: /^[\w ]{1,16}$/,
                            Formula: "",
                            FormulaPattern: /^[\S \*\\\+\-\^\(\)\%]{1,128}$/,
                            Units: "",
                            UnitsPattern: /^[\w\%]{1,8}$/,
                            Decimals: 2,
                            DecimalsPattern: /^[01234]{1}$/,
                            TestValue: 0,
                            TestValuePattern: /^[0 - 9]*(\.)?[0-9]?$/
                        };

                        // Validate formula
                        $scope.ValidateFormula = function (formula) {
                            console.log("AddFormula.ValidateFormula: Calling /api/formulas/validate - formula=" + JSON.stringify(formula));
                            $http({
                                method: "put",
                                url: "/api/formulas/validate",
                                data: formula
                            }).success(function (data) {
                                console.log('AddFormula.ValidateFormula: result=' + JSON.stringify(data));
                                $scope.ValidFormula = data.result;
                            });
                        };

                        // Apply button press
                        $scope.apply = function (formula) {
                            // Validate the formula first ...
                            $http({
                                method: "put",
                                url: "/api/formulas/validate",
                                data: formula
                            }).success(function (data) {
                                console.log('AddFormula.ValidateFormula: result=' + JSON.stringify(data));
                                $scope.ValidFormula = data.result;

                                // Only if this is a good formula, apply changes
                                console.log("AddFormula.Apply: Status of ValidFormula=" + $scope.ValidFormula);
                                if ($scope.ValidFormula === "TRUE") {
                                    console.log("AddFormula.Apply: Calling '/api/formulas/ data=" + JSON.stringify($scope.tempFormula));
                                    $http({
                                        method: "put",
                                        url: "/api/formulas",
                                        data: $scope.tempFormula
                                    }).success(function (data) {
                                        console.log('AddFormula.Apply: data=' + JSON.stringify(data));
                                        FormulasArray = data;// Update the Formulas Array
                                        $modalInstance.close(FormulasArray);
                                    });
                                }
                            });
                        };

                        // Evaluate button press
                        $scope.EvaluateFormula = function (formula) {
                            $http({
                                method: "put",
                                url: "/api/formulas/validate",
                                data: formula
                            }).success(function (data) {
                                console.log('AddFormula.EvaluateFormula: ValidateFormula result=' + JSON.stringify(data));
                                $scope.ValidFormula = data.result;
                                console.log("AddFormula.EvaluateFormula: Status of ValidFormula=" + $scope.ValidFormula);

                                // Only if this is a good formula, try evaluation
                                if ($scope.ValidFormula === "TRUE") {
                                    console.log("AddFormula.EvaluateFormula: Calling '/api/formulas/evaluate - data=" + JSON.stringify($scope.tempFormula));
                                    $http({
                                        method: "put",
                                        url: "/api/formulas/evaluate",
                                        data: formula
                                    }).success(function (data) {
                                        console.log('AddFormula.EvaluateFormula: data=' + JSON.stringify(data));
                                        $scope.tempFormula.TestResult = data.result + " " + formula.Units;
                                    });
                                } else {
                                    $scope.tempFormula.TestResult = "ERROR: Invalid formula";
                                }
                            });
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    },
                });

                // Save the results from the modal to $scope data, so it will automatically update the UI
                modalInstance.result.then(function (FormulasArray) {
                    $scope.FormulasArray = FormulasArray;
                }, function () {
                });
            };

            // Manage an existing formula
            //  /api/formulas/:formula
            $scope.ManageFormula = function (currentFormula) {
                console.log("ManageFormula: modal entry")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/ManageFormulas.html',
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = "Configure Formula";
                        $scope.tempFormula = {
                            Id: currentFormula.Id,
                            Name: currentFormula.Name,
                            NamePattern: /^[\w ]{1,16}$/,
                            Formula: currentFormula.Formula,
                            FormulaPattern: /^[\S \*\\\+\-\^\(\)\%]{1,128}$/,// 128 characters, any non-whitespace character
                            Units: currentFormula.Units,
                            UnitsPattern: /^[\w\%]{1,8}$/,// 8 characters, any word character
                            Decimals: currentFormula.Decimals,
                            DecimalsPattern: /^[01234]{1}$/,
                            TestValue: 0,
                            TestValuePattern: /^[0-9]*(\.)?[0-9]?$/
                        };

                        // Validate formula
                        $scope.ValidateFormula = function (formula) {
                            console.log("ManageFormula.ValidateFormula: Calling /api/formulas/validate - formula=" + JSON.stringify(formula));
                            $http({
                                method: "put",
                                url: "/api/formulas/validate",
                                data: formula
                            }).success(function (data) {
                                console.log('ManageFormula.ValidateFormula: result=' + JSON.stringify(data));
                                $scope.ValidFormula = data.result;
                            });
                        };

                        // Apply button press
                        $scope.apply = function (formula) {
                            // Validate the formula first ...
                            $http({
                                method: "put",
                                url: "/api/formulas/validate",
                                data: formula
                            }).success(function (data) {
                                console.log('ManageFormula.ValidateFormula: result=' + JSON.stringify(data));
                                $scope.ValidFormula = data.result;

                                // Only if this is a good formula, apply changes
                                console.log("ManageFormula.Apply: Status of ValidFormula=" + $scope.ValidFormula);
                                if ($scope.ValidFormula === "TRUE") {
                                    console.log("ManageFormula.Apply: Calling '/api/formulas/" + currentFormula.Id + " data=" + JSON.stringify($scope.tempFormula));
                                    $http({
                                        method: "put",
                                        url: "/api/formulas/" + currentFormula.Id,
                                        data: $scope.tempFormula
                                    }).success(function (data) {
                                        console.log('ManageFormula.Apply: data=' + JSON.stringify(data));

                                        for (var i = 0; i < data.length; i++) {
                                            if (data[i].Id == currentFormula.Id) {
                                                currentFormula.Name = data[i].Name;
                                                currentFormula.Formula = data[i].Formula;
                                                currentFormula.Units = data[i].Units;
                                                currentFormula.Decimals = data[i].Decimals;
                                                break;
                                            }
                                        }
                                    });
                                    $modalInstance.close();
                                }
                            });
                        };

                        // Evaluate button press
                        $scope.EvaluateFormula = function (formula) {
                            $http({
                                method: "put",
                                url: "/api/formulas/validate",
                                data: formula
                            }).success(function (data) {
                                console.log('ManageFormula.EvaluateFormula: ValidateFormula result=' + JSON.stringify(data));
                                $scope.ValidFormula = data.result;
                                console.log("ManageFormula.EvaluateFormula: Status of ValidFormula=" + $scope.ValidFormula);

                                // Only if this is a good formula, try evaluation
                                if ($scope.ValidFormula === "TRUE") {
                                    console.log("ManageFormula.EvaluateFormula: Calling '/api/formulas/evaluate - data=" + JSON.stringify($scope.tempFormula));
                                    $http({
                                        method: "put",
                                        url: "/api/formulas/evaluate",
                                        data: formula
                                    }).success(function (data) {
                                        console.log('ManageFormula.EvaluateFormula: data=' + JSON.stringify(data));
                                        $scope.tempFormula.TestResult = data.result + " " + formula.Units;
                                    });
                                } else {
                                    $scope.tempFormula.TestResult = "ERROR: Invalid formula";
                                }
                            });
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });
            };

            // Delete an existing formula
            //  /api/formulas/delete
            $scope.DeleteFormula = function (currentFormula) {
                console.log("Inside DeleteFormula")

                // Check to see if the formula is used anywhere
                //  if it is, do not allow deletion
                var FormulaIsUsed = false;
                FormulaInAnalogInputs = [];
                for (var i = 0; i < $scope.AnalogInputs.length; i++) {
                    if ($scope.AnalogInputs[i].FormulaId == currentFormula.Id) {
                        FormulaInAnalogInputs.push({ message: $scope.AnalogInputs[i].Name + ' [Analog Input ' + (i + 1) + ']' });
                        FormulaIsUsed = true;
                    }
                }

                if (FormulaIsUsed) {
                    // Throw up a message to let user know that formula is being used ...
                    var modalInstance = $modal.open({
                        templateUrl: 'views/partials/AnalogInputErrorModal.html',
                        //size: 'md',
                        controller: function ($scope, $modalInstance) {
                            $scope.modalTitle = 'Formula Delete Error';
                            $scope.modalMessage = 'This formula can not be deleted because it is being used by:';
                            $scope.FormulaInAnalogInputs = FormulaInAnalogInputs;

                            $scope.ok = function () {
                                $modalInstance.close();
                            };

                            $scope.cancel = function () {
                                $modalInstance.dismiss('cancel');
                            };

                        }
                    });
                }
                else {
                    // Formula isn't used, so we can delete it ...
                    $http({
                        method: "put",
                        url: "/api/formulas/delete",
                        data: currentFormula
                    })
                        .success(function (data) {
                            //console.log('DeleteFormula success - data=' + JSON.stringify(data));
                            $scope.FormulasArray = data;
                        })
                }

            };
            //#endregion Formulas

            //----------------------------------------------------------
            // Analog Outputs
            //#region Analog Outputs

            // Retreive Analog Output array through RESTful API
            $scope.GetAnalogOutputs = function () {
                $http({
                    method: "get",
                    url: "/api/analogoutputs"
                })
                    .success(function (data) {
                        //console.log('GetAnalogOutputs success');
                        $scope.AnalogOutputs = data;
                        $scope.AnalogOutputsTotal = data.length;
                        var ANALOG_OUTPUT_CONVERT_TO_RAW_SLOPE = 200;
                        var ANALOG_OUTPUT_CONVERT_TO_RAW_OFFSET = 0;
                        for (i = 0, enabled = 0; i < data.length; i++) {
                            if (data[i].Enabled == "TRUE") enabled++;
                            // We also need to update RangedValues, because they are calculated here
                            $scope.AnalogOutputs[i].RangedValue = Number(((data[i].RawValue - ANALOG_OUTPUT_CONVERT_TO_RAW_OFFSET) / ANALOG_OUTPUT_CONVERT_TO_RAW_SLOPE)).toFixed(2);
                        }
                        $scope.AnalogOutputsEnabled = enabled;
                    })
            }
            $scope.GetAnalogOutputs();// Go get digital outputs

            $scope.AnalogOutputSelected = 0;

            $scope.SetAnalogOutputValue = function (address) {
                if ($scope.AnalogOutputs[address].Enabled === "TRUE") {
                    console.log("Inside SetAnalogOutputValue")
                    var modalInstance = $modal.open({
                        templateUrl: 'views/partials/SetAnalogOutputValue.html',
                        //size: size,
                        controller: function ($scope, $modalInstance, Address, AnalogOutputs) {
                            $scope.Address = Address;
                            $scope.AnalogOutputs = AnalogOutputs;

                            $scope.AnalogOutputSetValue = {
                                SetValue: $scope.AnalogOutputs[$scope.Address].RangedValue,
                                SetFilter: /^(((([0-9]|[1][0-9]){0,1}(\.[0-9]{0,2}){0,1})|((20)(\.[0]{0,2}){0,1})))$/
                            };
                            $scope.AnalogOutputCurrentValue = {
                                CurrentValue: $scope.AnalogOutputs[$scope.Address].RangedValue,
                                Range: $scope.AnalogOutputs[$scope.Address].Range
                            };
                            console.log("Analog output selected=" + $scope.Address);
                            console.log("Analog output length=" + $scope.AnalogOutputs.length);
                            console.log("Analog output name=" + $scope.AnalogOutputs[$scope.Address].Name);
                            $scope.modalTitle = "Set Value for '" + $scope.AnalogOutputs[$scope.Address].Name + "' at address=" + $scope.Address;
                            $('#IdAnalogOutputSetValue').focus();
                            //$scope.modalContent = "Current Value = " + $scope.AnalogOutputs[$scope.Address].RangedValue + " Volts&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp[Valid Range = 0.." + $scope.AnalogOutputs[$scope.Address].Range + " Volts]";

                            $scope.ok = function () {
                                console.log("Input received = " + $scope.AnalogOutputSetValue.SetValue)
                                if (typeof $scope.AnalogOutputSetValue.SetValue !== "undefined") {
                                    console.log("Set Value=" + parseFloat($scope.AnalogOutputSetValue.SetValue));

                                    //  We're all good - let's set the value
                                    console.log("Sending: '/api/analogoutputs/" + $scope.Address + "/" + $scope.AnalogOutputSetValue.SetValue + "'");
                                    $http({
                                        method: "put",
                                        url: "/api/analogoutputs/" + $scope.Address + "/" + $scope.AnalogOutputSetValue.SetValue
                                    }).success(function (data) {
                                        //console.log('SetAnalogOutputValue success');
                                    });
                                    $modalInstance.close();
                                }
                            };
                            $scope.cancel = function () {
                                $modalInstance.dismiss('cancel');
                            };
                        },
                        resolve: {
                            Address: function () {
                                return address;
                            },
                            AnalogOutputs: function () {
                                return $scope.AnalogOutputs;
                            }
                        }
                    });
                }
            };

            // Handle incoming socket.io updates            
            socketManager.on('AnalogOutput', function (message) {
                var ANALOG_OUTPUT_CONVERT_TO_RAW_SLOPE = 200;
                var ANALOG_OUTPUT_CONVERT_TO_RAW_OFFSET = 0;
                $scope.AnalogOutputs[message.Address].RawValue = message.RawValue;
                $scope.AnalogOutputs[message.Address].TimeChanged = message.TimeChanged;
                $scope.AnalogOutputs[message.Address].RangedValue = Number(((message.RawValue - ANALOG_OUTPUT_CONVERT_TO_RAW_OFFSET) / ANALOG_OUTPUT_CONVERT_TO_RAW_SLOPE)).toFixed(2);
                $('#IdAnalogOutput' + message.Address + 'Value').html($scope.AnalogOutputs[message.Address].RangedValue + " Volts");
                $('#IdAnalogOutput' + message.Address + 'Value').css('color', 'yellow');
                setTimeout(function () { $('#IdAnalogOutput' + message.Address + 'Value').css('color', 'white') }, 1200);
            });

            // Update the configuration Outformation of the Digital Outputs
            socketManager.on('AnalogOutputs', function (data) {
                //console.log('socketManager.on for AnalogOutputs');
                $scope.AnalogOutputsTotal = data.AnalogOutputsTotal;
                $scope.AnalogOutputsEnabled = data.AnalogOutputsEnabled;
            });

            // Configure Analog Output x
            $scope.ConfigureAnalogOutput = function (currentAnalogOutput) {
                console.log("Inside ConfigureAnalogOutput")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/configureanalogoutput.html',
                    controller: function ($scope, $modalInstance) {
                        console.log("Analog Output selected=" + currentAnalogOutput.Address);
                        $scope.modalTitle = "Configure Analog Output '" + currentAnalogOutput.Name + "' at address=" + currentAnalogOutput.Address;

                        // Create a copy of the current configuration during the configuration process
                        $scope.tempAnalogOutput = angular.copy(currentAnalogOutput);

                        // List of possible options for updating the configuration
                        $scope.EnabledOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.SendEventsOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.RangeOptions = [{ option: '20' }];

                        // Accept changes to the configuration into the temp variable
                        $scope.SetEnabled = function (option) {
                            $scope.tempAnalogOutput.Enabled = option
                        }
                        $scope.SetSendEvents = function (option) {
                            $scope.tempAnalogOutput.SendEvents = option
                        }
                        $scope.SetRange = function (option) {
                            $scope.tempAnalogOutput.Range = parseInt(option)
                        }

                        // Apply button press - update the server
                        $scope.apply = function () {
                            $scope.tempAnalogOutput.Name = $scope.tempAnalogOutput.Name.substring(0, 16);// Temporary fix for long strings
                            if ($scope.tempAnalogOutput.Enabled == "FALSE") $scope.tempAnalogOutput.RangedValue = "0.00";
                            console.log("Sending: '/api/AnalogOutputs/" + $scope.tempAnalogOutput.Address + "'");
                            console.log("tempAnalogOutput=" + JSON.stringify($scope.tempAnalogOutput));

                            $http({
                                method: "put",
                                url: "/api/AnalogOutputs/" + currentAnalogOutput.Address,
                                data: $scope.tempAnalogOutput
                            }).success(function (data) {
                                //console.log('ConfigureAnalogOutput success');
                                Address = data.Address
                                currentAnalogOutput.Name = data.Name
                                currentAnalogOutput.Enabled = data.Enabled;
                                currentAnalogOutput.SendEvents = data.SendEvents;
                                currentAnalogOutput.Range = data.Range
                                currentAnalogOutput.RawValue = data.RawValue
                                currentAnalogOutput.RangedValue = data.RangedValue;
                                var ANALOG_OUTPUT_CONVERT_TO_RAW_SLOPE = 200;
                                var ANALOG_OUTPUT_CONVERT_TO_RAW_OFFSET = 0;
                                currentAnalogOutput.RangedValue = Number(((data.RawValue - ANALOG_OUTPUT_CONVERT_TO_RAW_OFFSET) / ANALOG_OUTPUT_CONVERT_TO_RAW_SLOPE)).toFixed(2);

                                if (currentAnalogOutput.Enabled === "TRUE") {
                                    $('#IdAnalogOutput' + Address + 'Value').html(currentAnalogOutput.RangedValue + " Volts");
                                    $('#IdAnalogOutput' + Address + 'Value').css('color', 'white');
                                    $('#IdAnalogOutput' + Address + 'Value').css('background-color', 'green');
                                    $('#IdAnalogOutput' + Address + 'Value').css('border-color', 'green');
                                    $('#IdAnalogOutput' + Address + 'Set').html("Set Value");
                                    $('#IdAnalogOutput' + Address + 'Set').css("color", "white");
                                    $('#IdAnalogOutput' + Address + 'Set').css("background-color", '#f0ad4e');
                                    $('#IdAnalogOutput' + Address + 'Set').css("border-color", '#f0ad4e');
                                } else {
                                    $('#IdAnalogOutput' + Address + 'Value').html("--");
                                    $('#IdAnalogOutput' + Address + 'Value').css('color', 'white');
                                    $('#IdAnalogOutput' + Address + 'Value').css('background-color', 'grey');
                                    $('#IdAnalogOutput' + Address + 'Value').css('border-color', 'grey');
                                    $('#IdAnalogOutput' + Address + 'Set').html("--");
                                    $('#IdAnalogOutput' + Address + 'Set').css("color", "white");
                                    $('#IdAnalogOutput' + Address + 'Set').css("background-color", 'grey');
                                    $('#IdAnalogOutput' + Address + 'Set').css("border-color", 'grey');
                                }
                            });
                            $modalInstance.close();
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });
            };
            //#endregion Analog Outputs
        }
    ])
    //#endregion Analog I/O Controller

    //#region Ping Sensor Controller
    .controller('pingSensorsCtrl', [
        '$scope',
        '$modal',
        '$http',
        'socketManager',
        function ($scope, $modal, $http, socketManager) {

            //#region Kenwood
            $scope.$on('$stateChangeSuccess', function () {
                console.log("Controller: kenwoodCtrl");
            });
            $scope.$on('$destroy', function (event) {
                socketManager.removeAllListeners();
            });

            $scope.KenwoodRulesArray = [];

            // Retreive array of Kenwood rules
            //  /api/network/kenwood/rules
            $scope.GetKenwoodRules = function () {
                console.log("Inside GetKenwoodRules")
                $http({
                    method: "get",
                    url: "/api/kenwood/rules"
                })
                    .success(function (data) {
                        $scope.KenwoodRulesArray = data;
                        $scope.NumberOfKenwoodRules = data.length;
                    })
            }
            $scope.GetKenwoodRules();

            // Retreive array of Kenwood ping interval
            //  /api/network/kenwood/pinginterval
            $scope.GetKenwoodPingInterval = function () {
                $http({
                    method: "get",
                    url: "/api/kenwood/pinginterval"
                })
                    .success(function (data) {
                        $scope.KenwoodPingInterval = data;
                    })
            }
            $scope.GetKenwoodPingInterval();

            // Add a Kenwood rule
            //  /api/kenwood/rules
            $scope.ChangeKenwoodPingInterval = function (KenwoodPingInterval) {
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/changekenwoodpinginterval.html',
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = "Change Global Ping Interval";
                        $scope.tempKenwoodPing = {
                            Interval: KenwoodPingInterval,
                            IntervalPattern: /^[1-9]$|^[1-5][0-9]$|^[6][0]$/
                        };

                        // Apply button press - update the server
                        $scope.apply = function () {
                            console.log("Sending: '/api/kenwood/pinginterval");
                            $http({
                                method: "put",
                                url: "/api/kenwood/pinginterval",
                                data: $scope.tempKenwoodPing
                            }).success(function (data) {
                                $modalInstance.close(data);
                            });
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    },
                });

                // Save the results from the modal to $scope data, so it will automatically update the UI
                modalInstance.result.then(function (data) {
                    $scope.KenwoodPingInterval = data.Interval;
                }, function () {
                });
            };

            // Handle incoming socket.io updates            
            socketManager.on('KenwoodRule', function (data) {
                //console.log('socketManager.on for KenwoodRule Rule=' + data.RepeaterName + " data=" + JSON.stringify(data));
                var Id = data.Id

                for (i = 0; i < $scope.KenwoodRulesArray.length; i++) {
                    if ($scope.KenwoodRulesArray[i].Id == Id) {
                        $scope.KenwoodRulesArray[i].Status = data.Status;
                        $scope.KenwoodRulesArray[i].TimeChanged = data.TimeChanged;
                        break;
                    }
                }

                if (data.Enabled === "TRUE") {
                    $('#IdKenwoodRule' + Id + 'Status').css('color', 'white');
                    if (data.Status == 'ALIVE') {
                        $('#IdKenwoodRule' + Id + 'Status').css('background-color', 'green');
                        $('#IdKenwoodRule' + Id + 'Status').css('border-color', 'green');
                    } else if (data.Status == 'DEAD') {
                        $('#IdKenwoodRule' + Id + 'Status').css('background-color', 'red');
                        $('#IdKenwoodRule' + Id + 'Status').css('border-color', 'red');
                    } else {
                        $('#IdKenwoodRule' + Id + 'Status').css('background-color', 'grey');
                        $('#IdKenwoodRule' + Id + 'Status').css('border-color', 'grey');
                    }
                }
                else {
                    $('#IdKenwoodRule' + Id + 'Status').css('color', 'white');
                    $('#IdKenwoodRule' + Id + 'Status').css('background-color', 'grey');
                    $('#IdKenwoodRule' + Id + 'Status').css('border-color', 'grey');
                }
            });

            // Delete a Kenwood rule
            //  /api/kenwood/rules/delete
            $scope.DeleteKenwoodRule = function (currentKenwoodRule) {
                console.log("Inside DeleteKenwoodRule")
                $http({
                    method: "put",
                    url: "/api/kenwood/rules/delete",
                    data: currentKenwoodRule
                })
                    .success(function (data) {
                        //console.log('DeleteKenwoodRule success - data=' + JSON.stringify(data));
                        $scope.KenwoodRulesArray = data;
                    })
            };

            // Add a Kenwood rule
            //  /api/kenwood/rules
            $scope.AddKenwoodRule = function (KenwoodRulesArray) {
                console.log("Inside AddKenwoodRule")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/managepingsensorrule.html',
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = "Add Ping Sensor Rule";
                        $scope.tempKenwoodRule = {
                            RepeaterName: "",
                            RepeaterNamePattern: /^[\w ]{1,15}[\w]{1,1}$/,
                            Enabled: "TRUE",
                            SendEvents: "TRUE",
                            HostAddress: "",
                            HostAddressPattern: /^((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/,
                            ToFail: "5",
                            ToFailPattern: /^[1-9]$|^[1][0-9]$/,
                            ToRecover: "15",
                            ToRecoverPattern: /^[1-9]$|^[1][0-9]$/,
                            ActivateOutput: "0",
                            ActivateOutputPattern: /^[0-9]$|^[1][0-6]$/,
                        };

                        // List of possible options for updating the configuration
                        $scope.EnabledOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.SendEventsOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];

                        // Apply button press - update the server
                        $scope.apply = function () {
                            console.log("Sending: '/api/kenwood/rules");
                            $http({
                                method: "put",
                                url: "/api/kenwood/rules",
                                data: $scope.tempKenwoodRule
                            }).success(function (data) {
                                //console.log('AddKenwoodRule PUT success data=' + JSON.stringify(data));
                                $modalInstance.close(data);
                            });
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    },
                });

                // Save the results from the modal to $scope data, so it will automatically update the UI
                modalInstance.result.then(function (KenwoodRulesArray) {
                    $scope.KenwoodRulesArray = KenwoodRulesArray;
                }, function () {
                    console.log('Modal dismissed at: ' + new Date());
                });
            };

            // Edit a Kenwood rule
            //  /api/kenwood/rules/:host
            $scope.ConfigureKenwoodRule = function (currentKenwoodRule) {
                console.log("Inside ConfigureKenwoodRule")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/managekenwoodrules.html',
                    controller: function ($scope, $modalInstance) {
                        $scope.modalTitle = "Configure Kenwood NexEdge Trunking Site Repeater";
                        $scope.tempKenwoodRule = {
                            Id: currentKenwoodRule.Id,
                            RepeaterName: currentKenwoodRule.RepeaterName,
                            RepeaterNamePattern: /^[\w ]{1,15}[\w]{1,1}$/,
                            Enabled: currentKenwoodRule.Enabled,
                            SendEvents: currentKenwoodRule.SendEvents,
                            HostAddress: currentKenwoodRule.HostAddress,
                            HostAddressPattern: /^((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/,
                            ToFail: currentKenwoodRule.ToFail,
                            ToFailPattern: /^[1-9]$|^[1][0-9]$/,
                            ToRecover: currentKenwoodRule.ToRecover,
                            ToRecoverPattern: /^[1-9]$|^[1][0-9]$/,
                            ActivateOutput: currentKenwoodRule.ActivateOutput,
                            ActivateOutputPattern: /^[0-9]$|^[1][0-6]$/,
                        };

                        // List of possible options for updating the configuration
                        $scope.EnabledOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.SendEventsOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];

                        // Accept changes to the configuration into the temp variable
                        $scope.SetEnabled = function (option) {
                            $scope.tempKenwoodRule.Enabled = option
                        }

                        // Accept changes to the configuration into the temp variable
                        $scope.SetSendEvents = function (option) {
                            $scope.tempKenwoodRule.SendEvents = option
                        }

                        // Apply button press - update the server
                        $scope.apply = function () {
                            console.log("Sending: '/api/kenwood/rules/" + currentKenwoodRule.Id);
                            $http({
                                method: "put",
                                url: "/api/kenwood/rules/" + currentKenwoodRule.Id,
                                data: $scope.tempKenwoodRule
                            }).success(function (data) {
                                //console.log('Configure Kenwood Rule PUT success data=' + JSON.stringify(data));
                                currentKenwoodRule.RepeaterName = data.RepeaterName;
                                currentKenwoodRule.Enabled = data.Enabled;
                                currentKenwoodRule.SendEvents = data.SendEvents;
                                currentKenwoodRule.HostAddress = data.HostAddress;
                                currentKenwoodRule.ToFail = data.ToFail;
                                currentKenwoodRule.ToRecover = data.ToRecover;
                                currentKenwoodRule.ActivateOutput = data.ActivateOutput;
                            });
                            $modalInstance.close();
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });
            };

            //#endregion Kenwood
        }
    ])
    //#endregion Ping Sensor Controller

    //#region Serial Port Controller
    .controller('serialPortsCtrl', [
        '$scope',
        '$http',
        '$modal',
        'socketManager',
        function ($scope, $http, $modal, socketManager) {
            // Administrative controller stuff
            $scope.$on('$stateChangeSuccess', function () {
                console.log("serialPortsCtrl: Controller entry");
            });

            $scope.$on('$destroy', function (event) {
                socketManager.removeAllListeners();
            });

            // Get Serial Port Settings
            //#region Get Serial Port Settings
            $scope.SerialPortSettings = [];
            $scope.SerialPortsEnabled = 0;
            $scope.SerialPortsTotal = 0;
            $scope.GetSerialPortSettings = function () {
                $http({
                    method: "get",
                    url: "/api/serialports"
                })
                    .success(function (data) {
                        $scope.SerialPortSettings = data;
                        $scope.SerialPortsTotal = data.length;
                        for (i = 0, enabled = 0; i < data.length; i++) {
                            if (data[i].Enabled == "TRUE") enabled++;
                        }
                        $scope.SerialPortsEnabled = enabled;
                    })
            }
            $scope.GetSerialPortSettings();
            //#endregion Get Serial Port Settings

            // Get Device Options
            //#region Get Device Option
            $scope.SerialPortDeviceOptions = [];
            $scope.GetSerialPortDeviceOptions = function () {
                $http({
                    method: "get",
                    url: "/api/serialports/deviceoptions"
                })
                    .success(function (data) {
                        //console.log('serialPortsCtrl.GetSerialPortDeviceOptions success');
                        $scope.SerialPortDeviceOptions = data;
                    })
            }
            $scope.GetSerialPortDeviceOptions();
            //#endregion Get Device Option

            // Configure Serial Port Settings
            //#region Configure Serial Port Settings
            //      currentSerialPort = $scope.SerialPortSettings[Address]
            //      tempSerialPort = temporary value for this modal
            $scope.ConfigureSerialPortSetting = function (currentSerialPort) {
                console.log("serialPortsCtrl.ConfigureSerialPortSetting: Started")
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/ConfigureSerialPortSetting.html',
                    controller: function ($scope, $modalInstance, DeviceOptions) {
                        console.log("serialPortsCtrl.ConfigureSerialPortSetting: Port selected=" + currentSerialPort.Address);
                        $scope.modalTitle = "Configure Serial Port '" + currentSerialPort.Name + "' at address=" + (currentSerialPort.Address + 1);

                        // Create a copy of the current configuration during the configuration process
                        $scope.tempSerialPort = angular.copy(currentSerialPort);

                        // Name
                        $scope.NamePattern = /^[\w ]{1,15}[\w]{1,1}$/;

                        // List of possible options for updating the configuration
                        $scope.EnabledOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.SendEventsOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];

                        $scope.DeviceOptions = [{ option: 'NONE' }];
                        for (var d = 0; d < DeviceOptions.length; d++) {
                            // HACK: Only allow adding DirectionalPower+VSWR on ports 6 and 7
                            if (DeviceOptions[d].id == "DirectionalPower+VSWR") {
                                if ($scope.tempSerialPort.Address == 6 || $scope.tempSerialPort.Address == 7) {
                                    $scope.DeviceOptions.push({ option: DeviceOptions[d].id });
                                }
                            }
                        }

                        // Accept changes to the configuration into the temp variable
                        $scope.SetEnabled = function (option) {
                            $scope.tempSerialPort.Enabled = option;
                        }

                        $scope.SetSendEvents = function (option) {
                            $scope.tempSerialPort.SendEvents = option;
                        }

                        $scope.SetDevice = function (option) {
                            $scope.tempSerialPort.Device = option;
                        }

                        $scope.clear = function () {
                            $scope.tempSerialPort.Name = "Port " + (parseInt($scope.tempSerialPort.Address) + 1);
                            $scope.tempSerialPort.Enabled = "FALSE";
                            $scope.tempSerialPort.SendEvents = "FALSE";
                            $scope.tempSerialPort.Device = "NONE";
                        }

                        // Apply button press - update the server
                        $scope.apply = function () {
                            $scope.tempSerialPort.Name = $scope.tempSerialPort.Name.substring(0, 16);// Temporary fix for long strings
                            console.log("serialPortsCtrl.ConfigureSerialPortSetting: Sending: '/api/serialports/" + $scope.tempSerialPort.Address + "'");
                            $http({
                                method: "put",
                                url: "/api/serialports/" + currentSerialPort.Address,
                                data: $scope.tempSerialPort
                            }).success(function (data) {
                                console.log('serialPortsCtrl.ConfigureSerialPortSetting: API data=' + JSON.stringify(data));
                                Address = data.Address
                                currentSerialPort.Name = data.Name;
                                currentSerialPort.Value = data.Value;
                                currentSerialPort.Enabled = data.Enabled;
                                currentSerialPort.SendEvents = data.SendEvents;
                                currentSerialPort.Device = data.Device;
                                currentSerialPort.TimeChanged = data.TimeChanged;
                            });
                            $modalInstance.close();
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    },
                 scope: $scope, //Refer to parent scope here
                    resolve: {
                        DeviceOptions: function () {
                            return $scope.SerialPortDeviceOptions;
                        }
                    }
                });
            };
            //#endregion Configure Serial Port Settings
        }
    ])
    //#endregion Serial Port Controller

    //#region Serial Test Controller
    .controller('serialPortsTestCtrl', [
        '$scope',
        '$http',
        '$modal',
        'socketManager',
        function ($scope, $http, $modal,socketManager) {
            // Administrative controller stuff
            $scope.$on('$stateChangeSuccess', function () {
                console.log("serialPortsCtrl: Controller entry");
            });

            $scope.$on('$destroy', function (event) {
                socketManager.removeAllListeners();
            });

            // Get Serial Port Settings
            //#region Get Serial Port Settings
            $scope.SerialPorts = [];
            $scope.GetSerialPorts = function () {
                $http({
                    method: "get",
                    url: "/api/serialportstest"
                })
                    .success(function (data) {
                        //console.log('serialPortDeviceCtrl.GetSerialPortSettings success');
                        $scope.SerialPorts = data;
                    });
            };
            $scope.GetSerialPorts();
            //#endregion Get Serial Port Settings

            //#region Open Serial Port
            $scope.OpenSerialPort = function (port) {
                $http({
                    method: "get",
                    url: "/api/serialportstest/open/"+port
                })
                    .success(function (data) {
                        console.log(JSON.stringify(data));
                    });
            };
            //#endregion Open Serial Port

            //#region Write Serial Port
            $scope.WriteSerialPort = function (port) {
                $http({
                    method: "get",
                    url: "/api/serialportstest/write/" + port
                })
                    .success(function (data) {
                        console.log(JSON.stringify(data));
                    });
            };
            //#endregion Write Serial Port

            //#region Close Serial Port
            $scope.CloseSerialPort = function (port) {
                $http({
                    method: "get",
                    url: "/api/serialportstest/close/" + port
                })
                    .success(function (data) {
                        console.log(JSON.stringify(data));
                    });
            };
            //#endregion Close Serial Port

            socketManager.on('SerialPortTest', function (data) {
                console.log("SerialPortTest.on: data=" + JSON.stringify(data));
                $scope.SerialPorts[data.address].status = data.status;
                $scope.SerialPorts[data.address].received = data.received;
            });
        }
    ])
    //#endregion Serial Port Test Controller

    //#region Serial Port Device Controller
    .controller('serialPortDeviceCtrl', [
        '$scope',
        '$state',
        '$stateParams',
        '$modal',
        '$http',
        'socketManager',
        function ($scope, $state, $stateParams, $modal, $http, socketManager) {
            // Controller entry
            //#region Controller entry
            $scope.$on('$stateChangeSuccess', function () {
                console.log("serialPortDeviceCtrl: Controller entry");
            });

            $scope.$on('$destroy', function (event) {
                socketManager.removeAllListeners();
            });
            //#endregion Controller entry

            // Controller Constants and Parameters
            $scope.ThisPort = $stateParams.port;
            console.log("Port=" + $stateParams.port);

            // Get Device Setttings
            //#region Get Device Settings
            // Get Serial Port Settings
            //#region Get Serial Port Settings
            $scope.SerialPortSettings = {};
            $scope.GetSerialPortSettings = function () {
                $http({
                    method: "get",
                    url: "/api/serialports/"+$scope.ThisPort
                })
                    .success(function (data) {
                        //console.log('serialPortDeviceCtrl.GetSerialPortSettings success');
                        $scope.SerialPortSettings = data;
                    })
            }
            $scope.GetSerialPortSettings();
            //#endregion Get Serial Port Settings

            // Get Serial Port DeviceModel Settings
            //#region Serial Port DeviceModel Settings
            $scope.DeviceModel = {};
            $scope.GetSerialPortDeviceModel = function () {
                $http({
                    method: "get",
                    url: "/api/serialports/devicemodel/" + $scope.ThisPort
                })
                    .success(function (data) {
                        //console.log('GetSerialPortDeviceModel success=' + JSON.stringify(data));
                        $scope.DeviceModel = data;
                    })
            }
            $scope.GetSerialPortDeviceModel();
            //#endregion Serial Port DeviceModel Settings
            //#endregion Get Device Settings

            // Formula Changes
            //#region Formula Changes
            //#region ForwardPower Formula Change
            $scope.ChangeForwardPowerFormulaIndex = function (option) {
                console.log("port" + $scope.ThisPort + ".ChangeForwardPowerFormulaIndex: New formula=" + option);
                for (var i = 0; i < $scope.DeviceModel.parameters.ForwardPower.Formulas.length; i++) {
                    if ($scope.DeviceModel.parameters.ForwardPower.Formulas[i].Name == option) {
                        $scope.DeviceModel.parameters.ForwardPower.FormulaIndex = i;

                        // Persist the change
                        $http({
                            method: "put",
                            url: "/api/serialports/devicemodel/" + $scope.DeviceModel.port,
                            data: $scope.DeviceModel
                        }).success(function (updatedmodel) {
                            console.log("port" + $scope.ThisPort + ".ChangeForwardPowerFormulaIndex: Updated DeviceModel=" + JSON.stringify(updatedmodel));
                            DeviceModel = updatedmodel;
                        });
                    }
                }
            }
            //#endregion ForwardPower Formula Change

            //#region ReflectedPower Formula Change
            $scope.ChangeReflectedPowerFormulaIndex = function (option) {
                console.log("port" + $scope.ThisPort + ".ChangeReflectedPowerFormulaIndex: New formula=" + option);
                for (var i = 0; i < $scope.DeviceModel.parameters.ReflectedPower.Formulas.length; i++) {
                    if ($scope.DeviceModel.parameters.ReflectedPower.Formulas[i].Name == option) {
                        $scope.DeviceModel.parameters.ReflectedPower.FormulaIndex = i;

                        // Persist the change
                        $http({
                            method: "put",
                            url: "/api/serialports/devicemodel/" + $scope.DeviceModel.port,
                            data: $scope.DeviceModel
                        }).success(function (updatedmodel) {
                            console.log("port" + $scope.ThisPort + ".ChangeReflectedPowerFormulaIndex: Updated DeviceModel=" + JSON.stringify(updatedmodel));
                            DeviceModel = updatedmodel;
                        });
                    }
                }
            }
            //#endregion ReflectedPower Formula Change

            //#region Temperature Formula Change
            $scope.ChangeTemperatureFormulaIndex = function (option) {
                console.log("port" + $scope.ThisPort + ".ChangeTemperatureFormulaIndex: New formula=" + option);
                for (var i = 0; i < $scope.DeviceModel.parameters.Temperature.Formulas.length; i++) {
                    if ($scope.DeviceModel.parameters.Temperature.Formulas[i].Name == option) {
                        $scope.DeviceModel.parameters.Temperature.FormulaIndex = i;

                        // Persist the change
                        $http({
                            method: "put",
                            url: "/api/serialports/devicemodel/" + $scope.DeviceModel.port,
                            data: $scope.DeviceModel
                        }).success(function (updatedmodel) {
                            console.log("port" + $scope.ThisPort + ".ChangeTemperatureFormulaIndex: Updated DeviceModel=" + JSON.stringify(updatedmodel));
                            DeviceModel = updatedmodel;
                        });
                    }
                }
            }
            //#endregion Temperature Formula Change
            //#endregion Formula Changes

            // Manual Operations
            //#region Manual Operations
            $scope.ResetDeviceButtonColor = "btn-warning";
            $scope.ResetDeviceButtonText = "Reset Device";
            $scope.ResetDevice = function () {
                if ($scope.ResetDeviceButtonText == "Reset Device") {
                    $scope.ResetDeviceButtonColor = "btn-basic";
                    $scope.ResetDeviceButtonText = "Resetting Device ..."
                    $http({
                        method: "put",
                        url: "/api/serialports/reset/" + $scope.ThisPort
                    })
                        .success(function (data) {
                            $scope.ResetDeviceButtonColor = "btn-success";
                            $scope.ResetDeviceButtonText = "Device was reset";
                            setTimeout(function () {
                                $scope.ResetDeviceButtonColor = "btn-warning";
                                $scope.ResetDeviceButtonText = "Reset Device";
                            }, 1000);
                        })
                }
            }

            $scope.ZeroOffsetButtonColor = "btn-warning";
            $scope.ZeroOffsetButtonText = "Zero Offsets";
            $scope.ZeroOffset = function () {
                if ($scope.ZeroOffsetButtonText == "Zero Offsets") {
                    $scope.ZeroOffsetButtonColor = "btn-basic";
                    $scope.ZeroOffsetButtonText = "Zeroing offsets ..."
                    $http({
                        method: "put",
                        url: "/api/serialports/zero/" + $scope.ThisPort
                    })
                        .success(function (data) {
                            $scope.ZeroOffsetButtonColor = "btn-success";
                            $scope.ZeroOffsetButtonText = "Offsets were zeroed";
                            setTimeout(function () {
                                $scope.ZeroOffsetButtonColor = "btn-warning";
                                $scope.ZeroOffsetButtonText = "Zero Offsets";
                            }, 1000);
                        })
                }
            }
            //#endregion Manual Operations

            // Configuration Modals
            //#region Configuration Modals
            // Configure Forward Power Settings
            //#region Configure Forward Power Settings
            //      _port = Current port the device is allocated to ($scope.ThisPort)
            //      currentDeviceModel = DeviceModel for the device to be configured ($scope.DeviceModel)
            //      tempDeviceModel = temporary copy of the DeviceModel for this modal
            $scope.ConfigureForwardPowerSettings = function (_port, currentDeviceModel) {
                console.log("serialPortDeviceCtrl.ConfigureForwardPowerSettings: Started")
                var modalInstance = $modal.open({
                    templateUrl: 'devices/DirectionalPower+VSWR-ForwardPower.html',
                    controller: function ($scope, $modalInstance) {
                        console.log("serialPortDeviceCtrl.ConfigureForwardPowerSettings: Port=" + (Number(_port) + 1));
                        $scope.modalTitle = "Configure Forward Power";
                        $scope.modalSubtitle = "for " + currentDeviceModel.id + " on Port= " + (Number(_port) + 1);

                        // Create a copy of the current configuration during the configuration process
                        $scope.tempDeviceModel = angular.copy(currentDeviceModel);
                        $scope.port = _port;

                        // List of possible options for updating the configuration
                        $scope.EnabledOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.SendEventsOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.HoldTimeOptions = $scope.tempDeviceModel.parameters.ForwardPower.HoldTimeOptions;

                        $scope.LowThresholdPattern = /^(500|[1-4]\d\d|\d\d|\d)?(\.\d{0,2})?$/;
                        $scope.HighThresholdPattern = /^(500|[1-4]\d\d|\d\d|\d)?(\.\d{0,2})?$/;
                        $scope.QualifierPattern = /^(4[0-8]|[1-3]\d|\d)?$/;

                        // Accept changes to the configuration into the temp variable
                        $scope.SetEnabled = function (option) {
                            if (option == "TRUE")
                                $scope.tempDeviceModel.parameters.ForwardPower.Enabled = true;
                            else
                                $scope.tempDeviceModel.parameters.ForwardPower.Enabled = false;
                        }

                        $scope.SetSendEvents = function (option) {
                            if (option == "TRUE")
                                $scope.tempDeviceModel.parameters.ForwardPower.SendEvents = true;
                            else
                                $scope.tempDeviceModel.parameters.ForwardPower.SendEvents = false;
                        }

                        $scope.SetHoldTime = function (option) {
                            $scope.tempDeviceModel.parameters.ForwardPower.HoldTime = option;
                        }

                        //#region Formula Evaluation
                        $scope.LowThresholdFormulaIndex = 0;
                        $scope.ChangeLowThresholdFormulaIndex = function(index){
                            $scope.LowThresholdFormulaIndex = index;
                        }
                        $scope.EvaluateLowThresholdFormula = function () {
                            console.log("serialPortDeviceCtrl.EvaluateLowThresholdFormula: Sending: '/api/serialports/devicemodel/formula'");
                            $http({
                                method: "put",
                                url: "/api/serialports/devicemodel/formulas",
                                data: $scope.tempDeviceModel.parameters.ForwardPower
                            }).success(function (data) {
                                console.log('serialPortDeviceCtrl.ConfigureForwardPowerSettings: API data=' + JSON.stringify(data));
                                $scope.tempDeviceModel.parameters.ForwardPower = data;
                            });
                        }

                        $scope.HighThresholdFormulaIndex = 0;
                        $scope.ChangeHighThresholdFormulaIndex = function (index) {
                            $scope.HighThresholdFormulaIndex = index;
                        }
                        $scope.EvaluateHighThresholdFormula = function () {
                            console.log("serialPortDeviceCtrl.EvaluateHighThresholdFormula: Sending: '/api/serialports/devicemodel/formula'");
                            $http({
                                method: "put",
                                url: "/api/serialports/devicemodel/formulas",
                                data: $scope.tempDeviceModel.parameters.ForwardPower
                            }).success(function (data) {
                                console.log('serialPortDeviceCtrl.ConfigureForwardPowerSettings: API data=' + JSON.stringify(data));
                                $scope.tempDeviceModel.parameters.ForwardPower = data;
                            });
                        }
                        //#endregion Formula Evaluation

                        // Apply button press - update the server
                        $scope.apply = function () {
                            console.log("serialPortDeviceCtrl.ConfigureForwardPowerSettings: Sending: '/api/serialports/devicemodel/" + $scope.port + "'");
                            $http({
                                method: "put",
                                url: "/api/serialports/devicemodel/" + $scope.port,
                                data: $scope.tempDeviceModel
                            }).success(function (data) {
                                console.log('serialPortDeviceCtrl.ConfigureForwardPowerSettings: API data=' + JSON.stringify(data));
                                currentDeviceModel.parameters.ForwardPower = data.parameters.ForwardPower;
                            });
                            $modalInstance.close();
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });
            };
            //#endregion Configure Forward Power Settings

            // Configure Reflected Power Settings
            //#region Configure Reflected Power Settings
            //      _port = Current port the device is allocated to ($scope.ThisPort)
            //      currentDeviceModel = DeviceModel for the device to be configured ($scope.DeviceModel)
            //      tempDeviceModel = temporary copy of the DeviceModel for this modal
            $scope.ConfigureReflectedPowerSettings = function (_port, currentDeviceModel) {
                console.log("serialPortDeviceCtrl.ConfigureReflectedPowerSettings: Started")
                var modalInstance = $modal.open({
                    templateUrl: 'devices/DirectionalPower+VSWR-ReflectedPower.html',
                    controller: function ($scope, $modalInstance) {
                        console.log("serialPortDeviceCtrl.ConfigureReflectedPowerSettings: Port=" + (Number(_port) + 1));
                        $scope.modalTitle = "Configure Reflected Power";
                        $scope.modalSubtitle = "for " + currentDeviceModel.id + " on Port= " + (Number(_port) + 1);

                        // Create a copy of the current configuration during the configuration process
                        $scope.tempDeviceModel = angular.copy(currentDeviceModel);
                        $scope.port = _port;

                        // List of possible options for updating the configuration
                        $scope.EnabledOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.SendEventsOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.HoldTimeOptions = $scope.tempDeviceModel.parameters.ReflectedPower.HoldTimeOptions;

                        $scope.LowThresholdPattern = /^(50|[1-4]\d|\d)?(\.\d{0,2})?$/;
                        $scope.HighThresholdPattern = /^(50|[1-4]\d|\d)?(\.\d{0,2})?$/;
                        $scope.QualifierPattern = /^(4[0-8]|[1-3]\d|\d)?$/;

                        // Accept changes to the configuration into the temp variable
                        $scope.SetEnabled = function (option) {
                            if (option == "TRUE")
                                $scope.tempDeviceModel.parameters.ReflectedPower.Enabled = true;
                            else
                                $scope.tempDeviceModel.parameters.ReflectedPower.Enabled = false;
                        }

                        $scope.SetSendEvents = function (option) {
                            if (option == "TRUE")
                                $scope.tempDeviceModel.parameters.ReflectedPower.SendEvents = true;
                            else
                                $scope.tempDeviceModel.parameters.ReflectedPower.SendEvents = false;
                        }

                        $scope.SetHoldTime = function (option) {
                            $scope.tempDeviceModel.parameters.ReflectedPower.HoldTime = option;
                        }

                        //#region Formula Evaluation
                        $scope.LowThresholdFormulaIndex = 0;
                        $scope.ChangeLowThresholdFormulaIndex = function (index) {
                            $scope.LowThresholdFormulaIndex = index;
                        }
                        $scope.EvaluateLowThresholdFormula = function () {
                            console.log("serialPortDeviceCtrl.EvaluateLowThresholdFormula: Sending: '/api/serialports/devicemodel/formula'");
                            $http({
                                method: "put",
                                url: "/api/serialports/devicemodel/formulas",
                                data: $scope.tempDeviceModel.parameters.ReflectedPower
                            }).success(function (data) {
                                console.log('serialPortDeviceCtrl.ConfigureReflectedPowerSettings: API data=' + JSON.stringify(data));
                                $scope.tempDeviceModel.parameters.ReflectedPower = data;
                            });
                        }

                        $scope.HighThresholdFormulaIndex = 0;
                        $scope.ChangeHighThresholdFormulaIndex = function (index) {
                            $scope.HighThresholdFormulaIndex = index;
                        }
                        $scope.EvaluateHighThresholdFormula = function () {
                            console.log("serialPortDeviceCtrl.EvaluateHighThresholdFormula: Sending: '/api/serialports/devicemodel/formula'");
                            $http({
                                method: "put",
                                url: "/api/serialports/devicemodel/formulas",
                                data: $scope.tempDeviceModel.parameters.ReflectedPower
                            }).success(function (data) {
                                console.log('serialPortDeviceCtrl.ConfigureReflectedPowerSettings: API data=' + JSON.stringify(data));
                                $scope.tempDeviceModel.parameters.ReflectedPower = data;
                            });
                        }
                        //#endregion Formula Evaluation

                        // Apply button press - update the server
                        $scope.apply = function () {
                            console.log("serialPortDeviceCtrl.ConfigureReflectedPowerSettings: Sending: '/api/serialports/devicemodel/" + $scope.port + "'");
                            $http({
                                method: "put",
                                url: "/api/serialports/devicemodel/" + $scope.port,
                                data: $scope.tempDeviceModel
                            }).success(function (data) {
                                console.log('serialPortDeviceCtrl.ConfigureReflectedPowerSettings: API data=' + JSON.stringify(data));
                                currentDeviceModel.parameters.ReflectedPower = data.parameters.ReflectedPower;
                            });
                            $modalInstance.close();
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });
            };
            //#endregion Configure Reflected Power Settings

            // Configure VSWR Power Settings
            //#region Configure VSWR Power Settings
            //      _port = Current port the device is allocated to ($scope.ThisPort)
            //      currentDeviceModel = DeviceModel for the device to be configured ($scope.DeviceModel)
            //      tempDeviceModel = temporary copy of the DeviceModel for this modal
            $scope.ConfigureVSWRSettings = function (_port, currentDeviceModel) {
                console.log("serialPortDeviceCtrl.ConfigureVSWRSettings: Started")
                var modalInstance = $modal.open({
                    templateUrl: 'devices/DirectionalPower+VSWR-VSWR.html',
                    controller: function ($scope, $modalInstance) {
                        console.log("serialPortDeviceCtrl.ConfigureVSWRSettings: Port=" + (Number(_port) + 1));
                        $scope.modalTitle = "Configure VSWR Power";
                        $scope.modalSubtitle = "for " + currentDeviceModel.id + " on Port= " + (Number(_port) + 1);

                        // Create a copy of the current configuration during the configuration process
                        $scope.tempDeviceModel = angular.copy(currentDeviceModel);
                        $scope.port = _port;

                        // List of possible options for updating the configuration
                        $scope.EnabledOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.SendEventsOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];

                        $scope.LowThresholdPattern = /^(10|[2-9]|1){1,1}(\.\d{0,2})?$/;
                        $scope.HighThresholdPattern = /^(10|[2-9]|1){1,1}(\.\d{0,2})?$/;

                        // Accept changes to the configuration into the temp variable
                        $scope.SetEnabled = function (option) {
                            if (option == "TRUE")
                                $scope.tempDeviceModel.parameters.VSWR.Enabled = true;
                            else
                                $scope.tempDeviceModel.parameters.VSWR.Enabled = false;
                        }

                        $scope.SetSendEvents = function (option) {
                            if (option == "TRUE")
                                $scope.tempDeviceModel.parameters.VSWR.SendEvents = true;
                            else
                                $scope.tempDeviceModel.parameters.VSWR.SendEvents = false;
                        }

                        // Apply button press - update the server
                        $scope.apply = function () {
                            console.log("serialPortDeviceCtrl.ConfigureVSWRSettings: Sending: '/api/serialports/devicemodel/" + $scope.port + "'");
                            $http({
                                method: "put",
                                url: "/api/serialports/devicemodel/" + $scope.port,
                                data: $scope.tempDeviceModel
                            }).success(function (data) {
                                console.log('serialPortDeviceCtrl.ConfigureVSWRSettings: API data=' + JSON.stringify(data));
                                currentDeviceModel.parameters.VSWR = data.parameters.VSWR;
                            });
                            $modalInstance.close();
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });
            };
            //#endregion Configure VSWR Power Settings

            // Configure Temperature Settings
            //#region Configure Temperature Settings
            //      _port = Current port the device is allocated to ($scope.ThisPort)
            //      currentDeviceModel = DeviceModel for the device to be configured ($scope.DeviceModel)
            //      tempDeviceModel = temporary copy of the DeviceModel for this modal
            $scope.ConfigureTemperatureSettings = function (_port, currentDeviceModel) {
                console.log("serialPortDeviceCtrl.ConfigureTemperatureSettings: Started")
                var modalInstance = $modal.open({
                    templateUrl: 'devices/DirectionalPower+VSWR-Temperature.html',
                    controller: function ($scope, $modalInstance) {
                        console.log("serialPortDeviceCtrl.ConfigureTemperatureSettings: Port=" + (Number(_port) + 1));
                        $scope.modalTitle = "Configure Temperature";
                        $scope.modalSubtitle = "for " + currentDeviceModel.id + " on Port= " + (Number(_port) + 1);

                        // Create a copy of the current configuration during the configuration process
                        $scope.tempDeviceModel = angular.copy(currentDeviceModel);
                        $scope.port = _port;

                        // List of possible options for updating the configuration
                        $scope.EnabledOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.SendEventsOptions = [{ option: 'TRUE' }, { option: 'FALSE' }];
                        $scope.HoldTimeOptions = $scope.tempDeviceModel.parameters.Temperature.HoldTimeOptions;

                        $scope.LowThresholdPattern = /^(-){0,1}(50|[1-4]\d|\d)?(\.\d{0,1})?$/;
                        $scope.HighThresholdPattern = /^(-){0,1}(50|[1-4]\d|\d)?(\.\d{0,1})?$/;
                        $scope.QualifierPattern = /^(4[0-8]|[1-3]\d|\d)?$/;

                        // Accept changes to the configuration into the temp variable
                        $scope.SetEnabled = function (option) {
                            if (option == "TRUE")
                                $scope.tempDeviceModel.parameters.Temperature.Enabled = true;
                            else
                                $scope.tempDeviceModel.parameters.Temperature.Enabled = false;
                        }

                        $scope.SetSendEvents = function (option) {
                            if (option == "TRUE")
                                $scope.tempDeviceModel.parameters.Temperature.SendEvents = true;
                            else
                                $scope.tempDeviceModel.parameters.Temperature.SendEvents = false;
                        }

                        $scope.SetHoldTime = function (option) {
                            $scope.tempDeviceModel.parameters.Temperature.HoldTime = option;
                        }

                        //#region Formula Evaluation
                        $scope.LowThresholdFormulaIndex = 0;
                        $scope.ChangeLowThresholdFormulaIndex = function (index) {
                            $scope.LowThresholdFormulaIndex = index;
                        }
                        $scope.EvaluateLowThresholdFormula = function () {
                            console.log("serialPortDeviceCtrl.EvaluateLowThresholdFormula: Sending: '/api/serialports/devicemodel/formula'");
                            $http({
                                method: "put",
                                url: "/api/serialports/devicemodel/formulas",
                                data: $scope.tempDeviceModel.parameters.Temperature
                            }).success(function (data) {
                                console.log('serialPortDeviceCtrl.ConfigureTemperatureSettings: API data=' + JSON.stringify(data));
                                $scope.tempDeviceModel.parameters.Temperature = data;
                            });
                        }

                        $scope.HighThresholdFormulaIndex = 0;
                        $scope.ChangeHighThresholdFormulaIndex = function (index) {
                            $scope.HighThresholdFormulaIndex = index;
                        }
                        $scope.EvaluateHighThresholdFormula = function () {
                            console.log("serialPortDeviceCtrl.EvaluateHighThresholdFormula: Sending: '/api/serialports/devicemodel/formula'");
                            $http({
                                method: "put",
                                url: "/api/serialports/devicemodel/formulas",
                                data: $scope.tempDeviceModel.parameters.Temperature
                            }).success(function (data) {
                                console.log('serialPortDeviceCtrl.ConfigureTemperatureSettings: API data=' + JSON.stringify(data));
                                $scope.tempDeviceModel.parameters.Temperature = data;
                            });
                        }
                        //#endregion Formula Evaluation

                        // Apply button press - update the server
                        $scope.apply = function () {
                            console.log("serialPortDeviceCtrl.ConfigureTemperatureSettings: Sending: '/api/serialports/devicemodel/" + $scope.port + "'");
                            $http({
                                method: "put",
                                url: "/api/serialports/devicemodel/" + $scope.port,
                                data: $scope.tempDeviceModel
                            }).success(function (data) {
                                console.log('serialPortDeviceCtrl.ConfigureTemperatureSettings: API data=' + JSON.stringify(data));
                                currentDeviceModel.parameters.Temperature = data.parameters.Temperature;
                            });
                            $modalInstance.close();
                        };

                        // Cancel button press - do nothing
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };
                    }
                });
            };
            //#endregion Configure Temperature Settings
            //#endregion Configuration Modals

            // Socket Handler
            //#region Socket Handler
            socketManager.on('DirectionalPower+VSWR', function (message) {
                if (message.Port == $scope.ThisPort) {
                    //console.log("Port" + $scope.ThisPort + ".Controller.SocketOn: DirectionalPower+VSWR=" + JSON.stringify(message));

                    switch (message.Message) {
                        case "DeviceInformation":
                            $scope.DeviceModel.parameters.DeviceInformation = message.Parameter.DeviceInformation;
                            break;

                        case "ForwardPower":
                            $scope.DeviceModel.parameters.ForwardPower = message.Parameter.ForwardPower;
                            break;

                        case "ForwardPowerHoldState":
                            $scope.ForwardPowerHoldState = message.Parameter.ForwardPowerHoldState;
                            break;

                        case "ForwardPowerQualifierValue":
                            $scope.DeviceModel.parameters.ForwardPower.QualifierValue = message.Parameter.ForwardPowerQualifierValue;
                            break;

                        case "ReflectedPower":
                            $scope.DeviceModel.parameters.ReflectedPower = message.Parameter.ReflectedPower;
                            break;

                        case "ReflectedPowerHoldState":
                            $scope.ReflectedPowerHoldState = message.Parameter.ReflectedPowerHoldState;
                            break;

                        case "ReflectedPowerQualifierValue":
                            $scope.DeviceModel.parameters.ReflectedPower.QualifierValue = message.Parameter.ReflectedPowerQualifierValue;
                            break;

                        case "VSWR":
                            $scope.DeviceModel.parameters.VSWR = message.Parameter.VSWR;
                            break;

                        case "VSWRHoldState":
                            $scope.VSWRHoldState = message.Parameter.VSWRHoldState;
                            break;

                        case "VSWRQualifierValue":
                            $scope.DeviceModel.parameters.VSWR.QualifierValue = message.Parameter.VSWRQualifierValue;
                            break;

                        case "Temperature":
                            $scope.DeviceModel.parameters.Temperature = message.Parameter.Temperature;
                            break;
                        case "TemperatureHoldState":
                            $scope.TemperatureHoldState = message.Parameter.TemperatureHoldState;
                            break;

                        case "TemperatureQualifierValue":
                            $scope.DeviceModel.parameters.Temperature.QualifierValue = message.Parameter.TemperatureQualifierValue;
                            break;

                    }
                }
            });

            //#endregion Socket Handler
        }
    ])
    //#endregion Serial Port Device Controller

    //#region Logging Controller
    .controller('loggingCtrl', [
        '$scope',
        '$http',
        'socketManager',
        function ($scope, $http, socketManager) {
            // Administrative controller stuff
            $scope.$on('$stateChangeSuccess', function () {
                console.log("Controller: loggingCtrl");
            });

            $scope.$on('$destroy', function (event) {
                socketManager.removeAllListeners();
            });

            $scope.LoggingSummary = "";

            // Handle incoming socket.io updates            
            //socketManager.on('SerialInput', function (message) {
            //    $('#IdLoggingTable').html(message.TimeChanged + "- Received Message: " + message.User)
            //    $('#IdLoggingTable').css('color', 'red');
            //    setTimeout(function () { $('#IdLogging').css('color', 'black') }, 1200);
            //});

            socketManager.on('DigitalInputs', function (message) {
                var table = document.getElementById("IdLoggingTable");
                if (table.rows.length == 15) table.deleteRow(1);
                var row = document.getElementById("IdLoggingTable").insertRow(0);
                var cell = row.insertCell(0);
                cell.innerHTML = "     " + message.TimeChanged + "  - Digital Input Address(" + message.Address + ") has new value=" + message.Value;
                cell.style.color = 'red';
                setTimeout(function () { cell.style.color = 'black'; }, 1200);
            });

            socketManager.on('DigitalOutputs', function (message) {
                var table = document.getElementById("IdLoggingTable");
                if (table.rows.length == 15) table.deleteRow(1);
                var row = document.getElementById("IdLoggingTable").insertRow(0);
                var cell = row.insertCell(0);
                cell.innerHTML = "     " + message.TimeChanged + "  - Digital Output Address(" + message.Address + ") has new value=" + message.Value;
                cell.style.color = 'red';
                setTimeout(function () { cell.style.color = 'black'; }, 1200);
            });

            socketManager.on('AnalogInputs', function (message) {
                var table = document.getElementById("IdLoggingTable");
                if (table.rows.length == 15) table.deleteRow(1);
                var row = document.getElementById("IdLoggingTable").insertRow(0);
                var cell = row.insertCell(0);
                cell.innerHTML = "     " + message.TimeChanged + "  - Analog Input Address(" + message.Address + ") has new [raw] value=" + message.RawValue;
                cell.style.color = 'red';
                setTimeout(function () { cell.style.color = 'black'; }, 1200);
            });

            socketManager.on('AnalogOutputs', function (message) {
                var table = document.getElementById("IdLoggingTable");
                if (table.rows.length == 15) table.deleteRow(1);
                var row = document.getElementById("IdLoggingTable").insertRow(0);
                var cell = row.insertCell(0);
                cell.innerHTML = "     " + message.TimeChanged + "  - Analog Output Address(" + message.Address + ") has new [raw] value=" + message.RawValue;
                cell.style.color = 'red';
                setTimeout(function () { cell.style.color = 'black'; }, 1200);
            });

            socketManager.on('SerialInput', function (message) {
                var table = document.getElementById("IdLoggingTable");
                if (table.rows.length == 15) table.deleteRow(1);
                var row = document.getElementById("IdLoggingTable").insertRow(0);
                var cell = row.insertCell(0);
                cell.innerHTML = "     " + message.TimeChanged + "  - Serial Address(" + message.Address + ") has new value=" + message.User;
                cell.style.color = 'red';
                setTimeout(function () { cell.style.color = 'black'; }, 1200);
            });

            $('.footable').footable({
                toggleSelector: " > tbody > tr > td > span.footable-toggle"
            })

        }
    ])
    //#endregion Logging Controller

    //#region UNUSED CONTROLLERS
    .controller('advancedCtrl', [
        '$scope',
        '$http',
        'socketManager',
        function ($scope, $http, socketManager) {
            // Administrative controller stuff
            $scope.$on('$stateChangeSuccess', function () {
                console.log("Controller: advancedCtrl");
            });

            $scope.$on('$destroy', function (event) {
                socketManager.removeAllListeners();
            });

            $('#IdSnmp').footable({
                toggleSelector: " > tbody > tr > td > span.footable-toggle"
            })
            $('#IdAccessControl').footable({
                toggleSelector: " > tbody > tr > td > span.footable-toggle"
            })
            $('#IdEnvironmentalControl').footable({
                toggleSelector: " > tbody > tr > td > span.footable-toggle"
            })
            $('#IdSiteControl').footable({
                toggleSelector: " > tbody > tr > td > span.footable-toggle"
            })
            $('#IdRadioControl').footable({
                toggleSelector: " > tbody > tr > td > span.footable-toggle"
            })
            $('#IdPowerManagement').footable({
                toggleSelector: " > tbody > tr > td > span.footable-toggle"
            })
            $('#IdGps').footable({
                toggleSelector: " > tbody > tr > td > span.footable-toggle"
            })
        }
    ])

    .controller('dashboardCtrl', [
        '$scope',
        'files',
        function ($scope, files) {
            // run scripts after state load
            $scope.$on('$stateChangeSuccess', function () {
                console.log("Controller: dashboardCtrl");
                // init dashboard functions
                $scope.$watch('countries_data', function () {
                    countries_data = $scope.countries_data;
                    yukon_dashboard.init();
                });
            })
        }
    ])

    .controller('formExtendedCtrl', [
        '$scope',
        'files',
        function ($scope, files) {
            $scope.$on('$stateChangeSuccess', function () {
                $scope.date_range = {
                    today: moment().format('MMMM D, YYYY'),
                    last_month: moment().subtract('M', 1).format('MMMM D, YYYY')
                };
                // init form.extended_elements functions
                yukon_extended_elements.init();
            })
        }
    ])

    .controller('formValidationCtrl', [
        '$scope',
        'files',
        function ($scope, files) {
            $scope.$on('$stateChangeSuccess', function () {
                // init form.validation functions
                yukon_form_validation.init();
            })
        }
    ])

    .controller('formWizardCtrl', [
        '$scope',
        '$timeout',
        function ($scope, $timeout) {
            $scope.$on('$stateChangeSuccess', function () {
                // prism highlight
                Prism.highlightAll();
                // init form.extended_elements functions
                $timeout(function () { yukon_wizard.init(); }, 0);
            })
        }
    ])

    .controller('chatCtrl', [
        '$scope',
        'files',
        function ($scope, files) {
            $scope.$on('$stateChangeSuccess', function () {
                // init chat functions
                yukon_chat.send_msg();
            })
        }
    ])

    .controller('userListCtrl', [
        '$scope',
        'userLists',
        'files',
        '$window',
        function ($scope, userLists, files, $window) {
            $scope.userList = userLists;
            $scope.userListItems = $scope.userList.length;
            $scope.$on('onRepeatLast', function (scope, element, attrs) {
                $('#user_list').listnav({
                    filterSelector: '.ul_lastName',
                    includeNums: false,
                    removeDisabled: true,
                    showCounts: false,
                    onClick: function (letter) {
                        $scope.userListItems = $window.document.getElementsByClassName("listNavShow").length;
                        $scope.$apply();
                    }
                });
            });
        }
    ])

    .controller('userProfileCtrl', [
        '$scope',
        'files',
        function ($scope, files) {
            // run scripts after state load
            $scope.$on('$stateChangeSuccess', function () {
                yukon_user_profile.init();
            })
        }
    ])

    .controller('helpFaqCtrl', [
        '$scope',
        '$http',
        '$state',
        function ($scope, $http, $state) {
            // get data from json
            $http.get('data/faq_help.json')
                .success(function (data, status, headers, config) {
                    $scope.faq = data;
                    // get curent category id
                    $scope.$state = $state;
                    $scope.stateActive = $state.current.name;
                    angular.forEach($scope.faq, function (value, key) {
                        if (value.link == $scope.stateActive) {
                            $scope.catId = value.id;
                        }
                    });
                }).
                error(function (data, status, headers, config) {
                    console.log(status);
                });

            // get category id
            $scope.categoryId = function (id) {
                $scope.catId = id;
            }
        }
    ])

    .controller('invoicesCtrl', [
        '$scope',
        'files',
        function ($scope, files) {
            // generate qrcode
            $scope.$watch('qr_base_size', function () {
                $('#invoice_qrcode').css({ 'width': $scope.qr_base_size / 2, 'height': $scope.qr_base_size / 2 }).qrcode({
                    render: 'canvas',
                    size: $scope.qr_base_size,
                    text: $scope.qr_text
                }).children('img').prop('title', $scope.qr_text);
            });
        }
    ])

    .controller('mailboxCtrl', [
        '$scope',
        '$http',
        '$state',
        '$stateParams',
        'files',
        'utils',
        function ($scope, $http, $state, $stateParams, files, utils) {

            // get data from json
            $http.get('data/mailbox.json')
                .success(function (data, status, headers, config) {
                    $scope.folders = data;

                    $scope.messageItem = [];
                    // get curent folder id
                    $scope.$state = $state;
                    $scope.stateActive = $state.current.name;
                    angular.forEach($scope.folders, function (value, key) {
                        if (value.link == $scope.stateActive) {
                            $scope.foldId = value.folderId;
                        }
                        if (value.showCount) {
                            $scope.countMessages = function (id) {
                                return $scope.folders[id]['messages'].length;
                            }
                        }
                    });
                }).
                error(function (data, status, headers, config) {
                    //console.log(status);
                });

            $scope.selectAll = [];
            $scope.checkAll = function (id) {
                if ($scope.selectAll[id]) {
                    $scope.selectAll[id] = false;
                } else {
                    $scope.selectAll[id] = true;
                }
                angular.forEach($scope.folders[id]['messages'], function (message) {
                    message.selected = $scope.selectAll[id];
                });
            };

            $scope.$on('onRepeatLast', function (scope, element, attrs) {
                $('#mailbox_table').footable({
                    toggleSelector: " > tbody > tr > td > span.footable-toggle"
                });
            });

            // get folder id
            $scope.folderId = function (id) {
                $scope.foldId = id;
            }

        }
    ])

    .controller('mailDetailsCtrl', [
        '$scope',
        '$state',
        '$stateParams',
        'messageDetails',
        'utils',
        function ($scope, $state, $stateParams, messageDetails, utils) {
            $scope.messages = messageDetails;
            $scope.messageDetails = utils.findById($scope.messages, $stateParams.messageId);
        }
    ])

    .controller('galleryCtrl', [
        '$scope',
        'images',
        'files',
        function ($scope, images, files) {
            $scope.gallery = images;

            $scope.$on('onRepeatLast', function (scope, element, attrs) {
                $('.gallery_grid .img_wrapper').magnificPopup({
                    type: 'image',
                    gallery: {
                        enabled: true,
                        arrowMarkup: '<i title="%title%" class="el-icon-chevron-%dir% mfp-nav"></i>'
                    },
                    image: {
                        titleSrc: function (item) {
                            return item.el.attr('title') + '<small>' + item.el.children(".gallery_image_tags").text() + '</small>';
                        }
                    },
                    removalDelay: 500, //delay removal by X to allow out-animation
                    callbacks: {
                        beforeOpen: function () {
                            $('html').addClass('magnific-popup-open');
                            // just a hack that adds mfp-anim class to markup
                            this.st.image.markup = this.st.image.markup.replace('mfp-figure', 'mfp-figure mfp-with-anim');
                            this.st.mainClass = 'mfp-zoom-in';
                        },
                        close: function () {
                            $('html').removeClass('magnific-popup-open');
                        }
                    },
                    retina: {
                        ratio: 2
                    },
                    closeOnContentClick: true,
                    midClick: true // allow opening popup on middle mouse click. Always set it to true if you don't provide alternative source.
                });
            });

        }
    ])

    .controller('notificationsPopupsCtrl', [
        '$scope',
        '$modal',
        'growl',
        function ($scope, $modal, growl) {

            // bootstrap modals
            $scope.modalOpen = function (size) {
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/bootstrapModal.html',
                    size: size,
                    controller: function ($scope, $modalInstance) {

                        $scope.modalTitle = 'Modal Title';
                        $scope.modalContent = '<p>Software Upgrade available: v1.00.4021</p><p>Architecto autem, eligendi enim est et illum ipsam laboriosam magni minima molestiae perferendis placeat quae unde&hellip;</p>';

                        $scope.ok = function () {
                            $modalInstance.close();
                        };
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };

                    }
                });
            };

            // growl
            $scope.basicUsage = function (type) {
                var config = {};
                switch (type) {
                    case "success":
                        growl.success("<b>I'm</b> a success message", config);
                        break;
                    case "info":
                        growl.info("I'm an info message", config);
                        break;
                    case "warning":
                        growl.warning("I'm the warning message", config);
                        break;
                    default:
                        growl.error("Ups, error message here!", config);
                }
            }

            // get comment id
            $scope.getCommentId = function (id) {
                $scope.commentId = id;
            };

            // jBox
            $scope.$on('$stateChangeSuccess', function () {
                new jBox('Modal', {
                    width: 340,
                    height: 180,
                    attach: $('#jbox_modal_drag'),
                    draggable: 'title',
                    closeButton: 'title',
                    title: 'Click here to drag me around',
                    content: 'You can move this modal window'
                });

                new jBox('Confirm', {
                    closeButton: false,
                    confirmButton: 'Yes',
                    cancelButton: 'No',
                    _onOpen: function () {
                        // Set the new action for the submit button
                        this.submitButton
                            .off('click.jBox-Confirm' + this.id)
                            .on('click.jBox-Confirm' + this.id, function () {
                                new jBox('Notice', {
                                    offset: {
                                        y: 36
                                    },
                                    content: 'Comment deleted: id=' + $scope.commentId
                                });
                                this.close();
                            }.bind(this));
                    }
                });

                $scope.jBoxNotice_def = function () {
                    new jBox('Notice', {
                        offset: {
                            y: 36
                        },
                        stack: false,
                        autoClose: 30000,
                        animation: {
                            open: 'slide:top',
                            close: 'slide:right'
                        },
                        onInit: function () {
                            this.options.content = 'Default notification';
                        }
                    })
                };

                $scope.jBoxNotice_audio = function () {
                    new jBox('Notice', {
                        attributes: {
                            x: 'right',
                            y: 'bottom'
                        },
                        theme: 'NoticeBorder',
                        color: 'green',
                        audio: 'assets/lib/jBox-0.3.0/Source/audio/bling2',
                        volume: '100',
                        stack: false,
                        autoClose: 3000,
                        animation: {
                            open: 'slide:bottom',
                            close: 'slide:left'
                        },
                        onInit: function () {
                            this.options.title = 'Title';
                            this.options.content = 'Notification with audio effect';
                        }
                    })
                };

                $scope.jBoxNotice_audio_50 = function () {
                    new jBox('Notice', {
                        attributes: {
                            x: 'right',
                            y: 'top'
                        },
                        offset: {
                            y: 36
                        },
                        theme: 'NoticeBorder',
                        color: 'blue',
                        audio: 'assets/lib/jBox-0.3.0/Source/audio/beep2',
                        volume: '60',
                        stack: false,
                        autoClose: 3000,
                        animation: {
                            open: 'slide:top',
                            close: 'slide:right'
                        },
                        onInit: function () {
                            this.options.title = 'Title';
                            this.options.content = 'Volume set to 60%';
                        }
                    })
                };

            });
        }
    ])

    .controller('bootstrapUICtrl', [
        '$scope',
        '$modal',
        function ($scope, $modal) {
            // accordions
            $scope.oneAtATime = true;

            $scope.groups = [
                {
                    title: 'Dynamic Group Header - 1',
                    content: 'Dynamic Group Body - 1'
                },
                {
                    title: 'Dynamic Group Header - 2',
                    content: 'Dynamic Group Body - 2'
                }
            ];

            $scope.items = ['Item 1', 'Item 2', 'Item 3'];

            $scope.addItem = function () {
                var newItemNo = $scope.items.length + 1;
                $scope.items.push('Item ' + newItemNo);
            };

            $scope.status = {
                isFirstOpen: true,
                isFirstDisabled: false
            };

            // alerts
            $scope.alerts = [
                { type: 'danger', msg: '<strong>Oh snap!</strong> Change a few <a class="alert-link">things</a> up and try submitting again.' },
                { type: 'success', msg: 'Well done! You successfully read this important alert message.' }
            ];

            $scope.addAlert = function () {
                var alertType = ['warning', 'success', 'info', 'danger'];
                $scope.alerts.push({ type: alertType[Math.floor(Math.random() * alertType.length)], msg: 'Another alert!' });
            };

            $scope.closeAlert = function (index) {
                $scope.alerts.splice(index, 1);
            };

            // dropdowns
            $scope.toggled = function (open) {
                console.log('Dropdown is now: ', open);
            };
            $scope.toggleDropdown = function ($event) {
                $event.preventDefault();
                $event.stopPropagation();
                $scope.status.isopen = !$scope.status.isopen;
            };

            // bootstrap modals
            $scope.modalOpen = function (size) {
                var modalInstance = $modal.open({
                    templateUrl: 'views/partials/bootstrapModal.html',
                    size: size,
                    controller: function ($scope, $modalInstance) {

                        $scope.modalTitle = 'Modal Title';
                        $scope.modalContent = '<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit.</p><p>Architecto autem, eligendi enim est et illum ipsam laboriosam magni minima molestiae perferendis placeat quae unde&hellip;</p>';

                        $scope.ok = function () {
                            $modalInstance.close();
                        };
                        $scope.cancel = function () {
                            $modalInstance.dismiss('cancel');
                        };

                    }
                });
            };

            // pagination
            $scope.totalItems = 64;
            $scope.currentPage = 4;

            $scope.setPage = function (pageNo) {
                $scope.currentPage = pageNo;
            };

            $scope.pageChanged = function () {
                console.log('Page changed to: ' + $scope.currentPage);
            };

            $scope.maxSize = 5;
            $scope.bigTotalItems = 175;
            $scope.bigCurrentPage = 1;

            // tooltip
            $scope.dynamicTooltip = 'Hello, World!';
            $scope.dynamicTooltipText = 'dynamic';
            $scope.htmlTooltip = 'I\'ve been made <b>bold</b>!';

            // tabs
            $scope.tabs = [
                { title: 'Dynamic Title 1', content: 'Dynamic content 1' },
                { title: 'Dynamic Title 2', content: 'Dynamic content 2', disabled: true }
            ];
            $scope.alertMe = function () {
                alert('You\'ve selected the alert tab!');
            };

        }
    ])

    .controller('calendarBasicCtrl', [
        '$scope',
        function ($scope) {
            var date = new Date();
            var d = date.getDate();
            var m = date.getMonth();
            var y = date.getFullYear();

            $('#calendar').fullCalendar({
                header: {
                    center: 'title',
                    left: 'month,agendaWeek,agendaDay today',
                    right: 'prev,next'
                },
                buttonIcons: {
                    prev: ' el-icon-chevron-left',
                    next: ' el-icon-chevron-right'
                },
                editable: true,
                aspectRatio: 2.2,
                events: [
                    {
                        title: 'All Day Event',
                        start: new Date(y, m, 1)
                    },
                    {
                        title: 'Long Event',
                        start: new Date(y, m, d - 5),
                        end: new Date(y, m, d - 2)
                    },
                    {
                        id: 999,
                        title: 'Repeating Event',
                        start: new Date(y, m, d - 3, 16, 0)
                    },
                    {
                        id: 999,
                        title: 'Repeating Event',
                        start: new Date(y, m, d + 4, 16, 0)
                    },
                    {
                        title: 'Meeting',
                        start: new Date(y, m, d + 1, 19, 0),
                        end: new Date(y, m, d + 1, 22, 30)
                    },
                    {
                        title: 'Lunch',
                        start: new Date(y, m, d - 7)
                    },
                    {
                        title: 'Birthday Party',
                        start: new Date(y, m, d + 10)
                    },
                    {
                        title: 'Click for Google',
                        url: 'http://google.com/',
                        start: new Date(y, m, d + 12)
                    }
                ],
                eventAfterAllRender: function () {
                    $('.fc-header .fc-button-prev').html('<span class="el-icon-chevron-left"></span>');
                    $('.fc-header .fc-button-next').html('<span class="el-icon-chevron-right"></span>');
                }
            });

        }
    ])

    .controller('calendarLunarCtrl', [
        '$scope',
        function ($scope) {

            $('#calendar_phases').fullCalendar({
                header: {
                    center: 'title',
                    left: 'month,agendaWeek,agendaDay today',
                    right: 'prev,next'
                },
                buttonIcons: false,
                aspectRatio: 2.2,
                // Phases of the Moon
                events: 'https://www.google.com/calendar/feeds/ht3jlfaac5lfd6263ulfh4tql8%40group.calendar.google.com/public/basic',
                eventClick: function (event) {
                    // opens events in a popup window
                    window.open(event.url, 'gcalevent', 'width=700,height=600');
                    return false;
                },
                eventAfterAllRender: function () {
                    $('.fc-header .fc-button-prev').html('<span class="el-icon-chevron-left"></span>');
                    $('.fc-header .fc-button-next').html('<span class="el-icon-chevron-right"></span>');
                }
            });

        }
    ])

    .controller('chartsCtrl', [
        '$scope',
        function ($scope) {

            // cobined chart
            c3.generate({
                bindto: '#c3_combined',
                data: {
                    columns: [
                        ['data1', 30, 20, 50, 40, 60, 50],
                        ['data2', 200, 130, 90, 240, 130, 220],
                        ['data3', 200, 130, 90, 240, 130, 220],
                        ['data4', 130, 120, 150, 140, 160, 150],
                        ['data5', 90, 70, 20, 50, 60, 120],
                    ],
                    type: 'bar',
                    types: {
                        data3: 'line',
                        data5: 'area',
                    },
                    groups: [
                        ['data1', 'data2']
                    ]
                },
                point: {
                    r: '4',
                    focus: {
                        expand: {
                            r: '5'
                        }
                    }
                },
                bar: {
                    width: {
                        ratio: 0.4 // this makes bar width 50% of length between ticks
                    }
                },
                grid: {
                    x: {
                        show: true
                    },
                    y: {
                        show: true
                    }
                },
                color: {
                    pattern: ['#ff7f0e', '#2ca02c', '#9467bd', '#1f77b4', '#d62728']
                }
            });

            // gauge chart
            var chart_gauge = c3.generate({
                bindto: '#c3_gauge',
                data: {
                    columns: [
                        ['data', 91.4]
                    ],
                    type: 'gauge',
                    onclick: function (d, i) { console.log("onclick", d, i); },
                    onmouseover: function (d, i) { console.log("onmouseover", d, i); },
                    onmouseout: function (d, i) { console.log("onmouseout", d, i); }
                },
                gauge: {
                    width: 39
                },
                color: {
                    pattern: ['#ff0000', '#f97600', '#f6c600', '#60b044'],
                    threshold: {
                        values: [30, 60, 90, 100]
                    }
                }
            });

            setTimeout(function () {
                chart_gauge.load({
                    columns: [['data', 10]]
                });
            }, 2000);
            setTimeout(function () {
                chart_gauge.load({
                    columns: [['data', 50]]
                });
            }, 3000);
            setTimeout(function () {
                chart_gauge.load({
                    columns: [['data', 70]]
                });
            }, 4000);
            setTimeout(function () {
                chart_gauge.load({
                    columns: [['data', 0]]
                });
            }, 5000);
            setTimeout(function () {
                chart_gauge.load({
                    columns: [['data', 100]]
                });
            }, 6000);

            // donut chart
            var chart_donut = c3.generate({
                bindto: '#c3_donut',
                data: {
                    columns: [
                        ['data1', 30],
                        ['data2', 120],
                    ],
                    type: 'donut',
                    onclick: function (d, i) { console.log("onclick", d, i); },
                    onmouseover: function (d, i) { console.log("onmouseover", d, i); },
                    onmouseout: function (d, i) { console.log("onmouseout", d, i); }
                },
                donut: {
                    title: "Iris Petal Width"
                }
            });
            setTimeout(function () {
                chart_donut.load({
                    columns: [
                        ["setosa", 0.2, 0.2, 0.2, 0.2, 0.2, 0.4, 0.3, 0.2, 0.2, 0.1, 0.2, 0.2, 0.1, 0.1, 0.2, 0.4, 0.4, 0.3, 0.3, 0.3, 0.2, 0.4, 0.2, 0.5, 0.2, 0.2, 0.4, 0.2, 0.2, 0.2, 0.2, 0.4, 0.1, 0.2, 0.2, 0.2, 0.2, 0.1, 0.2, 0.2, 0.3, 0.3, 0.2, 0.6, 0.4, 0.3, 0.2, 0.2, 0.2, 0.2],
                        ["versicolor", 1.4, 1.5, 1.5, 1.3, 1.5, 1.3, 1.6, 1.0, 1.3, 1.4, 1.0, 1.5, 1.0, 1.4, 1.3, 1.4, 1.5, 1.0, 1.5, 1.1, 1.8, 1.3, 1.5, 1.2, 1.3, 1.4, 1.4, 1.7, 1.5, 1.0, 1.1, 1.0, 1.2, 1.6, 1.5, 1.6, 1.5, 1.3, 1.3, 1.3, 1.2, 1.4, 1.2, 1.0, 1.3, 1.2, 1.3, 1.3, 1.1, 1.3],
                        ["virginica", 2.5, 1.9, 2.1, 1.8, 2.2, 2.1, 1.7, 1.8, 1.8, 2.5, 2.0, 1.9, 2.1, 2.0, 2.4, 2.3, 1.8, 2.2, 2.3, 1.5, 2.3, 2.0, 2.0, 1.8, 2.1, 1.8, 1.8, 1.8, 2.1, 1.6, 1.9, 2.0, 2.2, 1.5, 1.4, 2.3, 2.4, 1.8, 1.8, 2.1, 2.4, 2.3, 1.9, 2.3, 2.5, 2.3, 1.9, 2.0, 2.3, 1.8],
                    ]
                });
            }, 2500);
            setTimeout(function () {
                chart_donut.unload({
                    ids: 'data1'
                });
                chart_donut.unload({
                    ids: 'data2'
                });
            }, 4500);

            // grid lines
            var chart_grid_lines = c3.generate({
                bindto: '#c3_grid_lines',
                data: {
                    columns: [
                        ['sample', 30, 200, 100, 400, 150, 250],
                        ['sample2', 1300, 1200, 1100, 1400, 1500, 1250],
                    ],
                    axes: {
                        sample2: 'y2'
                    }
                },
                axis: {
                    y2: {
                        show: true
                    }
                },
                grid: {
                    y: {
                        lines: [{ value: 50, text: 'Label 50' }, { value: 1300, text: 'Label 1300', axis: 'y2' }]
                    }
                }
            });

            // scatter plot
            var chart_scatter = c3.generate({
                bindto: '#c3_scatter',
                data: {
                    xs: {
                        setosa: 'setosa_x',
                        versicolor: 'versicolor_x',
                    },
                    // iris data from R
                    columns: [
                        ["setosa_x", 3.5, 3.0, 3.2, 3.1, 3.6, 3.9, 3.4, 3.4, 2.9, 3.1, 3.7, 3.4, 3.0, 3.0, 4.0, 4.4, 3.9, 3.5, 3.8, 3.8, 3.4, 3.7, 3.6, 3.3, 3.4, 3.0, 3.4, 3.5, 3.4, 3.2, 3.1, 3.4, 4.1, 4.2, 3.1, 3.2, 3.5, 3.6, 3.0, 3.4, 3.5, 2.3, 3.2, 3.5, 3.8, 3.0, 3.8, 3.2, 3.7, 3.3],
                        ["versicolor_x", 3.2, 3.2, 3.1, 2.3, 2.8, 2.8, 3.3, 2.4, 2.9, 2.7, 2.0, 3.0, 2.2, 2.9, 2.9, 3.1, 3.0, 2.7, 2.2, 2.5, 3.2, 2.8, 2.5, 2.8, 2.9, 3.0, 2.8, 3.0, 2.9, 2.6, 2.4, 2.4, 2.7, 2.7, 3.0, 3.4, 3.1, 2.3, 3.0, 2.5, 2.6, 3.0, 2.6, 2.3, 2.7, 3.0, 2.9, 2.9, 2.5, 2.8],
                        ["setosa", 0.2, 0.2, 0.2, 0.2, 0.2, 0.4, 0.3, 0.2, 0.2, 0.1, 0.2, 0.2, 0.1, 0.1, 0.2, 0.4, 0.4, 0.3, 0.3, 0.3, 0.2, 0.4, 0.2, 0.5, 0.2, 0.2, 0.4, 0.2, 0.2, 0.2, 0.2, 0.4, 0.1, 0.2, 0.2, 0.2, 0.2, 0.1, 0.2, 0.2, 0.3, 0.3, 0.2, 0.6, 0.4, 0.3, 0.2, 0.2, 0.2, 0.2],
                        ["versicolor", 1.4, 1.5, 1.5, 1.3, 1.5, 1.3, 1.6, 1.0, 1.3, 1.4, 1.0, 1.5, 1.0, 1.4, 1.3, 1.4, 1.5, 1.0, 1.5, 1.1, 1.8, 1.3, 1.5, 1.2, 1.3, 1.4, 1.4, 1.7, 1.5, 1.0, 1.1, 1.0, 1.2, 1.6, 1.5, 1.6, 1.5, 1.3, 1.3, 1.3, 1.2, 1.4, 1.2, 1.0, 1.3, 1.2, 1.3, 1.3, 1.1, 1.3],
                    ],
                    type: 'scatter'
                },
                axis: {
                    x: {
                        label: 'Sepal.Width',
                        tick: {
                            fit: false
                        }
                    },
                    y: {
                        label: 'Petal.Width'
                    }
                }
            });

            setTimeout(function () {
                chart_scatter.load({
                    xs: {
                        virginica: 'virginica_x'
                    },
                    columns: [
                        ["virginica_x", 3.3, 2.7, 3.0, 2.9, 3.0, 3.0, 2.5, 2.9, 2.5, 3.6, 3.2, 2.7, 3.0, 2.5, 2.8, 3.2, 3.0, 3.8, 2.6, 2.2, 3.2, 2.8, 2.8, 2.7, 3.3, 3.2, 2.8, 3.0, 2.8, 3.0, 2.8, 3.8, 2.8, 2.8, 2.6, 3.0, 3.4, 3.1, 3.0, 3.1, 3.1, 3.1, 2.7, 3.2, 3.3, 3.0, 2.5, 3.0, 3.4, 3.0],
                        ["virginica", 2.5, 1.9, 2.1, 1.8, 2.2, 2.1, 1.7, 1.8, 1.8, 2.5, 2.0, 1.9, 2.1, 2.0, 2.4, 2.3, 1.8, 2.2, 2.3, 1.5, 2.3, 2.0, 2.0, 1.8, 2.1, 1.8, 1.8, 1.8, 2.1, 1.6, 1.9, 2.0, 2.2, 1.5, 1.4, 2.3, 2.4, 1.8, 1.8, 2.1, 2.4, 2.3, 1.9, 2.3, 2.5, 2.3, 1.9, 2.0, 2.3, 1.8],
                    ]
                });
            }, 1000);

            setTimeout(function () {
                chart_scatter.unload({
                    ids: 'setosa'
                });
            }, 2000);

            setTimeout(function () {
                chart_scatter.load({
                    columns: [
                        ["virginica", 0.2, 0.2, 0.2, 0.2, 0.2, 0.4, 0.3, 0.2, 0.2, 0.1, 0.2, 0.2, 0.1, 0.1, 0.2, 0.4, 0.4, 0.3, 0.3, 0.3, 0.2, 0.4, 0.2, 0.5, 0.2, 0.2, 0.4, 0.2, 0.2, 0.2, 0.2, 0.4, 0.1, 0.2, 0.2, 0.2, 0.2, 0.1, 0.2, 0.2, 0.3, 0.3, 0.2, 0.6, 0.4, 0.3, 0.2, 0.2, 0.2, 0.2],
                    ]
                });
            }, 3000);
        }
    ])

    .controller('gmapsCtrl', [
        '$scope',
        function ($scope) {

            // basic google maps
            new GMaps({
                div: '#gmap_basic',
                lat: -12.043333,
                lng: -77.028333
            });

            // with markers
            map_markers = new GMaps({
                el: '#gmap_markers',
                lat: 51.500902,
                lng: -0.124531
            });
            map_markers.addMarker({
                lat: 51.497714,
                lng: -0.12991,
                title: 'Westminster',
                details: {
                    // You can attach additional information, which will be passed to Event object (e) in the events previously defined.
                },
                click: function (e) {
                    alert('You clicked in this marker');
                },
                mouseover: function (e) {
                    if (console.log) console.log(e);
                }
            });
            map_markers.addMarker({
                lat: 51.500891,
                lng: -0.123347,
                title: 'Westminster Bridge',
                infoWindow: {
                    content: '<div class="infoWindow_content"><p>Westminster Bridge is a road and foot traffic bridge over the River Thames...</p><a href="http://en.wikipedia.org/wiki/Westminster_Bridge" target="_blank">wikipedia</a></div>'
                }
            });

            // static map
            if (window.devicePixelRatio >= 2) {
                var img_scale = '&scale=2'
                background_size = 'background-size: 640px 640px;';

            } else {
                var img_scale = '',
                    background_size = '';
            }
            url = GMaps.staticMapURL({
                size: [640, 640],
                lat: -37.824972,
                lng: 144.958735,
                zoom: 10
            });
            $('#gmap_static').append('<span class="gmap-static" style="height:100%;display:block;background: url(' + url + img_scale + ') no-repeat 50% 50%;' + background_size + '"><img src="' + url + '" style="visibility:hidden" alt="" /></span>');

            // geocoding
            map_geocode = new GMaps({
                el: '#gmap_geocoding',
                lat: 55.478853,
                lng: 15.117188,
                zoom: 3
            });
            $('#geocoding_form').submit(function (e) {
                e.preventDefault();
                GMaps.geocode({
                    address: $('#gmaps_address').val().trim(),
                    callback: function (results, status) {
                        if (status == 'OK') {
                            var latlng = results[0].geometry.location;
                            map_geocode.setCenter(latlng.lat(), latlng.lng());
                            map_geocode.addMarker({
                                lat: latlng.lat(),
                                lng: latlng.lng()
                            });
                            map_geocode.map.setZoom(15);
                            $('#gmaps_address').val('');
                        }
                    }
                });
            });

        }
    ])

    .controller('footablesCtrl', [
        '$scope',
        function ($scope) {
            $('#footable_demo').footable({
                toggleSelector: " > tbody > tr > td > span.footable-toggle"
            }).on({
                'footable_filtering': function (e) {
                    var selected = $scope.userStatus;
                    if (selected && selected.length > 0) {
                        e.filter += (e.filter && e.filter.length > 0) ? ' ' + selected : selected;
                        e.clear = !e.filter;
                    }
                }
            });

            $scope.clearFilters = function () {
                $('.filter-status').val('');
                $('#footable_demo').trigger('footable_clear_filter');
            }

            $scope.filterTable = function (userStatus) {
                $('#footable_demo').data('footable-filter').filter($('#textFilter').val());
            }
        }
    ])

    .controller('datatablesCtrl', [
        '$scope',
        '$timeout',
        function ($scope, $timeout) {

            var table = $('#datatable_demo').dataTable({
                "iDisplayLength": 25
            });

            $timeout(function () {
                oFH = new $.fn.dataTable.FixedHeader(table, {
                    "offsetTop": 48
                });
                oFH.fnUpdate();
            }, 2000);

            // please also add "updateFixedHeaders" directive (update fixedHeaders position on window resize) to parent element

        }
    ])

    .controller('vectorMapsCtrl', [
        '$scope',
        function ($scope) {

            // random colors
            var palette = ['#1f77b4', '#3a9add', '#888'];
            generateColors = function () {
                var colors = {},
                    key;
                for (key in map_ca.regions) {
                    colors[key] = palette[Math.floor(Math.random() * palette.length)];
                }
                return colors;
            };
            map_ca = new jvm.WorldMap({
                map: 'ca_mill_en',
                container: $('#vmap_canada'),
                backgroundColor: 'transparent',
                series: {
                    regions: [
                        {
                            attribute: 'fill'
                        }
                    ]
                }
            });
            map_ca.series.regions[0].setValues(generateColors());

            $scope.updateColors = function () {
                map_ca.series.regions[0].setValues(generateColors());
            };

            // markers on the map
            $('#vmap_markers').vectorMap({
                map: 'world_mill_en',
                backgroundColor: 'transparent',
                scaleColors: ['#c8eeff', '#0071a4'],
                normalizeFunction: 'polynomial',
                hoverColor: false,
                regionStyle: {
                    initial: {
                        fill: '#888'
                    },
                    hover: {
                        "fill-opacity": 1
                    }
                },
                markerStyle: {
                    initial: {
                        fill: '#fff',
                        stroke: '#1f77b4'
                    },
                    hover: {
                        fill: '#13476c',
                        stroke: '#13476c'
                    }
                },
                markers: [
                    { latLng: [41.90, 12.45], name: 'Vatican City' },
                    { latLng: [43.73, 7.41], name: 'Monaco' },
                    { latLng: [-0.52, 166.93], name: 'Nauru' },
                    { latLng: [-8.51, 179.21], name: 'Tuvalu' },
                    { latLng: [43.93, 12.46], name: 'San Marino' },
                    { latLng: [47.14, 9.52], name: 'Liechtenstein' },
                    { latLng: [7.11, 171.06], name: 'Marshall Islands' },
                    { latLng: [17.3, -62.73], name: 'Saint Kitts and Nevis' },
                    { latLng: [3.2, 73.22], name: 'Maldives' },
                    { latLng: [35.88, 14.5], name: 'Malta' },
                    { latLng: [12.05, -61.75], name: 'Grenada' },
                    { latLng: [13.16, -61.23], name: 'Saint Vincent and the Grenadines' },
                    { latLng: [13.16, -59.55], name: 'Barbados' },
                    { latLng: [17.11, -61.85], name: 'Antigua and Barbuda' },
                    { latLng: [-4.61, 55.45], name: 'Seychelles' },
                    { latLng: [7.35, 134.46], name: 'Palau' },
                    { latLng: [42.5, 1.51], name: 'Andorra' },
                    { latLng: [14.01, -60.98], name: 'Saint Lucia' },
                    { latLng: [6.91, 158.18], name: 'Federated States of Micronesia' },
                    { latLng: [1.3, 103.8], name: 'Singapore' },
                    { latLng: [1.46, 173.03], name: 'Kiribati' },
                    { latLng: [-21.13, -175.2], name: 'Tonga' },
                    { latLng: [15.3, -61.38], name: 'Dominica' },
                    { latLng: [-20.2, 57.5], name: 'Mauritius' },
                    { latLng: [26.02, 50.55], name: 'Bahrain' },
                    { latLng: [0.33, 6.73], name: 'São Tomé and Príncipe' }
                ]
            });

        }
    ])
    ;
    //#endregion UNUSED CONTROLLERS
